package com.telecom.tdp.service.cluster.impl;

package ..deTemp.1730875095060;

import cn.hutool.core.io.FileUtil;
import com.alibaba.fastjson2.JSONObject;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.google.common.collect.ImmutableList;
import com.google.common.collect.ImmutableMap;
import com.google.common.collect.Iterables;
import com.google.common.collect.Lists;
import com.google.common.collect.MapDifference;
import com.google.common.collect.Maps;
import com.google.common.collect.Sets;
import com.telecom.tdp.annotation.LogDisplay;
import com.telecom.tdp.cache.ClusterInstanceMonitorCache;
import com.telecom.tdp.cache.HostRuntimeStatusHandler;
import com.telecom.tdp.cache.vo.InstanceMonitorVO;
import com.telecom.tdp.client.PrometheusClient;
import com.telecom.tdp.client.TdpHttpClient;
import com.telecom.tdp.convert.RoleNameConvert;
import com.telecom.tdp.dao.ClusterConfigGroupDao;
import com.telecom.tdp.dao.ClusterConfigGroupHostDao;
import com.telecom.tdp.dao.ClusterConfigStatusDao;
import com.telecom.tdp.dao.ClusterConfigVersionDao;
import com.telecom.tdp.dao.ClusterEnvDao;
import com.telecom.tdp.dao.ClusterInstanceDao;
import com.telecom.tdp.dao.ClusterInstanceUIDao;
import com.telecom.tdp.dao.ClusterOperateButtonDao;
import com.telecom.tdp.dao.ClusterOperateStepDao;
import com.telecom.tdp.dao.ComponentRoleDao;
import com.telecom.tdp.dao.ComponentRoleInstanceDao;
import com.telecom.tdp.dao.ComponentRoleInstanceHostDao;
import com.telecom.tdp.dao.ComponentRoleInstanceHostStatusDao;
import com.telecom.tdp.dao.ComponentTypeDao;
import com.telecom.tdp.dao.ComponentTypeDependenciesDao;
import com.telecom.tdp.dao.ComponentTypeInstanceDao;
import com.telecom.tdp.dao.ComponentTypeVersionDao;
import com.telecom.tdp.dao.EnvInfoDao;
import com.telecom.tdp.dao.HostConfigDao;
import com.telecom.tdp.dao.HostDao;
import com.telecom.tdp.dao.TaskDao;
import com.telecom.tdp.dao.base.ClusterConfigGroupHostMapper;
import com.telecom.tdp.dao.base.ClusterConfigGroupMapper;
import com.telecom.tdp.dao.base.ClusterConfigMapper;
import com.telecom.tdp.dao.base.ClusterConfigVersionMapper;
import com.telecom.tdp.dao.base.ComponentRoleInstanceHostMapper;
import com.telecom.tdp.dao.base.ComponentRoleInstanceMapper;
import com.telecom.tdp.dao.vo.AuditLogOperateVo;
import com.telecom.tdp.dao.vo.HostExpansionVO;
import com.telecom.tdp.dao.vo.HostSearchVO;
import com.telecom.tdp.dao.vo.HostShrinkClusterVO;
import com.telecom.tdp.dto.ComponentRoleInstanceAndHost;
import com.telecom.tdp.dto.cluster.ClusterInstanceAndComponentTypeDTO;
import com.telecom.tdp.dto.cluster.ClusterInstanceCreateDTO;
import com.telecom.tdp.dto.cluster.ClusterInstanceUiDTO;
import com.telecom.tdp.dto.cluster.TdpOperateLogDTO;
import com.telecom.tdp.dto.command.ClusterInstanceOperateCommand;
import com.telecom.tdp.dto.command.MigrateOperateCommand;
import com.telecom.tdp.dto.command.UpgradeDetermineCommand;
import com.telecom.tdp.dto.command.monitor.MonitorClusterCommand;
import com.telecom.tdp.dto.instance.TaskPIDDTO;
import com.telecom.tdp.dto.inventory.Inventory;
import com.telecom.tdp.dto.inventory.InventoryGroup;
import com.telecom.tdp.dto.inventory.InventoryHost;
import com.telecom.tdp.dto.open.req.ConfigPublishReq;
import com.telecom.tdp.dto.query.HostExpansionShrinkQuery;
import com.telecom.tdp.dto.query.InitConfigClusterInstanceQuery;
import com.telecom.tdp.dto.query.MigrateVerifyQuery;
import com.telecom.tdp.dto.query.TerminateMissionQuery;
import com.telecom.tdp.dto.req.AddConfigGroupClusterInstanceReq;
import com.telecom.tdp.dto.req.AsyncClusterInstanceOperateReq;
import com.telecom.tdp.dto.req.BasicInformationReq;
import com.telecom.tdp.dto.req.BatchManageRoleAndHostReq;
import com.telecom.tdp.dto.req.CreateClusterInstanceReq;
import com.telecom.tdp.dto.req.DeleteClusterInstanceConfigReq;
import com.telecom.tdp.dto.req.DeleteClusterInstanceReq;
import com.telecom.tdp.dto.req.DeleteConfigGroupClusterInstanceReq;
import com.telecom.tdp.dto.req.DeleteRoleAndHostReq;
import com.telecom.tdp.dto.req.HostExpansionSaveReq;
import com.telecom.tdp.dto.req.HostShrinkSaveReq;
import com.telecom.tdp.dto.req.ManageRoleAndHostReq;
import com.telecom.tdp.dto.req.OperationInformation;
import com.telecom.tdp.dto.req.PublishClusterInstanceConfigReq;
import com.telecom.tdp.dto.req.RenameConfigGroupClusterInstanceReq;
import com.telecom.tdp.dto.req.RollBackClusterInstanceConfigCheckReq;
import com.telecom.tdp.dto.req.RollBackClusterInstanceConfigReq;
import com.telecom.tdp.dto.req.SaveClusterInstanceConfigReq;
import com.telecom.tdp.dto.req.SaveInventoryReq;
import com.telecom.tdp.dto.req.SaveVarsReq;
import com.telecom.tdp.dto.req.SyncButtonReq;
import com.telecom.tdp.dto.req.SyncConfigReq;
import com.telecom.tdp.dto.req.TransformConfigGroupClusterInstanceReq;
import com.telecom.tdp.dto.req.TypeSelectClusterInstanceReq;
import com.telecom.tdp.dto.req.UpdateClusterInstanceReq;
import com.telecom.tdp.dto.req.UpdateRoleAndHostReq;
import com.telecom.tdp.dto.req.UpgradeComponentTypeCheckReq;
import com.telecom.tdp.dto.req.UpgradeComponentTypeReq;
import com.telecom.tdp.enums.CacheTypeEnum;
import com.telecom.tdp.enums.ClusterButtonBelongEnum;
import com.telecom.tdp.enums.ClusterInstanceOperateEnum;
import com.telecom.tdp.enums.ClusterOperateButtonOnlineEnum;
import com.telecom.tdp.enums.ClusterOperateStepEnum;
import com.telecom.tdp.enums.ClusterOperateStepStatusEnum;
import com.telecom.tdp.enums.ClusterOperateTypeEnum;
import com.telecom.tdp.enums.ClusterTaskStatusEnum;
import com.telecom.tdp.enums.CollectionEqualEnum;
import com.telecom.tdp.enums.ComponentTypeBindEnum;
import com.telecom.tdp.enums.ComponentTypeEnum;
import com.telecom.tdp.enums.ConfigTakeAffectStateEnum;
import com.telecom.tdp.enums.ConfigVersionOnlineEnum;
import com.telecom.tdp.enums.HostRuntimeStatusEnum;
import com.telecom.tdp.enums.HostSelectedStatusEnum;
import com.telecom.tdp.enums.HostStatusEnum;
import com.telecom.tdp.enums.InstanceStatusEnum;
import com.telecom.tdp.enums.LogDisplayContentEnum;
import com.telecom.tdp.enums.LogDisplayEnum;
import com.telecom.tdp.enums.ProjectModuleEnum;
import com.telecom.tdp.enums.TaskStatusEnum;
import com.telecom.tdp.enums.TypeEnum;
import com.telecom.tdp.exception.ClusterConfigException;
import com.telecom.tdp.exception.ClusterEnvException;
import com.telecom.tdp.exception.ClusterInstanceException;
import com.telecom.tdp.exception.ComponentRoleException;
import com.telecom.tdp.exception.ComponentTypeException;
import com.telecom.tdp.exception.HostException;
import com.telecom.tdp.exception.ValidationException;
import com.telecom.tdp.mapper.TdpClusterInstanceMapper;
import com.telecom.tdp.mapper.TdpComponentRoleInstanceMapper;
import com.telecom.tdp.model.TdpClusterConfig;
import com.telecom.tdp.model.TdpClusterConfigGroup;
import com.telecom.tdp.model.TdpClusterConfigGroupHost;
import com.telecom.tdp.model.TdpClusterConfigStatus;
import com.telecom.tdp.model.TdpClusterConfigVersion;
import com.telecom.tdp.model.TdpClusterEnv;
import com.telecom.tdp.model.TdpClusterInstance;
import com.telecom.tdp.model.TdpClusterInstanceUi;
import com.telecom.tdp.model.TdpClusterOperateButton;
import com.telecom.tdp.model.TdpClusterOperateStep;
import com.telecom.tdp.model.TdpComponentRole;
import com.telecom.tdp.model.TdpComponentRoleInstance;
import com.telecom.tdp.model.TdpComponentRoleInstanceHost;
import com.telecom.tdp.model.TdpComponentRoleInstanceHostStatus;
import com.telecom.tdp.model.TdpComponentType;
import com.telecom.tdp.model.TdpComponentTypeInstance;
import com.telecom.tdp.model.TdpHost;
import com.telecom.tdp.model.TdpHostConfig;
import com.telecom.tdp.model.TdpTask;
import com.telecom.tdp.rmi.ClusterEnvRmi;
import com.telecom.tdp.rmi.ClusterInstanceRmi;
import com.telecom.tdp.rmi.bean.ClusterConfig;
import com.telecom.tdp.rmi.bean.ClusterConfigFile;
import com.telecom.tdp.rmi.bean.ClusterInstanceOperateConfig;
import com.telecom.tdp.rmi.bean.LogData;
import com.telecom.tdp.rmi.bean.PublishConfig;
import com.telecom.tdp.service.AuditLogService;
import com.telecom.tdp.service.ClusterConfigService;
import com.telecom.tdp.service.ComponentRoleInstanceHostService;
import com.telecom.tdp.service.ComponentRoleService;
import com.telecom.tdp.service.ComponentTypeService;
import com.telecom.tdp.service.HostService;
import com.telecom.tdp.service.JwtService;
import com.telecom.tdp.service.OperateLogService;
import com.telecom.tdp.service.PrivilegeService;
import com.telecom.tdp.service.RmiService;
import com.telecom.tdp.service.RoleMigratesService;
import com.telecom.tdp.service.TaskService;
import com.telecom.tdp.service.cluster.ClusterInstanceService;
import com.telecom.tdp.service.cluster.OperateClusterInstanceJavaService;
import com.telecom.tdp.service.host.HostDetailService;
import com.telecom.tdp.service.monitor.MonitorService;
import com.telecom.tdp.service.remote.MetaManagerService;
import com.telecom.tdp.util.AuthUtil;
import com.telecom.tdp.util.CacheUtil;
import com.telecom.tdp.util.ConfigVersionUtil;
import com.telecom.tdp.util.HostUtil;
import com.telecom.tdp.util.IniUtil;
import com.telecom.tdp.util.InventoryUtil;
import com.telecom.tdp.util.JsonUtil;
import com.telecom.tdp.util.UserUtil;
import com.telecom.tdp.util.VarsUtil;
import com.telecom.tdp.vo.ClusterComponentRoleInstanceVo;
import com.telecom.tdp.vo.ClusterConfigVersionAndGroupVo;
import com.telecom.tdp.vo.ClusterInstanceConfigGroupHostVo;
import com.telecom.tdp.vo.ClusterInstanceConfigGroupVo;
import com.telecom.tdp.vo.ClusterInstanceConfigKeyValueVo;
import com.telecom.tdp.vo.ClusterInstanceServiceVo;
import com.telecom.tdp.vo.ComponentTypeSelectVo;
import com.telecom.tdp.vo.HostExpansionVo;
import com.telecom.tdp.vo.HostShrinkVo;
import com.telecom.tdp.vo.PageVo;
import com.telecom.tdp.vo.RoleAndHostVo;
import com.telecom.tdp.vo.TaskPIDVO;
import com.telecom.tdp.vo.TdpComponentRoleInstanceHostCount;
import com.telecom.tdp.vo.UserDetailsVo;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.lang.invoke.SerializedLambda;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.Set;
import java.util.UUID;
import java.util.function.Function;
import java.util.stream.Collectors;
import javax.servlet.http.HttpServletRequest;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.tuple.ImmutablePair;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.slf4j.MDC;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Lazy;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;
import org.springframework.util.ObjectUtils;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;
import org.springframework.web.multipart.MultipartFile;

@Service
public class ClusterInstanceServiceImpl implements ClusterInstanceService {
  private static final Logger log = LoggerFactory.getLogger(com.telecom.tdp.service.cluster.impl.ClusterInstanceServiceImpl.class);
  
  @Autowired
  private ComponentRoleInstanceHostStatusDao componentRoleInstanceHostStatusDao;
  
  @Autowired
  private HostConfigDao hostConfigDao;
  
  @Autowired
  private ClusterEnvDao clusterEnvDao;
  
  @Autowired
  private HostDao hostDao;
  
  @Autowired
  private ClusterConfigVersionMapper clusterConfigVersionMapper;
  
  @Autowired
  private ClusterConfigService clusterConfigService;
  
  @Autowired
  private ComponentTypeService componentTypeService;
  
  @Autowired
  private ComponentRoleService componentRoleService;
  
  @Autowired
  private PrivilegeService privilegeService;
  
  @Autowired
  @Lazy
  private HostService hostService;
  
  @Autowired
  private TaskService taskService;
  
  @Autowired
  private ComponentTypeInstanceDao componentTypeInstanceDao;
  
  @Autowired
  private ComponentRoleInstanceHostDao componentRoleInstanceHostDao;
  
  @Autowired
  private ComponentRoleInstanceHostService componentRoleInstanceHostService;
  
  @Autowired
  private PrometheusClient prometheusClient;
  
  @Autowired
  private TdpClusterInstanceMapper tdpClusterInstanceMapper;
  
  @Autowired
  private ClusterConfigGroupMapper clusterConfigGroupMapper;
  
  @Autowired
  private ClusterConfigGroupHostMapper clusterConfigGroupHostMapper;
  
  @Autowired
  private ClusterConfigMapper clusterConfigMapper;
  
  @Autowired
  private TdpComponentRoleInstanceMapper tdpComponentRoleInstanceMapper;
  
  @Autowired
  private RmiService rmiService;
  
  @Autowired
  private ClusterInstanceDao clusterInstanceDao;
  
  @Autowired
  private ComponentRoleInstanceDao componentRoleInstanceDao;
  
  @Autowired
  private ClusterConfigStatusDao clusterConfigStatusDao;
  
  @Autowired
  private ClusterOperateButtonDao clusterOperateButtonDao;
  
  @Autowired
  private MetaManagerService metaManagerService;
  
  @Autowired
  private ComponentTypeDao componentTypeDao;
  
  @Autowired
  private ComponentRoleDao componentRoleDao;
  
  @Autowired
  private OperateClusterInstanceJavaService operateClusterInstanceJavaService;
  
  @Autowired
  private ClusterConfigVersionDao clusterConfigVersionDao;
  
  @Autowired
  private ClusterConfigGroupHostDao clusterConfigGroupHostDao;
  
  @Autowired
  private ClusterOperateStepDao clusterOperateStepDao;
  
  @Autowired
  private AuditLogService auditLogService;
  
  @Autowired
  private ClusterInstanceUIDao clusterInstanceUIDao;
  
  @Autowired
  private HostRuntimeStatusHandler hostRuntimeStatusHandler;
  
  @Autowired
  private ClusterConfigGroupDao clusterConfigGroupDao;
  
  @Autowired
  private RoleMigratesService roleMigratesService;
  
  @Autowired
  private ComponentTypeVersionDao componentTypeVersionDao;
  
  @Autowired
  private TaskDao taskDao;
  
  @Autowired
  private OperateLogService operateLogService;
  
  @Autowired
  private MonitorService monitorService;
  
  @Autowired
  private EnvInfoDao envInfoDao;
  
  @Value("${tdp.host.config.callback.ui}")
  private String callback;
  
  @Value("${tdp.host.openapi}")
  private String callbackUrl;
  
  @Autowired
  private ClusterInstanceService clusterInstanceService;
  
  @Autowired
  private JwtService jwtService;
  
  @Autowired
  private TdpHttpClient httpClient;
  
  @Autowired
  private ComponentTypeDependenciesDao componentTypeDependenciesDao;
  
  @Autowired
  private HostDetailService hostDetailService;
  
  @Autowired
  private ComponentRoleInstanceMapper componentRoleInstanceMapper;
  
  @Autowired
  private ComponentRoleInstanceHostMapper componentRoleInstanceHostMapper;
  
  @Autowired
  private ClusterInstanceMonitorCache clusterInstanceMonitorCache;
  
  public TdpClusterInstanceMapper getTdpClusterInstanceMapper() {
    return this.tdpClusterInstanceMapper;
  }
  
  public List<TdpClusterInstance> searchClusterInstanceInEnv(Integer envId) {
    return this.clusterInstanceDao.getByClusterEnvId(envId);
  }
  
  public TdpClusterInstance selectTdpClusterInstanceById(Integer clusterInstanceId) {
    return this.clusterInstanceDao.getById(clusterInstanceId);
  }
  
  public String getInstanceNameEn(CreateClusterInstanceReq createClusterInstanceReq) {
    TdpComponentType componentType = this.componentTypeDao.getById(createClusterInstanceReq.getComponentTypeId());
    if (componentType == null || componentType.getName() == null || componentType.getName().isEmpty())
      return ""; 
    return componentType.getName() + createClusterInstanceReq.getClusterEnvId();
  }
  
  public String validateType(Integer clusterEnvId, Integer componentTypeId) {
    TdpComponentType componentType = this.componentTypeDao.getById(componentTypeId);
    List<Integer> clusterInstancesIds = this.clusterInstanceDao.getByEnvId(clusterEnvId);
    if (CollectionUtils.isNotEmpty(clusterInstancesIds)) {
      List<TdpComponentTypeInstance> componentTypeInstance = this.componentTypeInstanceDao.getByClusterInstanceIds(clusterInstancesIds);
      if (CollectionUtils.isNotEmpty(componentTypeInstance)) {
        for (TdpComponentTypeInstance typeInstance : componentTypeInstance)
          ValidationException.validate(!typeInstance.getComponentTypeId().equals(componentTypeId), "该环境下已经存在类型为" + componentType.getName() + "的集群"); 
      } else {
        throw new ClusterEnvException("该环境下未找到对应的集群类型");
      } 
    } 
    return componentType.getName();
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public ClusterInstanceCreateDTO createClusterInstance(CreateClusterInstanceReq createClusterInstanceReq) {
    AuthUtil.checkEnvOperateAuth(createClusterInstanceReq.getClusterEnvId());
    Integer deployType = createClusterInstanceReq.getDeployType();
    Integer componentTypeId = createClusterInstanceReq.getComponentTypeId();
    checkDeployType(deployType, componentTypeId);
    String nameEn = getInstanceNameEn(createClusterInstanceReq);
    createClusterInstanceReq.setNameEn(nameEn);
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE);
    auditLogOperateVo.setOperateContent(LogDisplayContentEnum.ADD);
    auditLogOperateVo.setOperateClusterEnvId(createClusterInstanceReq.getClusterEnvId());
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    TdpClusterEnv clusterEnv = this.clusterEnvDao.getById(createClusterInstanceReq.getClusterEnvId());
    if (clusterEnv == null) {
      String message = String.format("集群环境 %s 不存在", new Object[] { createClusterInstanceReq.getClusterEnvId() });
      log.error(message);
      throw new ClusterEnvException(message);
    } 
    if (isExists(createClusterInstanceReq.getClusterEnvId(), createClusterInstanceReq
        .getNameEn())) {
      String message = String.format("集群实例 %s 已经存在", new Object[] { createClusterInstanceReq.getNameEn() });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    String componentTypeName = validateType(createClusterInstanceReq.getClusterEnvId(), createClusterInstanceReq.getComponentTypeId());
    TdpClusterInstance tdpClusterInstance = new TdpClusterInstance();
    tdpClusterInstance.setClusterEnvId(createClusterInstanceReq.getClusterEnvId());
    tdpClusterInstance.setNameEn(createClusterInstanceReq.getNameEn());
    tdpClusterInstance.setNameZh(createClusterInstanceReq.getNameZh());
    tdpClusterInstance.setRemark(createClusterInstanceReq.getRemark());
    tdpClusterInstance.setDeployType(createClusterInstanceReq.getDeployType());
    tdpClusterInstance.setCreateTime(new Date());
    tdpClusterInstance.setUpdateTime(new Date());
    String uuid = UUID.randomUUID().toString().replace("-", "");
    tdpClusterInstance.setUuid(uuid);
    this.clusterInstanceDao.insert(tdpClusterInstance);
    TypeSelectClusterInstanceReq typeSelectClusterInstanceReq = new TypeSelectClusterInstanceReq();
    typeSelectClusterInstanceReq.setClusterInstanceId(tdpClusterInstance.getId());
    typeSelectClusterInstanceReq.setComponentTypeId(createClusterInstanceReq.getComponentTypeId());
    typeSelectClusterInstanceReq.setComponentTypeVersion(createClusterInstanceReq.getComponentTypeVersion());
    typeSelectClusterInstance(typeSelectClusterInstanceReq);
    initOperateButton(tdpClusterInstance.getId());
    ClusterInstanceCreateDTO clusterInstanceCreateDTO = new ClusterInstanceCreateDTO();
    BeanUtils.copyProperties(tdpClusterInstance, clusterInstanceCreateDTO);
    clusterInstanceCreateDTO.setComponentType(componentTypeName);
    return clusterInstanceCreateDTO;
  }
  
  private void checkDeployType(Integer deployType, Integer componentTypeId) {
    Integer componentTypeDeployType = this.componentTypeDao.getDeployType(componentTypeId);
    if (!deployType.equals(componentTypeDeployType)) {
      String message = String.format("部署方式和组件不一致", new Object[0]);
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
  }
  
  public void initOperateButton(Integer clusterInstanceId) {
    List<ClusterOperateTypeEnum> collect = (List<ClusterOperateTypeEnum>)Arrays.<ClusterOperateTypeEnum>stream(ClusterOperateTypeEnum.values()).filter(item -> !ClusterButtonBelongEnum.CLUSTER_CONFIG.getCode().equals(item.getBelong())).collect(Collectors.toList());
    List<TdpClusterOperateButton> list = Lists.newArrayList();
    for (ClusterOperateTypeEnum clusterOperateTypeEnum : collect) {
      TdpClusterOperateButton button = new TdpClusterOperateButton();
      button.setHidden(Boolean.FALSE);
      button.setButtonCode(clusterOperateTypeEnum.getName());
      button.setClusterInstanceId(clusterInstanceId);
      button.setDisplayNum(clusterOperateTypeEnum.getIndex());
      button.setCreateTime(new Date());
      button.setUpdateTime(new Date());
      list.add(button);
    } 
    this.clusterOperateButtonDao.saveBatch(list);
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public TdpClusterInstance updateClusterInstance(UpdateClusterInstanceReq updateClusterInstanceReq) {
    Integer clusterEnvId = updateClusterInstanceReq.getClusterEnvId();
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE);
    auditLogOperateVo.setOperateContent(LogDisplayContentEnum.UPDATE);
    auditLogOperateVo.setOperateClusterEnvId(clusterEnvId);
    auditLogOperateVo.setOperateClusterInstanceId(updateClusterInstanceReq.getClusterInstanceId());
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    updateClusterInstanceReq.validate();
    checkInstanceAuth(updateClusterInstanceReq.getClusterInstanceId());
    TdpClusterInstance tdpClusterInstance = new TdpClusterInstance();
    BeanUtils.copyProperties(updateClusterInstanceReq, tdpClusterInstance);
    tdpClusterInstance.setId(updateClusterInstanceReq.getClusterInstanceId());
    tdpClusterInstance.setUpdateTime(new Date());
    this.clusterInstanceDao.update(tdpClusterInstance);
    refreshInventoryAndVars(updateClusterInstanceReq.getClusterInstanceId());
    return this.clusterInstanceDao.getById(updateClusterInstanceReq.getClusterInstanceId());
  }
  
  private void checkInstanceAuth(Integer instanceId) {
    TdpClusterInstance instance = this.clusterInstanceDao.getById(instanceId);
    if (instance == null) {
      String message = String.format("集群实例 %s 不存在", new Object[] { instanceId });
      throw new ValidationException(message);
    } 
    AuthUtil.checkEnvOperateAuth(instance.getClusterEnvId());
  }
  
  @LogDisplay
  public PageVo<ClusterInstanceAndComponentTypeDTO> searchClusterInstance(Integer clusterEnvId, String clusterInstanceName, Integer current, Integer size) {
    AuthUtil.checkEnvReadAuth(clusterEnvId);
    PageVo<ClusterInstanceAndComponentTypeDTO> pageVo = new PageVo();
    List<Integer> userEnvIdList = this.privilegeService.selectUserEnvId();
    ValidationException.validate(CollectionUtils.isNotEmpty(userEnvIdList), "用户没有权限，请联系管理员");
    PageHelper.startPage(current.intValue(), size.intValue());
    List<TdpClusterInstance> tdpClusterInstances = this.clusterInstanceDao.searchClusterInstances(clusterEnvId, clusterInstanceName, userEnvIdList);
    PageInfo<TdpClusterInstance> pageInfo = new PageInfo(tdpClusterInstances);
    if (CollectionUtils.isEmpty(tdpClusterInstances))
      return pageVo; 
    Set<Integer> envIds = (Set<Integer>)tdpClusterInstances.stream().map(TdpClusterInstance::getClusterEnvId).collect(Collectors.toSet());
    Map<Integer, TdpClusterEnv> clusterEnvMap = (Map<Integer, TdpClusterEnv>)this.clusterEnvDao.selectClusterEnv(null, Lists.newArrayList(envIds)).stream().collect(Collectors.toMap(TdpClusterEnv::getId, Function.identity()));
    List<Integer> instanceIds = (List<Integer>)tdpClusterInstances.stream().map(TdpClusterInstance::getId).collect(Collectors.toList());
    List<TdpComponentTypeInstance> tdpComponentTypeInstances = this.componentTypeInstanceDao.listByClusterInstanceId(instanceIds);
    List<Integer> componentIds = (List<Integer>)tdpComponentTypeInstances.stream().filter(item -> Objects.nonNull(item.getComponentTypeId())).map(TdpComponentTypeInstance::getComponentTypeId).collect(Collectors.toList());
    List<TdpComponentType> componentTypes = this.componentTypeDao.listComponentTypesByIds(componentIds);
    Map<Integer, TdpComponentType> componentTypeMap = (Map<Integer, TdpComponentType>)componentTypes.stream().collect(Collectors.toMap(TdpComponentType::getId, Function.identity(), (e1, e2) -> e1));
    Map<Integer, TdpComponentTypeInstance> veisonMap = (Map<Integer, TdpComponentTypeInstance>)tdpComponentTypeInstances.stream().collect(Collectors.toMap(TdpComponentTypeInstance::getClusterInstanceId, Function.identity(), (e1, e2) -> e1));
    Map<Integer, Integer> instanceComponentMap = new HashMap<>();
    for (TdpComponentTypeInstance tdpComponentTypeInstance : tdpComponentTypeInstances)
      instanceComponentMap.put(tdpComponentTypeInstance.getClusterInstanceId(), tdpComponentTypeInstance.getComponentTypeId()); 
    List<ClusterInstanceAndComponentTypeDTO> dtoList = new ArrayList<>();
    for (TdpClusterInstance tdpClusterInstance : tdpClusterInstances) {
      String componentType;
      ClusterInstanceAndComponentTypeDTO clusterInstanceDTO = new ClusterInstanceAndComponentTypeDTO();
      BeanUtils.copyProperties(tdpClusterInstance, clusterInstanceDTO);
      String clusterEnvName = ((TdpClusterEnv)clusterEnvMap.get(tdpClusterInstance.getClusterEnvId())).getName();
      Integer componentTypeId = instanceComponentMap.get(tdpClusterInstance.getId());
      TdpComponentType tdpComponentType = componentTypeMap.get(componentTypeId);
      TdpComponentTypeInstance tdpComponentTypeInstance = veisonMap.get(tdpClusterInstance.getId());
      if (tdpComponentTypeInstance != null) {
        String componentTypeVersion = tdpComponentTypeInstance.getComponentTypeVersion();
        clusterInstanceDTO.setComponentTypeVersion(componentTypeVersion);
      } 
      String typeNameByClusterInstanceId = (tdpComponentType == null) ? "" : tdpComponentType.getName();
      if (ComponentTypeEnum.JAVA.getCode().equalsIgnoreCase(typeNameByClusterInstanceId)) {
        componentType = ComponentTypeEnum.JAVA.getCode();
      } else {
        componentType = ComponentTypeEnum.BIGDATA.getCode();
      } 
      if (componentTypeId != null) {
        TdpComponentType componentTypeById = this.componentTypeDao.getById(componentTypeId);
        Boolean upgrade = componentTypeById.getUpgrade();
        clusterInstanceDTO.setUpgrade(upgrade);
      } 
      clusterInstanceDTO.setClusterEnvName(clusterEnvName);
      clusterInstanceDTO.setTypeId(componentTypeId);
      clusterInstanceDTO.setComponentType(componentType);
      clusterInstanceDTO.setShowOnline(tdpClusterInstance.getOnlineStatus());
      if (tdpComponentType != null)
        clusterInstanceDTO.setComponentTypeName(tdpComponentType.getName()); 
      clusterInstanceDTO.setDeployType(tdpClusterInstance.getDeployType());
      getMonitorStatus(clusterInstanceDTO, tdpClusterInstance);
      dtoList.add(clusterInstanceDTO);
    } 
    fillHostNumAndRoleNum(dtoList);
    pageVo.setTotal(pageInfo.getTotal());
    pageVo.setData(dtoList);
    pageVo.setPageNum(pageInfo.getPageNum());
    pageVo.setPageSize(pageInfo.getPageSize());
    pageVo.setSize(dtoList.size());
    return pageVo;
  }
  
  private void getMonitorStatus(ClusterInstanceAndComponentTypeDTO clusterInstanceDTO, TdpClusterInstance tdpClusterInstance) {
    if (!InstanceStatusEnum.RUNNING.getCode().equals(clusterInstanceDTO.getInstanceStatus())) {
      clusterInstanceDTO.setRunningStatus(InstanceStatusEnum.STOPED.getCode());
      return;
    } 
    clusterInstanceDTO.setRunningStatus(InstanceStatusEnum.RUNNING.getCode());
    String monitorStatus = this.clusterInstanceMonitorCache.getClusterInstanceMonitorStatus(tdpClusterInstance.getClusterEnvId(), tdpClusterInstance.getId());
    if (StringUtils.isNotEmpty(monitorStatus))
      clusterInstanceDTO.setInstanceStatus(monitorStatus); 
    if (InstanceStatusEnum.NORMAL.getCode().equals(monitorStatus))
      clusterInstanceDTO.setInstanceStatus(InstanceStatusEnum.RUNNING.getCode()); 
  }
  
  public void clusterOperateButtonUpOffLine(Integer clusterEnvId, Integer clusterInstanceId, String flag) {
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE);
    auditLogOperateVo.setOperateContent(LogDisplayContentEnum.UPOFFLINE);
    auditLogOperateVo.setOperateClusterEnvId(clusterEnvId);
    auditLogOperateVo.setOperateClusterInstanceId(clusterInstanceId);
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    checkInstanceAuth(clusterInstanceId);
    ClusterOperateButtonOnlineEnum buttonOnlineEnum = ClusterOperateButtonOnlineEnum.getBycode(flag);
    if (ClusterOperateButtonOnlineEnum.ONLINE.getCode().equals(buttonOnlineEnum.getCode())) {
      hiddenButton(clusterInstanceId);
      TdpClusterInstance tdpClusterInstance = new TdpClusterInstance();
      tdpClusterInstance.setId(clusterInstanceId);
      tdpClusterInstance.setOnlineStatus(ClusterOperateButtonOnlineEnum.ONLINE.getStatus());
      this.clusterInstanceDao.update(tdpClusterInstance);
    } 
    if (ClusterOperateButtonOnlineEnum.OFFLINE.getCode().equals(buttonOnlineEnum.getCode())) {
      showButton(clusterInstanceId);
      TdpClusterInstance tdpClusterInstance = new TdpClusterInstance();
      tdpClusterInstance.setId(clusterInstanceId);
      tdpClusterInstance.setOnlineStatus(ClusterOperateButtonOnlineEnum.OFFLINE.getStatus());
      this.clusterInstanceDao.update(tdpClusterInstance);
    } 
  }
  
  @Transactional
  public String uploadFile(MultipartFile file, Integer clusterInstanceId) {
    TdpClusterInstance tdpClusterInstance = this.clusterInstanceDao.getById(clusterInstanceId);
    TdpClusterEnv tdpClusterEnv = this.clusterEnvDao.getById(tdpClusterInstance.getClusterEnvId());
    AuthUtil.checkEnvOperateAuth(tdpClusterEnv.getId());
    ValidationException.validate(!file.isEmpty(), "文件不能为空");
    ValidationException.validate(StringUtils.isNotEmpty(file.getOriginalFilename()), "文件名为空");
    ValidationException.validate((StringUtils.endsWith(file.getOriginalFilename(), ".jar") || StringUtils.endsWith(file.getOriginalFilename(), ".tar")), "无效的文件格式。上传的文件必须是.jar/.tar文件！");
    ValidationException.validate((file.getSize() <= 1073741824L), "文件大小超过1GB，请检查后上传");
    String filePath = "/tmp/TDP/jar" + File.separator + clusterInstanceId;
    log.info("存放jar包的位置是:{}", filePath);
    String absolutePath = filePath + File.separator + file.getOriginalFilename();
    try {
      File directory = new File(filePath);
      if (!directory.exists())
        directory.mkdirs(); 
      File[] files = directory.listFiles();
      if (files != null)
        for (File f : files)
          f.delete();  
      InputStream inputStream = file.getInputStream();
      long size = file.getSize();
      String s = inputStream.toString();
      log.info("文件内容:", s);
      log.info("文件大小是", Long.valueOf(size));
      FileUtil.writeFromStream(file.getInputStream(), new File(absolutePath));
      TdpComponentTypeInstance tdpComponentTypeInstance = new TdpComponentTypeInstance();
      TdpComponentTypeInstance componentTypeInstance = this.componentTypeInstanceDao.getByClusterInstanceId(clusterInstanceId);
      ValidationException.validate(!ObjectUtils.isEmpty(componentTypeInstance), "传输错误，请新增集群实例！");
      tdpComponentTypeInstance.setClusterInstanceId(componentTypeInstance.getClusterInstanceId());
      tdpComponentTypeInstance.setComponentTypeId(componentTypeInstance.getComponentTypeId());
      tdpComponentTypeInstance.setJarPackage(absolutePath);
      Date date = new Date();
      tdpComponentTypeInstance.setUpdateTime(date);
      Boolean num = this.componentTypeInstanceDao.updateJarPackage(tdpComponentTypeInstance);
      saveOperateStep(clusterInstanceId, ClusterOperateStepEnum.UPLOAD_JAR.getStep(), ClusterOperateStepStatusEnum.DONE.getStatus());
      ClusterEnvRmi clusterEnvRmi = this.rmiService.getClusterEnvRmi(tdpClusterEnv.getId());
      (new Thread(() -> {
            try {
              clusterEnvRmi.copyFile(filePath, new File(absolutePath));
            } catch (RemoteException e) {
              log.error("远程拷贝文件失败", e);
            } 
          })).start();
      if (Boolean.TRUE.equals(num))
        return file.getOriginalFilename(); 
    } catch (IOException e) {
      log.error("文件上传失败", e);
      saveOperateStep(clusterInstanceId, ClusterOperateStepEnum.UPLOAD_JAR.getStep(), ClusterOperateStepStatusEnum.RUNNING.getStatus());
    } 
    throw new RuntimeException("文件上传失败");
  }
  
  public String searchFile(Integer clusterInstanceId) {
    AuthUtil.checkInstanceReadAuth(clusterInstanceId);
    ValidationException.validate(!ObjectUtils.isEmpty(clusterInstanceId), "未传入有效clusterInstanceId!");
    TdpComponentTypeInstance componentTypeInstance = this.componentTypeInstanceDao.getByClusterInstanceId(clusterInstanceId);
    Integer componentTypeId = componentTypeInstance.getComponentTypeId();
    ValidationException.validate(!ObjectUtils.isEmpty(componentTypeId), "请新增组件类型进行绑定");
    if (StringUtils.isEmpty(componentTypeInstance.getJarPackage()))
      return ""; 
    String absolutePath = componentTypeInstance.getJarPackage();
    Path path = Paths.get(absolutePath, new String[0]);
    return path.getFileName().toString();
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public void deleteClusterInstance(DeleteClusterInstanceReq deleteClusterInstanceReq) {
    Integer clusterEnvId = deleteClusterInstanceReq.getClusterEnvId();
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE);
    auditLogOperateVo.setOperateContent(LogDisplayContentEnum.DELETE);
    auditLogOperateVo.setOperateClusterEnvId(clusterEnvId);
    auditLogOperateVo.setOperateClusterInstanceId(deleteClusterInstanceReq.getClusterInstanceId());
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    checkInstanceAuth(deleteClusterInstanceReq.getClusterInstanceId());
    this.clusterConfigService.deleteInstanceConfig(deleteClusterInstanceReq.getClusterInstanceId());
    LambdaQueryWrapper<TdpComponentTypeInstance> lambdaQueryWrapper = new LambdaQueryWrapper();
    lambdaQueryWrapper.eq(TdpComponentTypeInstance::getClusterInstanceId, deleteClusterInstanceReq.getClusterInstanceId());
    List<TdpComponentTypeInstance> tdpComponentTypeInstanceList = this.componentTypeInstanceDao.selectByExample(lambdaQueryWrapper);
    if (CollectionUtils.isEmpty(tdpComponentTypeInstanceList)) {
      TdpClusterInstance tdpClusterInstance = this.clusterInstanceDao.getById(deleteClusterInstanceReq.getClusterInstanceId());
      if (Objects.isNull(tdpClusterInstance))
        return; 
      this.clusterInstanceDao.deleteByPrimaryKey(deleteClusterInstanceReq.getClusterInstanceId());
    } else {
      TdpComponentTypeInstance tdpComponentTypeInstance = tdpComponentTypeInstanceList.get(0);
      LambdaQueryWrapper<TdpComponentRoleInstance> wrapper = new LambdaQueryWrapper();
      wrapper.eq(TdpComponentRoleInstance::getComponentTypeInstanceId, tdpComponentTypeInstance.getId());
      List<TdpComponentRoleInstance> tdpComponentRoleInstanceList = this.componentRoleInstanceMapper.list((Wrapper)wrapper);
      if (!CollectionUtils.isEmpty(tdpComponentRoleInstanceList)) {
        String message = "集群下存在角色不能删除!";
        throw new ClusterInstanceException(message);
      } 
      this.componentTypeInstanceDao.deleteByPrimaryKey(tdpComponentTypeInstance.getId());
      this.clusterInstanceDao.deleteByPrimaryKey(deleteClusterInstanceReq.getClusterInstanceId());
    } 
  }
  
  @LogDisplay
  public List<ClusterComponentRoleInstanceVo> searchRoleInstanceList(Integer clusterInstanceId) {
    checkInstanceEnvReadAuth(clusterInstanceId);
    List<ClusterComponentRoleInstanceVo> clusterComponentRoleInstanceVoList = this.tdpClusterInstanceMapper.searchRoleInstanceList(clusterInstanceId);
    List<TdpComponentRole> roleList = this.componentRoleService.getComponentRoleByClusterInstanceId(clusterInstanceId);
    Set<String> roleNames = (Set<String>)clusterComponentRoleInstanceVoList.stream().map(ClusterComponentRoleInstanceVo::getComponentRoleName).filter(Objects::nonNull).collect(Collectors.toSet());
    ClusterComponentRoleInstanceVo basicInfo = null;
    if (CollectionUtils.isNotEmpty(clusterComponentRoleInstanceVoList))
      basicInfo = clusterComponentRoleInstanceVoList.get(0); 
    List<ClusterComponentRoleInstanceVo> list = new ArrayList<>();
    for (TdpComponentRole componentRole : roleList) {
      if (!roleNames.contains(componentRole.getName())) {
        ClusterComponentRoleInstanceVo vo = new ClusterComponentRoleInstanceVo();
        vo.setComponentRoleHostNum(Integer.valueOf(0));
        vo.setComponentRoleInstanceId(clusterInstanceId);
        vo.setComponentRoleId(componentRole.getId() + "");
        vo.setComponentRoleName(componentRole.getName());
        if (basicInfo != null)
          vo.setComponentTypeName(basicInfo.getComponentTypeName()); 
        list.add(vo);
      } 
    } 
    clusterComponentRoleInstanceVoList.addAll(list);
    return clusterComponentRoleInstanceVoList;
  }
  
  @LogDisplay
  public ComponentTypeSelectVo checkTypeSelectChangeClusterInstance(Integer clusterInstanceId) {
    AuthUtil.checkInstanceReadAuth(clusterInstanceId);
    LambdaQueryWrapper<TdpComponentTypeInstance> lambdaQueryWrapper = new LambdaQueryWrapper();
    lambdaQueryWrapper.eq(TdpComponentTypeInstance::getClusterInstanceId, clusterInstanceId);
    TdpComponentTypeInstance tdpComponentTypeInstance = this.componentTypeInstanceDao.selectOneByExample(lambdaQueryWrapper);
    ComponentTypeSelectVo componentTypeSelectVo = new ComponentTypeSelectVo();
    if (Objects.isNull(tdpComponentTypeInstance)) {
      componentTypeSelectVo.setIsBind(ComponentTypeBindEnum.NOT_BIND.getIndex());
      componentTypeSelectVo.setComponentTypeId(null);
    } else {
      Integer componentTypeInstanceId = tdpComponentTypeInstance.getId();
      LambdaQueryWrapper<TdpComponentRoleInstance> wrapperForRole = new LambdaQueryWrapper();
      wrapperForRole.eq(TdpComponentRoleInstance::getComponentTypeInstanceId, componentTypeInstanceId);
      List<TdpComponentRoleInstance> tdpComponentRoleInstanceList = this.componentRoleInstanceMapper.list((Wrapper)wrapperForRole);
      componentTypeSelectVo.setComponentTypeId(tdpComponentTypeInstance.getComponentTypeId());
      if (CollectionUtils.isEmpty(tdpComponentRoleInstanceList)) {
        componentTypeSelectVo.setIsBind(ComponentTypeBindEnum.NOT_BIND.getIndex());
      } else {
        componentTypeSelectVo.setIsBind(ComponentTypeBindEnum.BIND.getIndex());
      } 
    } 
    return componentTypeSelectVo;
  }
  
  @LogDisplay
  public TdpComponentTypeInstance typeSelectClusterInstance(TypeSelectClusterInstanceReq typeSelectClusterInstanceReq) {
    if (!isExists(typeSelectClusterInstanceReq.getClusterInstanceId())) {
      String message = String.format("集群实例 %s 不存在", new Object[] { typeSelectClusterInstanceReq.getClusterInstanceId() });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    TdpClusterInstance instance = this.clusterInstanceDao.getById(typeSelectClusterInstanceReq.getClusterInstanceId());
    AuthUtil.checkEnvOperateAuth(instance.getClusterEnvId());
    if (!this.componentTypeService.isExists(typeSelectClusterInstanceReq.getComponentTypeId())) {
      String message = String.format("组件类型 %s 不存在", new Object[] { typeSelectClusterInstanceReq.getComponentTypeId() });
      log.error(message);
      throw new ComponentTypeException(message);
    } 
    LambdaQueryWrapper<TdpComponentTypeInstance> lambdaQueryWrapper = new LambdaQueryWrapper();
    lambdaQueryWrapper.eq(TdpComponentTypeInstance::getClusterInstanceId, typeSelectClusterInstanceReq.getClusterInstanceId());
    TdpComponentTypeInstance tdpComponentTypeInstance = this.componentTypeInstanceDao.selectOneByExample(lambdaQueryWrapper);
    if (Objects.nonNull(tdpComponentTypeInstance)) {
      tdpComponentTypeInstance.setComponentTypeId(typeSelectClusterInstanceReq.getComponentTypeId());
      tdpComponentTypeInstance.setUpdateTime(new Date());
      this.componentTypeInstanceDao.updateByPrimaryKeySelective(tdpComponentTypeInstance);
      return tdpComponentTypeInstance;
    } 
    TdpComponentTypeInstance tdpComponentTypeInstanceInsert = new TdpComponentTypeInstance();
    BeanUtils.copyProperties(typeSelectClusterInstanceReq, tdpComponentTypeInstanceInsert);
    tdpComponentTypeInstanceInsert.setCreateTime(new Date());
    tdpComponentTypeInstanceInsert.setUpdateTime(new Date());
    this.componentTypeInstanceDao.insert(tdpComponentTypeInstanceInsert);
    return tdpComponentTypeInstanceInsert;
  }
  
  @LogDisplay
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  public void manageRoleAndHost(ManageRoleAndHostReq manageRoleAndHostReq) {
    checkComponentRoleIdExist(manageRoleAndHostReq.getComponentRoleId());
    checkHostListExist(manageRoleAndHostReq.getHostIdList());
    checkInstanceEnvOperateAuth(manageRoleAndHostReq.getClusterInstanceId());
    LambdaQueryWrapper<TdpComponentTypeInstance> lambdaQueryWrapper = new LambdaQueryWrapper();
    lambdaQueryWrapper.eq(TdpComponentTypeInstance::getClusterInstanceId, manageRoleAndHostReq.getClusterInstanceId());
    TdpComponentTypeInstance tdpComponentTypeInstance = this.componentTypeInstanceDao.selectOneByExample(lambdaQueryWrapper);
    LambdaQueryWrapper<TdpComponentRoleInstance> roleWrapper = new LambdaQueryWrapper();
    roleWrapper.eq(TdpComponentRoleInstance::getComponentTypeInstanceId, tdpComponentTypeInstance.getId());
    roleWrapper.eq(TdpComponentRoleInstance::getComponentRoleId, manageRoleAndHostReq.getComponentRoleId());
    TdpComponentRoleInstance tdpComponentRoleInstance = (TdpComponentRoleInstance)this.componentRoleInstanceMapper.getOne((Wrapper)roleWrapper);
    if (Objects.nonNull(tdpComponentRoleInstance)) {
      String message = String.format("角色 %s 已绑定机器", new Object[] { manageRoleAndHostReq.getComponentRoleId() });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    TdpComponentRoleInstance tdpComponentRoleInstanceInsert = new TdpComponentRoleInstance();
    BeanUtils.copyProperties(manageRoleAndHostReq, tdpComponentRoleInstanceInsert);
    tdpComponentRoleInstanceInsert.setComponentTypeInstanceId(tdpComponentTypeInstance.getId());
    tdpComponentRoleInstanceInsert.setCreateTime(new Date());
    tdpComponentRoleInstanceInsert.setUpdateTime(new Date());
    this.componentRoleInstanceMapper.save(tdpComponentRoleInstanceInsert);
    Integer componentRoleInstanceId = tdpComponentRoleInstanceInsert.getId();
    manageRoleAndHostReq.getHostIdList().forEach(item -> {
          TdpComponentRoleInstanceHost tdpComponentRoleInstanceHost = new TdpComponentRoleInstanceHost();
          tdpComponentRoleInstanceHost.setComponentRoleInstanceId(componentRoleInstanceId);
          tdpComponentRoleInstanceHost.setCreateTime(new Date());
          tdpComponentRoleInstanceHost.setUpdateTime(new Date());
          tdpComponentRoleInstanceHost.setHostId(item);
          this.componentRoleInstanceHostMapper.save(tdpComponentRoleInstanceHost);
          TdpHost tdpHost = this.hostDao.queryById(item);
          tdpHost.setStatus(HostStatusEnum.USED.getIndex());
          this.hostDao.updateByPrimaryKey(tdpHost);
        });
  }
  
  @Transactional
  public String batchManageRoleAndHost(BatchManageRoleAndHostReq batchManageRoleAndHostReq) {
    batchManageRoleAndHostReq.validate();
    checkInstanceAuth(batchManageRoleAndHostReq.getClusterInstanceId());
    checkComponentRoleIdListExist(new ArrayList<>(batchManageRoleAndHostReq.getComponentRoleIds()));
    checkHostListExist(batchManageRoleAndHostReq.getHostIds());
    List<Integer> hostIds = batchManageRoleAndHostReq.getHostIds();
    Set<Integer> fontRoleIds = batchManageRoleAndHostReq.getComponentRoleIds();
    Integer clusterInstanceId = batchManageRoleAndHostReq.getClusterInstanceId();
    checkInstanceEnvOperateAuth(clusterInstanceId);
    TdpComponentTypeInstance typeInstance = this.componentTypeInstanceDao.getByClusterInstanceIdAndTypeId(clusterInstanceId, batchManageRoleAndHostReq
        .getComponentTypeId());
    Boolean alterMessage = Boolean.TRUE;
    try {
      for (Integer hostId : hostIds) {
        Set<Integer> roleIds = getRoleIds(hostId, typeInstance.getId());
        if (CollectionUtils.isEmpty(roleIds)) {
          hostRoleBind(fontRoleIds, typeInstance, hostId);
        } else {
          String compareResult = collectionEqualDegree(fontRoleIds, roleIds);
          if (CollectionEqualEnum.NOT_EQUAL.getResult().equals(compareResult)) {
            hostRoleBind(fontRoleIds, typeInstance, hostId);
          } else if (CollectionEqualEnum.PART_EQUAL.getResult().equals(compareResult)) {
            Set<Integer> componentRoleIdFilter = (Set<Integer>)fontRoleIds.stream().filter(s -> !roleIds.contains(s)).collect(Collectors.toSet());
            hostRoleBind(componentRoleIdFilter, typeInstance, hostId);
          } else if (CollectionEqualEnum.EQUAL.getResult().equals(compareResult)) {
            hostRoleDeletedBind(fontRoleIds, typeInstance, hostId);
            saveOperateStep(clusterInstanceId, ClusterOperateStepEnum.CHOOSE_HOST.getStep(), ClusterOperateStepStatusEnum.DONE.getStatus());
            alterMessage = Boolean.FALSE;
          } 
        } 
        saveOperateStep(clusterInstanceId, ClusterOperateStepEnum.CHOOSE_HOST.getStep(), ClusterOperateStepStatusEnum.DONE.getStatus());
      } 
    } catch (Exception e) {
      saveOperateStep(clusterInstanceId, ClusterOperateStepEnum.CHOOSE_HOST.getStep(), ClusterOperateStepStatusEnum.RUNNING.getStatus());
      log.info("绑定主机异常:{}", e);
      throw new RuntimeException(e);
    } 
    if (alterMessage.booleanValue())
      return "绑定成功"; 
    return "取消成功";
  }
  
  private void checkInstanceEnvReadAuth(Integer clusterInstanceId) {
    TdpClusterInstance instance = this.clusterInstanceDao.getById(clusterInstanceId);
    if (instance == null) {
      String message = String.format("集群实例 %s 不存在", new Object[] { clusterInstanceId });
      throw new ValidationException(message);
    } 
    AuthUtil.checkEnvReadAuth(instance.getClusterEnvId());
  }
  
  private void checkInstanceEnvOperateAuth(Integer clusterInstanceId) {
    TdpClusterInstance instance = this.clusterInstanceDao.getById(clusterInstanceId);
    if (instance == null) {
      String message = String.format("集群实例 %s 不存在", new Object[] { clusterInstanceId });
      throw new ValidationException(message);
    } 
    AuthUtil.checkEnvOperateAuth(instance.getClusterEnvId());
  }
  
  public void saveOperateStep(Integer clusterInstanceId, Integer step, String status) {
    TdpClusterOperateStep tdpClusterOperateStep = this.clusterOperateStepDao.getObjectByClusterInstanceIdAndStep(clusterInstanceId, step);
    if (Objects.isNull(tdpClusterOperateStep)) {
      TdpClusterOperateStep clusterOperateStepNew = new TdpClusterOperateStep();
      clusterOperateStepNew.setClusterInstanceId(clusterInstanceId);
      clusterOperateStepNew.setStep(step);
      clusterOperateStepNew.setStatus(status);
      clusterOperateStepNew.setCreateTime(new Date());
      clusterOperateStepNew.setUpdateTime(new Date());
      this.clusterOperateStepDao.insert(clusterOperateStepNew);
    } else {
      tdpClusterOperateStep.setStatus(status);
      tdpClusterOperateStep.setUpdateTime(new Date());
      this.clusterOperateStepDao.update(tdpClusterOperateStep);
    } 
  }
  
  private Set<Integer> getRoleIds(Integer hostId, Integer typeInstanceId) {
    Set<Integer> roleInstanceIds = this.componentRoleInstanceHostDao.getRoleInstanceIdByHostId(hostId);
    if (CollectionUtils.isEmpty(roleInstanceIds))
      return Sets.newHashSet(); 
    Set<Integer> roleIds = this.componentRoleInstanceDao.listRoleIdByIdsAndTypeInstanceId(roleInstanceIds, typeInstanceId);
    if (CollectionUtils.isEmpty(roleIds))
      return Sets.newHashSet(); 
    return roleIds;
  }
  
  @Transactional
  public void hostRoleDeletedBind(Set<Integer> componentRoleIds, TdpComponentTypeInstance typeInstance, Integer hostId) {
    for (Integer componentRoleId : componentRoleIds) {
      TdpComponentRoleInstance roleInstance = this.componentRoleInstanceDao.getObjectByRoleId(componentRoleId, typeInstance.getId());
      ValidationException.validate(Objects.nonNull(roleInstance), String.format("组件角色 %s 找不到对应角色实例", new Object[] { componentRoleId }));
      this.componentRoleInstanceHostDao.deletedByRoleInstanceIdAndHostId(roleInstance.getId(), hostId);
      List<TdpComponentRoleInstanceHost> check = this.componentRoleInstanceHostDao.listByHostId(hostId);
      if (CollectionUtils.isEmpty(check))
        modifyHostStatus(hostId, HostStatusEnum.UNUSED.getIndex()); 
      List<TdpComponentRoleInstanceHost> checkRoleInstance = this.componentRoleInstanceHostDao.getByRoleInstanceId(roleInstance.getId());
      if (CollectionUtils.isEmpty(checkRoleInstance))
        this.componentRoleInstanceDao.deletedByRoleId(componentRoleId); 
    } 
  }
  
  @Transactional
  public void hostRoleBind(Set<Integer> fontRoleIds, TdpComponentTypeInstance typeInstance, Integer hostId) {
    for (Integer fontRoleId : fontRoleIds) {
      LambdaQueryWrapper<TdpComponentRoleInstance> queryWrapper = new LambdaQueryWrapper();
      ((LambdaQueryWrapper)queryWrapper.eq(TdpComponentRoleInstance::getComponentTypeInstanceId, typeInstance.getId()))
        .eq(TdpComponentRoleInstance::getComponentRoleId, fontRoleId);
      TdpComponentRoleInstance tdpComponentRoleInstance = (TdpComponentRoleInstance)this.componentRoleInstanceMapper.getOne((Wrapper)queryWrapper);
      if (Objects.isNull(tdpComponentRoleInstance)) {
        TdpComponentRoleInstance roleInstanceInsert = new TdpComponentRoleInstance();
        roleInstanceInsert.setComponentTypeInstanceId(typeInstance.getId());
        roleInstanceInsert.setComponentRoleId(fontRoleId);
        roleInstanceInsert.setCreateTime(new Date());
        roleInstanceInsert.setUpdateTime(new Date());
        this.componentRoleInstanceDao.insert(roleInstanceInsert);
        TdpComponentRoleInstanceHost tdpComponentRoleInstanceHost1 = new TdpComponentRoleInstanceHost();
        tdpComponentRoleInstanceHost1.setComponentRoleInstanceId(roleInstanceInsert.getId());
        tdpComponentRoleInstanceHost1.setHostId(hostId);
        tdpComponentRoleInstanceHost1.setCreateTime(new Date());
        tdpComponentRoleInstanceHost1.setUpdateTime(new Date());
        this.componentRoleInstanceHostDao.insert(tdpComponentRoleInstanceHost1);
        continue;
      } 
      TdpComponentRoleInstanceHost tdpComponentRoleInstanceHost = new TdpComponentRoleInstanceHost();
      tdpComponentRoleInstanceHost.setComponentRoleInstanceId(tdpComponentRoleInstance.getId());
      tdpComponentRoleInstanceHost.setHostId(hostId);
      tdpComponentRoleInstanceHost.setCreateTime(new Date());
      tdpComponentRoleInstanceHost.setUpdateTime(new Date());
      this.componentRoleInstanceHostDao.insert(tdpComponentRoleInstanceHost);
    } 
    modifyHostStatus(hostId, HostStatusEnum.USED.getIndex());
  }
  
  private void modifyHostStatus(Integer hostId, Integer status) {
    TdpHost tdpHost = this.hostDao.queryById(hostId);
    tdpHost.setStatus(status);
    this.hostDao.updateByPrimaryKey(tdpHost);
  }
  
  public String collectionEqualDegree(Set<Integer> fontSet, Set<Integer> backQuerySet) {
    Set<Integer> fontSets = (Set<Integer>)fontSet.stream().sorted().collect(Collectors.toSet());
    Set<Integer> backQuerySets = (Set<Integer>)backQuerySet.stream().sorted().collect(Collectors.toSet());
    if (CollectionUtils.isEmpty(backQuerySets) || fontSets.stream().noneMatch(backQuerySets::contains))
      return CollectionEqualEnum.NOT_EQUAL.getResult(); 
    if (backQuerySets.containsAll(fontSets))
      return CollectionEqualEnum.EQUAL.getResult(); 
    if (fontSets.stream().anyMatch(backQuerySets::contains))
      return CollectionEqualEnum.PART_EQUAL.getResult(); 
    return "";
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public void updateRoleAndHost(UpdateRoleAndHostReq updateRoleAndHostReq) {
    List<Integer> hostIdList = updateRoleAndHostReq.getHostIdList();
    if (CollectionUtils.isNotEmpty(hostIdList)) {
      Integer id = hostIdList.get(0);
      TdpHost tdpHost = this.hostDao.queryById(id);
      AuthUtil.checkEnvOperateAuth(tdpHost.getClusterEnvId());
    } 
    LambdaQueryWrapper<TdpComponentRoleInstanceHost> wrapper = new LambdaQueryWrapper();
    wrapper.eq(TdpComponentRoleInstanceHost::getComponentRoleInstanceId, updateRoleAndHostReq.getComponentRoleInstanceId());
    List<TdpComponentRoleInstanceHost> componentRoleInstanceHostListInDB = this.componentRoleInstanceHostMapper.list((Wrapper)wrapper);
    checkHostListExist(updateRoleAndHostReq.getHostIdList());
    Map<Integer, TdpComponentRoleInstanceHost> hostAndRoleInstanceMapInDB = (Map<Integer, TdpComponentRoleInstanceHost>)componentRoleInstanceHostListInDB.stream().collect(Collectors.toMap(TdpComponentRoleInstanceHost::getHostId, item -> item));
    Map<Integer, TdpComponentRoleInstanceHost> hostAndRoleInstanceNeedChange = (Map<Integer, TdpComponentRoleInstanceHost>)updateRoleAndHostReq.getHostIdList().stream().collect(Collectors.toMap(item -> item, item -> new TdpComponentRoleInstanceHost()));
    MapDifference<Integer, TdpComponentRoleInstanceHost> mapDifference = Maps.difference(hostAndRoleInstanceMapInDB, hostAndRoleInstanceNeedChange);
    Map<Integer, TdpComponentRoleInstanceHost> mapNeedDelete = mapDifference.entriesOnlyOnLeft();
    mapNeedDelete.keySet().forEach(item -> {
          TdpComponentRoleInstanceHost tdpComponentRoleInstanceHost = new TdpComponentRoleInstanceHost();
          tdpComponentRoleInstanceHost.setComponentRoleInstanceId(updateRoleAndHostReq.getComponentRoleInstanceId());
          tdpComponentRoleInstanceHost.setHostId(item);
          LambdaUpdateWrapper<TdpComponentRoleInstanceHost> wrapperInstanceHost = new LambdaUpdateWrapper();
          wrapperInstanceHost.eq(TdpComponentRoleInstanceHost::getComponentRoleInstanceId, updateRoleAndHostReq.getComponentRoleInstanceId());
          wrapperInstanceHost.eq(TdpComponentRoleInstanceHost::getHostId, item);
          this.componentRoleInstanceHostMapper.remove((Wrapper)wrapperInstanceHost);
          TdpComponentRoleInstanceHost check = new TdpComponentRoleInstanceHost();
          check.setHostId(item);
          LambdaQueryWrapper<TdpComponentRoleInstanceHost> hostQueryWrapper = new LambdaQueryWrapper();
          hostQueryWrapper.eq(TdpComponentRoleInstanceHost::getHostId, item);
          List<TdpComponentRoleInstanceHost> tdpComponentRoleInstanceHostList = this.componentRoleInstanceHostMapper.list((Wrapper)hostQueryWrapper);
          if (CollectionUtils.isEmpty(tdpComponentRoleInstanceHostList)) {
            TdpHost tdpHost = this.hostDao.queryById(item);
            tdpHost.setStatus(HostStatusEnum.UNUSED.getIndex());
            tdpHost.setUpdateTime(new Date());
            this.hostDao.updateByPrimaryKey(tdpHost);
          } 
        });
    Map<Integer, MapDifference.ValueDifference<TdpComponentRoleInstanceHost>> mapNotChange = mapDifference.entriesDiffering();
    mapNotChange.keySet().forEach(item -> {
          TdpHost tdpHost = this.hostDao.queryById(item);
          tdpHost.setStatus(HostStatusEnum.USED.getIndex());
          tdpHost.setUpdateTime(new Date());
          this.hostDao.updateByPrimaryKey(tdpHost);
        });
    Map<Integer, TdpComponentRoleInstanceHost> mapNeedInsert = mapDifference.entriesOnlyOnRight();
    mapNeedInsert.keySet().forEach(item -> {
          TdpComponentRoleInstanceHost tdpComponentRoleInstanceHost = new TdpComponentRoleInstanceHost();
          tdpComponentRoleInstanceHost.setComponentRoleInstanceId(updateRoleAndHostReq.getComponentRoleInstanceId());
          tdpComponentRoleInstanceHost.setCreateTime(new Date());
          tdpComponentRoleInstanceHost.setUpdateTime(new Date());
          tdpComponentRoleInstanceHost.setHostId(item);
          this.componentRoleInstanceHostMapper.save(tdpComponentRoleInstanceHost);
          TdpHost tdpHost = this.hostDao.queryById(item);
          tdpHost.setStatus(HostStatusEnum.USED.getIndex());
          this.hostDao.updateByPrimaryKey(tdpHost);
        });
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public void deleteRoleAndHost(DeleteRoleAndHostReq deleteRoleAndHostReq) {
    Integer clusterEnvId = deleteRoleAndHostReq.getClusterEnvId();
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    LambdaQueryWrapper<TdpComponentRoleInstanceHost> wrapper = new LambdaQueryWrapper();
    wrapper.eq(TdpComponentRoleInstanceHost::getComponentRoleInstanceId, deleteRoleAndHostReq.getComponentRoleInstanceId());
    List<TdpComponentRoleInstanceHost> tdpComponentRoleInstanceHostList = this.componentRoleInstanceHostMapper.list((Wrapper)wrapper);
    this.componentRoleInstanceHostMapper.remove((Wrapper)wrapper);
    tdpComponentRoleInstanceHostList.forEach(item -> {
          LambdaQueryWrapper<TdpComponentRoleInstanceHost> hostUsedWrapper = new LambdaQueryWrapper();
          wrapper.eq(TdpComponentRoleInstanceHost::getHostId, item.getHostId());
          List<TdpComponentRoleInstanceHost> hostsUsed = this.componentRoleInstanceHostMapper.list((Wrapper)hostUsedWrapper);
          if (CollectionUtils.isEmpty(hostsUsed)) {
            TdpHost tdpHost = this.hostDao.queryById(item.getHostId());
            tdpHost.setStatus(HostStatusEnum.UNUSED.getIndex());
            tdpHost.setUpdateTime(new Date());
            this.hostDao.updateByPrimaryKey(tdpHost);
          } 
        });
    this.componentRoleInstanceMapper.removeById(deleteRoleAndHostReq.getComponentRoleInstanceId());
  }
  
  @LogDisplay
  public String inventoryCreateForClusterInstance(Integer clusterInstanceId) {
    checkInstanceEnvOperateAuth(clusterInstanceId);
    return inventoryResetForClusterInstance(clusterInstanceId);
  }
  
  @LogDisplay
  public String inventoryResetForClusterInstance(Integer clusterInstanceId) {
    checkInstanceEnvOperateAuth(clusterInstanceId);
    Inventory inventory = getInventoryData(clusterInstanceId, Lists.newArrayList());
    return IniUtil.generateInventory(inventory);
  }
  
  private Inventory getInventoryData(Integer clusterInstanceId, List<ComponentRoleInstanceAndHost> extraRoleAndHost) {
    TdpComponentTypeInstance tdpComponentTypeInstance = this.componentTypeInstanceDao.getByClusterInstanceId(clusterInstanceId);
    List<ComponentRoleInstanceAndHost> componentRoleInstanceAndHostList = this.tdpComponentRoleInstanceMapper.getRoleHostInfo(tdpComponentTypeInstance.getId());
    List<ComponentRoleInstanceAndHost> componentRoleInstanceAndHostListFilter = getComponentRoleInstanceAndHostsByRunnTimeStatus(clusterInstanceId, componentRoleInstanceAndHostList);
    List<ComponentRoleInstanceAndHost> allRoleAndHost = ImmutableList.copyOf(Iterables.concat(componentRoleInstanceAndHostListFilter, extraRoleAndHost));
    Set<Integer> hostIds = (Set<Integer>)allRoleAndHost.stream().map(ComponentRoleInstanceAndHost::getHostId).collect(Collectors.toSet());
    List<TdpHost> hosts = this.hostDao.listByIdsWithDescription(hostIds);
    Map<Integer, TdpHost> hostMap = (Map<Integer, TdpHost>)hosts.stream().collect(Collectors.toMap(TdpHost::getId, Function.identity(), (e1, e2) -> e1));
    List<InventoryGroup> inventoryGroupList = (List<InventoryGroup>)((Map)allRoleAndHost.stream().collect(Collectors.groupingBy(ComponentRoleInstanceAndHost::getComponentRoleName))).entrySet().stream().map(item -> {
          String roleName = (String)item.getKey();
          List<ComponentRoleInstanceAndHost> oneRoleHostList = (List<ComponentRoleInstanceAndHost>)item.getValue();
          List<InventoryHost> inventoryHostList = (List<InventoryHost>)oneRoleHostList.stream().map(()).collect(Collectors.toList());
          return InventoryGroup.builder().groupName(roleName).inventoryHostList(inventoryHostList).groupVars(Collections.emptyMap()).build();
        }).collect(Collectors.toList());
    return Inventory.builder().inventoryGroupList(inventoryGroupList).build();
  }
  
  private List<ComponentRoleInstanceAndHost> getComponentRoleInstanceAndHostsByRunnTimeStatus(Integer clusterInstanceId, List<ComponentRoleInstanceAndHost> componentRoleInstanceAndHostList) {
    TdpClusterInstance tdpClusterInstance = this.clusterInstanceDao.getById(clusterInstanceId);
    List<String> innerIps = (List<String>)componentRoleInstanceAndHostList.stream().map(ComponentRoleInstanceAndHost::getHostIp).collect(Collectors.toList());
    Map<String, String> runtimeStatus = this.hostRuntimeStatusHandler.getRuntimeStatus(tdpClusterInstance.getClusterEnvId(), innerIps);
    return (List<ComponentRoleInstanceAndHost>)componentRoleInstanceAndHostList.stream()
      .filter(item -> HostRuntimeStatusEnum.NORMAL.getName().equals(runtimeStatus.get(item.getHostIp())))
      .collect(Collectors.toList());
  }
  
  @LogDisplay
  public void refreshInventoryAndVars(Integer clusterInstanceId) {
    TdpClusterInstance clusterInstance = this.clusterInstanceDao.getById(clusterInstanceId);
    TdpClusterEnv clusterEnv = this.clusterEnvDao.getById(clusterInstance.getClusterEnvId());
    TdpComponentTypeInstance typeInstance = this.componentTypeInstanceDao.getByClusterInstanceId(clusterInstanceId);
    TdpComponentType tdpComponentType = this.componentTypeDao.getById(typeInstance.getComponentTypeId());
    String vars = StringUtils.isEmpty(typeInstance.getVars()) ? tdpComponentType.getVarsTemplate() : typeInstance.getVars();
    String inventory = inventoryResetForClusterInstance(clusterInstanceId);
    ClusterConfig clusterConfig = ClusterConfig.builder().clusterInstanceId(clusterInstanceId).vars(vars).componentType(tdpComponentType.getName()).inventory(inventory).build();
    ClusterInstanceRmi clusterInstanceRmi = this.rmiService.getClusterInstanceRmi(clusterInstanceId);
    clusterInstanceRmi.preConfig(clusterConfig);
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public void inventorySaveClusterInstance(SaveInventoryReq saveInventoryReq) {
    checkInstanceEnvOperateAuth(saveInventoryReq.getClusterInstanceId());
    LambdaQueryWrapper<TdpComponentTypeInstance> lambdaQueryWrapper = new LambdaQueryWrapper();
    lambdaQueryWrapper.eq(TdpComponentTypeInstance::getClusterInstanceId, saveInventoryReq.getClusterInstanceId());
    TdpComponentTypeInstance tdpComponentTypeInstance = this.componentTypeInstanceDao.selectOneByExample(lambdaQueryWrapper);
    tdpComponentTypeInstance.setInventory(saveInventoryReq.getInventoryString());
    tdpComponentTypeInstance.setUpdateTime(new Date());
    this.componentTypeInstanceDao.updateByPrimaryKeySelective(tdpComponentTypeInstance);
  }
  
  public String varShowForClusterInstance(Integer clusterInstanceId) {
    checkInstanceEnvReadAuth(clusterInstanceId);
    TdpComponentTypeInstance tdpComponentTypeInstance = this.componentTypeInstanceDao.getByClusterInstanceId(clusterInstanceId);
    if (Objects.isNull(tdpComponentTypeInstance))
      return ""; 
    TdpClusterInstance instance = this.clusterInstanceDao.getById(clusterInstanceId);
    Integer componentTypeId = tdpComponentTypeInstance.getComponentTypeId();
    TdpComponentType tdpComponentType = this.componentTypeDao.getById(componentTypeId);
    String vars = tdpComponentTypeInstance.getVars();
    if (StringUtils.isBlank(vars)) {
      ClusterEnvRmi clusterEnvRmi = this.rmiService.getClusterEnvRmi(instance.getClusterEnvId());
      try {
        if (!StringUtils.isEmpty(tdpComponentType.getVarsPath())) {
          byte[] file = clusterEnvRmi.getFile(tdpComponentType.getVarsPath());
          vars = new String(file);
        } 
      } catch (Exception e) {
        log.error("从远程获取vars失败", e);
      } 
      if (StringUtils.isEmpty(vars))
        vars = tdpComponentType.getVarsTemplate(); 
    } 
    if (ComponentTypeEnum.JAVA.getCode().equals(tdpComponentType.getName().toLowerCase()))
      vars = genNewVars(tdpComponentTypeInstance); 
    if (StringUtils.isEmpty(vars))
      return vars; 
    vars = VarsUtil.hiddenUserAndPwd(vars);
    if (vars.contains("UPDATE_VERSION: "))
      return updateVarsVersion(vars, tdpComponentTypeInstance.getComponentTypeVersion()); 
    return vars;
  }
  
  private String updateVarsVersion(String vars, String newVersion) {
    return VarsUtil.updateVersion(vars, newVersion);
  }
  
  private String genNewVars(TdpComponentTypeInstance tdpComponentTypeInstance) {
    String absolutePath = tdpComponentTypeInstance.getJarPackage();
    ValidationException.validate((StringUtils.isNotBlank(absolutePath) || "NULL".equals(absolutePath)), "Java组件请先上传Jar包");
    Path path = Paths.get(absolutePath, new String[0]);
    String jarName = path.getFileName().toString();
    jarName = jarName.substring(0, jarName.length() - 4);
    return VarsUtil.generateJAVAVars(absolutePath, jarName);
  }
  
  public String insertText(String input, String target, String newText) {
    int index = input.indexOf(target);
    StringBuilder builder = new StringBuilder(input);
    if (index != -1) {
      builder.insert(index, newText);
    } else {
      builder.append(newText);
    } 
    return builder.toString();
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public TdpComponentTypeInstance varSaveForClusterInstance(SaveVarsReq saveVarsReq) {
    Integer clusterEnvId = saveVarsReq.getClusterEnvId();
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    Integer clusterInstanceId = saveVarsReq.getClusterInstanceId();
    TdpClusterInstance clusterInstance = this.clusterInstanceDao.getById(clusterInstanceId);
    ValidationException.validate((clusterInstance != null), "cluster instance not exist");
    TdpComponentTypeInstance tdpComponentTypeInstance = this.componentTypeInstanceDao.getByClusterInstanceId(clusterInstanceId);
    String configVars = saveVarsReq.getVarString();
    if (!StringUtils.contains(configVars, "cluster_instance_id")) {
      configVars = configVars + "\ncluster_instance_id: \"" + clusterInstanceId + "\"";
      configVars = configVars + "\n";
    } 
    if (!StringUtils.contains(configVars, "update_web_ui_url")) {
      configVars = configVars + "\nupdate_web_ui_url: \"" + this.callback + "\"";
      configVars = configVars + "\n";
    } 
    TdpComponentTypeInstance param = new TdpComponentTypeInstance();
    param.setId(tdpComponentTypeInstance.getId());
    param.setVars(configVars);
    param.setUpdateTime(new Date());
    this.componentTypeInstanceDao.update(param);
    tdpComponentTypeInstance.setVars(configVars);
    refreshInventoryAndVars(clusterInstanceId);
    return tdpComponentTypeInstance;
  }
  
  @LogDisplay
  public PageVo<ClusterInstanceServiceVo> serviceClusterInstance(Integer clusterInstanceId, String ip, String roleName, Integer current, Integer size) {
    TdpClusterInstance instance = this.clusterInstanceDao.getById(clusterInstanceId);
    Integer clusterEnvId = instance.getClusterEnvId();
    AuthUtil.checkEnvReadAuth(clusterEnvId);
    TdpClusterEnv tdpClusterEnv = this.clusterEnvDao.getById(clusterEnvId);
    String monitorUrl = this.envInfoDao.getById(tdpClusterEnv.getAgentId()).getMonitorUrl();
    if (StringUtils.equals(ip, "%") || StringUtils.equals(ip, "_"))
      return new PageVo(); 
    if (StringUtils.equals(roleName, "%") || StringUtils.equals(roleName, "_"))
      return new PageVo(); 
    TdpClusterInstance clusterInstance = this.clusterInstanceDao.getById(clusterInstanceId);
    ValidationException.validate((clusterInstance != null), "cluster instance must not be null");
    PageHelper.startPage(current.intValue(), size.intValue());
    List<ClusterInstanceServiceVo> clusterInstanceServiceVoList = this.tdpClusterInstanceMapper.searchClusterInstanceService(clusterInstanceId, ip, clusterInstance.getClusterEnvId(), roleName);
    if (Objects.nonNull(monitorUrl))
      clusterInstanceServiceVoList.forEach(clusterInstanceServiceVo -> {
            String roleInstanceIp = clusterInstanceServiceVo.getIp();
            String roleInstanceName = clusterInstanceServiceVo.getComponentRoleName();
            ImmutableMap<String, String> requestParamMap = ImmutableMap.<String, String>builder().put("instance", String.format("'%s:9100'", new Object[] { roleInstanceIp })).put("name", String.format("'%s.service'", new Object[] { roleInstanceName })).build();
            String status = this.prometheusClient.getComponentRoleInstanceStatus(monitorUrl, requestParamMap);
            clusterInstanceServiceVo.setRunStatus(status);
          }); 
    PageInfo<ClusterInstanceServiceVo> pageInfo = new PageInfo(clusterInstanceServiceVoList);
    PageVo<ClusterInstanceServiceVo> pageVo = new PageVo();
    BeanUtils.copyProperties(pageInfo, pageVo);
    pageVo.setTotal(pageInfo.getTotal());
    pageVo.setData(pageInfo.getList());
    return pageVo;
  }
  
  @LogDisplay
  public TdpComponentType selectComponentTypeByClusterInstance(Integer clusterInstanceId) {
    LambdaQueryWrapper<TdpComponentTypeInstance> lambdaQueryWrapper = new LambdaQueryWrapper();
    lambdaQueryWrapper.eq(TdpComponentTypeInstance::getClusterInstanceId, clusterInstanceId);
    List<TdpComponentTypeInstance> tdpComponentTypeInstanceList = this.componentTypeInstanceDao.selectByExample(lambdaQueryWrapper);
    if (CollectionUtils.isEmpty(tdpComponentTypeInstanceList))
      return null; 
    TdpComponentTypeInstance tdpComponentTypeInstance = tdpComponentTypeInstanceList.get(0);
    return this.componentTypeDao.getById(tdpComponentTypeInstance.getComponentTypeId());
  }
  
  @LogDisplay
  public boolean isExists(Integer clusterInstanceId) {
    TdpClusterInstance tdpClusterInstance = this.clusterInstanceDao.getById(clusterInstanceId);
    return Objects.nonNull(tdpClusterInstance);
  }
  
  @LogDisplay
  public boolean isExists(Integer envId, String nameEn) {
    List<TdpClusterInstance> list = this.clusterInstanceDao.getByClusterEnvId(envId);
    if (CollectionUtils.isEmpty(list))
      return Boolean.FALSE.booleanValue(); 
    Optional<TdpClusterInstance> any = list.stream().filter(item -> nameEn.equals(item.getNameEn())).findAny();
    return any.isPresent();
  }
  
  @LogDisplay
  public List<TdpComponentRole> deployRoleClusterInstance(Integer clusterInstanceId) {
    checkInstanceEnvReadAuth(clusterInstanceId);
    return this.tdpClusterInstanceMapper.searchClusterInstanceRoleNames(clusterInstanceId);
  }
  
  public TaskPIDDTO asyncOperateClusterInstance(AsyncClusterInstanceOperateReq req) throws RemoteException {
    Integer clusterEnvId = req.getClusterEnvId();
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE);
    LogDisplayContentEnum title = LogDisplayContentEnum.getOperateType(req.getOperateType());
    auditLogOperateVo.setOperateContent(title);
    auditLogOperateVo.setOperateClusterEnvId(clusterEnvId);
    auditLogOperateVo.setOperateClusterInstanceId(req.getClusterInstanceId());
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    UserDetailsVo principal = (UserDetailsVo)SecurityContextHolder.getContext().getAuthentication().getPrincipal();
    String resourceCode = ClusterInstanceOperateEnum.getResourceCode(req.getOperateType());
    boolean b = principal.getResourceCodes().stream().anyMatch(s -> s.equals(resourceCode));
    ValidationException.validate(b, "没有权限操作");
    Integer clusterInstanceId = req.getClusterInstanceId();
    TdpComponentType tdpComponentType = selectComponentTypeByClusterInstance(req.getClusterInstanceId());
    TdpClusterEnv tdpClusterEnv = this.clusterEnvDao.getByClusterInstanceId(clusterInstanceId);
    Boolean isTerminate = req.getIsTerminate();
    if (Boolean.TRUE.equals(isTerminate)) {
      checkClusterStatus(clusterInstanceId, isTerminate);
    } else {
      checkRunStatusClusterInstance(clusterInstanceId);
    } 
    refreshInventoryAndVars(clusterInstanceId);
    TdpClusterConfigVersion tdpClusterConfigVersion = this.clusterConfigService.getOnlineConfigVersion(clusterInstanceId);
    if (Objects.nonNull(tdpClusterConfigVersion))
      updateAgentConfig(clusterInstanceId, tdpClusterConfigVersion.getId(), null); 
    ClusterInstanceOperateConfig clusterInstanceOperateConfig = ClusterInstanceOperateConfig.builder().build();
    BeanUtils.copyProperties(req, clusterInstanceOperateConfig);
    String operateType = req.getOperateType();
    Boolean show = this.clusterOperateButtonDao.isShow(clusterInstanceId, operateType);
    ValidationException.validate(Boolean.FALSE.equals(show), "集群已经启动，该功能被暂停使用");
    clusterInstanceOperateConfig.setComponentType(tdpComponentType.getName());
    log.info("clusterInstanceOperateConfig {}", JsonUtil.objectToJson(clusterInstanceOperateConfig));
    ClusterInstanceRmi clusterInstanceRmi = this.rmiService.getClusterInstanceRmi(clusterInstanceId);
    TaskPIDVO taskPIDVO = this.taskService.asyncOperateInstance(clusterInstanceRmi, clusterInstanceOperateConfig, tdpClusterEnv.getId());
    List<TdpHost> hosts = this.hostDao.searchClusterInstanceHost(req.getClusterInstanceId());
    Set<String> hostList = (Set<String>)hosts.stream().map(TdpHost::getNodePort).collect(Collectors.toSet());
    try {
      if (req.getOperateType().equals(ClusterInstanceOperateEnum.start.getOperateType()))
        this.monitorService.addInstance2Monitor(clusterEnvId, req.getClusterInstanceId(), hostList); 
      if (req.getOperateType().equals(ClusterInstanceOperateEnum.stop.getOperateType()))
        this.monitorService.removeInstance2Monitor(clusterEnvId, req.getClusterInstanceId(), hostList); 
      if (req.getOperateType().equals(ClusterInstanceOperateEnum.uninstall.getOperateType()))
        this.monitorService.removeInstance2Monitor(clusterEnvId, req.getClusterInstanceId(), hostList); 
    } catch (Exception e) {
      log.error("添加或移除纳管异常", e);
    } 
    return TaskPIDDTO.assemble(taskPIDVO);
  }
  
  public void terminateMission(TerminateMissionQuery terminateMissionQuery) {
    terminateMissionQuery.validate();
    TdpClusterInstance clusterInstance = this.clusterInstanceDao.getById(terminateMissionQuery.getClusterInstanceId());
    checkInstanceEnvOperateAuth(clusterInstance.getId());
    log.info("终止任务-集群实例:{}", clusterInstance);
    log.info("终止任务-开始");
    ClusterEnvRmi clusterEnvRmi = this.rmiService.getClusterEnvRmi(clusterInstance.getClusterEnvId());
    log.info("终止任务-进行中 ，远程对象 clusterEnvRmi：{}", clusterEnvRmi);
    clusterEnvRmi.killTask(terminateMissionQuery.getPid());
    log.info("终止任务-结束");
    this.taskDao.updateStatusFailedById(terminateMissionQuery.getTaskId());
    this.operateLogService.updateStatus(terminateMissionQuery.getClusterInstanceId(), TaskStatusEnum.STOP);
  }
  
  public void configurationSync(SyncConfigReq syncConfigReq) throws RemoteException {
    Integer clusterEnvId = syncConfigReq.getClusterEnvId();
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE_CONFIG);
    auditLogOperateVo.setOperateContent(LogDisplayContentEnum.CONFIGSYC);
    auditLogOperateVo.setOperateClusterEnvId(clusterEnvId);
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    writeConfig2Agent(syncConfigReq, clusterEnvId);
    List<String> hostIpList = new ArrayList<>();
    hostIpList.addAll(syncConfigReq.getHostIp());
    PublishConfig publishConfig = new PublishConfig();
    publishConfig.setIpList(hostIpList);
    publishConfig.setConfigName(syncConfigReq.getConfigGroup());
    Integer clusterInstanceId = syncConfigReq.getClusterInstanceId();
    refreshInventoryAndVars(clusterInstanceId);
    ClusterInstanceRmi clusterInstanceRmi = this.rmiService.getClusterInstanceRmi(clusterInstanceId);
    TdpComponentType tdpComponentType = selectComponentTypeByClusterInstance(clusterInstanceId);
    log.info("tdpComponentType {}", tdpComponentType);
    ClusterInstanceOperateConfig clusterInstanceOperateConfig = ClusterInstanceOperateConfig.builder().operateType(ClusterOperateTypeEnum.PUBLISH_CONFIG.getName()).clusterInstanceId(clusterInstanceId).componentType(tdpComponentType.getName()).configGroupName(syncConfigReq.getConfigGroup()).publishConfig(publishConfig).build();
    log.info("start synchronization task");
    this.taskService.doClusterInstanceTask(config -> clusterInstanceRmi.clusterInstanceOperate(clusterInstanceOperateConfig), clusterInstanceOperateConfig, this::callback, clusterInstanceId);
  }
  
  private void writeConfig2Agent(SyncConfigReq syncConfigReq, Integer clusterEnvId) throws RemoteException {
    ClusterEnvRmi clusterEnvRmi = this.rmiService.getClusterEnvRmi(clusterEnvId);
    String configFilePath = (String)clusterEnvRmi.getAgentPath().get("configFilePath") + File.separator + syncConfigReq.getClusterInstanceId();
    String groupPath = configFilePath + File.separator + syncConfigReq.getConfigGroup();
    String hostPath = configFilePath + File.separator + "host";
    clusterEnvRmi.mkdir(groupPath);
    clusterEnvRmi.mkdir(hostPath);
    List<TdpClusterConfig> configList = this.clusterConfigService.getConfigList(syncConfigReq.getClusterInstanceId(), syncConfigReq.getConfigName(), syncConfigReq.getConfigGroup());
    ValidationException.validate(CollectionUtils.isNotEmpty(configList), "配置文件为空，请核对数据");
    configList.forEach(config -> {
          try {
            clusterEnvRmi.writeContent2File(groupPath, config.getFileName(), config.getFileContent(), Boolean.FALSE);
          } catch (RemoteException e) {
            log.error("写配置文件到agent异常", e);
          } 
        });
    String content = String.join(",", syncConfigReq.getHostIp());
    clusterEnvRmi.writeContent2File(hostPath, syncConfigReq.getConfigGroup(), content, Boolean.FALSE);
  }
  
  private String callback(Integer instanceId) {
    log.info("发布配置成功");
    return "";
  }
  
  public List<SyncButtonReq> publishConfigSyncButton(Integer clusterEnvId, String configGroupName, String configVersion, Integer clusterInstanceId) {
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE_CONFIG);
    auditLogOperateVo.setOperateContent(LogDisplayContentEnum.CONFIGSYC);
    auditLogOperateVo.setOperateClusterEnvId(clusterEnvId);
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    List<TdpClusterConfigVersion> configVersions = this.clusterConfigVersionDao.selectByConfigVersion(configVersion, clusterInstanceId);
    if (!configVersions.isEmpty()) {
      TdpClusterConfigVersion configversion = configVersions.get(0);
      Integer configVersionId = configversion.getId();
      LambdaQueryWrapper<TdpClusterConfigGroup> wrapper = new LambdaQueryWrapper();
      wrapper.eq(TdpClusterConfigGroup::getConfigGroupName, configGroupName);
      wrapper.eq(TdpClusterConfigGroup::getConfigVersionId, configVersionId);
      List<TdpClusterConfigGroup> configGroups = this.clusterConfigGroupMapper.list((Wrapper)wrapper);
      if (!configGroups.isEmpty()) {
        TdpClusterConfigGroup configGroup = configGroups.get(0);
        Integer newConfigGroupId = configGroup.getId();
        List<TdpClusterConfigGroupHost> configGroupHosts = this.clusterConfigGroupHostDao.selectByConfigGroupId(newConfigGroupId);
        Set<Integer> hostIds = (Set<Integer>)configGroupHosts.stream().map(TdpClusterConfigGroupHost::getHostId).collect(Collectors.toSet());
        List<TdpHost> tdpHosts = this.hostDao.listByIds(hostIds);
        if (CollectionUtils.isEmpty(tdpHosts))
          return new ArrayList<>(); 
        List<SyncButtonReq> syncButtonReqs = new ArrayList<>();
        tdpHosts.forEach(host -> {
              SyncButtonReq syncButtonReq = new SyncButtonReq();
              syncButtonReq.setHostName(host.getHostName());
              syncButtonReq.setIp(host.getInnerIp());
              syncButtonReq.setId(host.getId());
              syncButtonReqs.add(syncButtonReq);
            });
        return syncButtonReqs;
      } 
      return new ArrayList<>();
    } 
    return new ArrayList<>();
  }
  
  public List<ClusterInstanceUiDTO> listUI(Integer envId) {
    List<TdpClusterInstanceUi> tdpClusterInstanceUis = this.clusterInstanceUIDao.listByEnvId(envId);
    List<Integer> instanceIds = (List<Integer>)tdpClusterInstanceUis.stream().map(TdpClusterInstanceUi::getClusterInstanceId).collect(Collectors.toList());
    List<TdpClusterInstance> clusterInstances = this.clusterInstanceDao.listByClusterInstanceIds(instanceIds);
    return ClusterInstanceUiDTO.assamble(tdpClusterInstanceUis, clusterInstances);
  }
  
  public TaskPIDVO migrateOperate(MigrateOperateCommand command) {
    command.validate();
    Integer oldHostId = command.getOldHostId();
    Integer newHostId = command.getNewHostId();
    Integer clusterInstanceId = command.getClusterInstanceId();
    TdpClusterInstance instance = this.clusterInstanceDao.getById(clusterInstanceId);
    AuthUtil.checkEnvOperateAuth(instance.getClusterEnvId());
    String configStatus = command.getConfigStatus();
    int index = configStatus.lastIndexOf("-");
    String configGroupName = configStatus.substring(index + 1);
    ValidationException.validate(StringUtils.isNotBlank(configGroupName), "迁移配置信息为空");
    TdpComponentRoleInstance componentRoleInstance = this.componentRoleInstanceDao.getComponentRoleInstanceById(command.getComponentRoleInstanceId());
    ValidationException.validate(Objects.nonNull(componentRoleInstance), "迁移,对应角色实例无法匹配");
    TdpComponentRole componentRole = this.componentRoleDao.getById(componentRoleInstance.getComponentRoleId());
    ValidationException.validate(Boolean.TRUE.equals(componentRole.getMigrate()), "角色不能迁移");
    TdpComponentTypeInstance typeInstance = this.componentTypeInstanceDao.getById(componentRoleInstance.getComponentTypeInstanceId());
    TdpComponentType componentType = this.componentTypeDao.getById(typeInstance.getComponentTypeId());
    List<TdpHost> hosts = this.hostDao.listByIds(Sets.newHashSet(new Integer[] { oldHostId, newHostId }));
    Map<Integer, TdpHost> hostMap = (Map<Integer, TdpHost>)hosts.stream().collect(Collectors.toMap(TdpHost::getId, Function.identity(), (e1, e2) -> e1));
    TdpHost tdpHost = hostMap.get(newHostId);
    if (StringUtils.isNotBlank(tdpHost.getRuntimeStatus()) && HostRuntimeStatusEnum.ABNORMAL.getName().equals(tdpHost.getRuntimeStatus().toUpperCase()))
      ValidationException.validate(Boolean.FALSE.booleanValue(), "主机状态异常无法迁移"); 
    Map<String, String> extParam = new HashMap<>();
    extParam.put("roleName", "[" + command.getRoleName() + "]");
    TdpHost oldHost = hostMap.get(oldHostId);
    TdpHost newHost = hostMap.get(newHostId);
    extParam.put("oldIp", oldHost.getInnerIp() + " HOSTNAME=" + oldHost.getHostName());
    extParam.put("newIp", newHost.getInnerIp() + " HOSTNAME=" + newHost.getHostName());
    HttpServletRequest request = ((ServletRequestAttributes)RequestContextHolder.getRequestAttributes()).getRequest();
    String token = this.jwtService.getTokenString(request);
    extParam.put("token", token);
    extParam.put("host", this.callbackUrl);
    ClusterInstanceOperateConfig operateConfig = ClusterInstanceOperateConfig.builder().clusterInstanceId(command.getClusterInstanceId()).extraParam(extParam).componentType(componentType.getName()).operateType(ClusterOperateTypeEnum.MIGRATION.getName()).build();
    this.roleMigratesService.createMigrateTemporaryVersion(clusterInstanceId);
    ClusterInstanceRmi clusterInstanceRmi = this.rmiService.getClusterInstanceRmi(clusterInstanceId);
    TaskPIDVO taskPIDVO = this.taskService.asyncOperateInstance(clusterInstanceRmi, operateConfig, instance.getClusterEnvId());
    String traceId = MDC.get("traceId");
    (new Thread(() -> {
          MDC.put("traceId", traceId);
          for (int count = 0; count < 1200; count++) {
            TdpTask tdpTask = this.taskDao.getById(taskPIDVO.getTaskId());
            log.info("taskId:{}的任务结果是：{}", taskPIDVO.getTaskId(), tdpTask.toString());
            TaskStatusEnum taskStatusEnum = TaskStatusEnum.getByName(tdpTask.getStatus());
            if (TaskStatusEnum.FAILED.getName().equals(taskStatusEnum.getName()))
              break; 
            if (TaskStatusEnum.FINISHED.getName().equals(taskStatusEnum.getName())) {
              log.info("Task迁移完成....数据更改");
              if (!"0".equals(tdpTask.getExitCode()))
                this.roleMigratesService.deleteMigrateTemporaryVersion(clusterInstanceId); 
              break;
            } 
            try {
              Thread.sleep(3000L);
            } catch (InterruptedException e) {
              e.printStackTrace();
            } 
          } 
          MDC.remove("traceId");
        })).start();
    return taskPIDVO;
  }
  
  public Boolean supportMigrate(Integer roleId) {
    TdpComponentRole componentRole = this.componentRoleDao.getById(roleId);
    ValidationException.validate(Objects.nonNull(componentRole), "角色不支持迁移");
    if (Boolean.TRUE.equals(componentRole.getMigrate()))
      return Boolean.valueOf(true); 
    return Boolean.valueOf(false);
  }
  
  public void roleMigrateVerify(MigrateVerifyQuery query) {
    Integer clusterInstanceId = query.getClusterInstanceId();
    TdpClusterInstance instance = this.clusterInstanceDao.getById(clusterInstanceId);
    AuthUtil.checkEnvOperateAuth(instance.getClusterEnvId());
    TdpClusterConfigVersion temporaryConfigVersion = this.clusterConfigVersionDao.getTemporaryConfigVersion(clusterInstanceId);
    ValidationException.validate(Objects.isNull(temporaryConfigVersion), "当前集群存在临时版本,校验失败");
    List<ClusterInstanceServiceVo> clusterInstanceServiceVoList = this.tdpClusterInstanceMapper.searchClusterInstanceService(clusterInstanceId, query.getIp(), instance.getClusterEnvId(), query.getRoleName());
    ValidationException.validate(CollectionUtils.isEmpty(clusterInstanceServiceVoList), "要迁移的主机已经存在该角色");
  }
  
  public TaskPIDDTO upgradeDetermine(UpgradeDetermineCommand command) {
    Integer clusterInstanceId = command.getClusterInstanceId();
    String upgradeVersion = command.getUpgradeVersions();
    Integer clusterEnvId = command.getClusterEnvId();
    ValidationException.validate(StringUtils.isNotBlank(upgradeVersion), "版本号为空，请检查");
    ValidationException.validate(Objects.nonNull(clusterInstanceId), "clusterInstanceId，请检查");
    ValidationException.validate(Objects.nonNull(clusterEnvId), "clusterEnvId，请检查");
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    log.info("升级更新var模板");
    updateVars(clusterInstanceId, upgradeVersion);
    refreshInventoryAndVars(clusterInstanceId);
    log.info("检查组件是否支持升级");
    checkUpgrade(clusterInstanceId);
    TdpComponentTypeInstance tdpComponentTypeInstance = this.componentTypeInstanceDao.getByClusterInstanceId(clusterInstanceId);
    String oldVersion = tdpComponentTypeInstance.getComponentTypeVersion();
    TdpComponentType componentType = this.componentTypeDao.getById(tdpComponentTypeInstance.getComponentTypeId());
    TdpClusterEnv tdpClusterEnv = this.clusterEnvDao.getByClusterInstanceId(clusterInstanceId);
    ClusterInstanceOperateConfig clusterInstanceOperateConfig = ClusterInstanceOperateConfig.builder().build();
    command.setOperateType(ClusterOperateTypeEnum.UPGRADE.getName());
    BeanUtils.copyProperties(command, clusterInstanceOperateConfig, new String[] { "upgradeVersion" });
    clusterInstanceOperateConfig.setComponentType(componentType.getName());
    ClusterInstanceRmi clusterInstanceRmi = this.rmiService.getClusterInstanceRmi(clusterInstanceId);
    TaskPIDVO taskPIDVO = this.taskService.asyncOperateInstance(clusterInstanceRmi, clusterInstanceOperateConfig, tdpClusterEnv.getId());
    (new Thread(() -> {
          for (int count = 0; count < 1200; count++) {
            TdpTask tdpTask = this.taskDao.getById(taskPIDVO.getTaskId());
            log.info("taskId:{}的任务结果是：{}", taskPIDVO.getTaskId(), tdpTask.toString());
            TaskStatusEnum taskStatusEnum = TaskStatusEnum.getByName(tdpTask.getStatus());
            if (TaskStatusEnum.FAILED.getName().equals(taskStatusEnum.getName())) {
              tdpComponentTypeInstance.setComponentTypeVersion(oldVersion);
              this.componentTypeInstanceDao.update(tdpComponentTypeInstance);
              break;
            } 
            if (TaskStatusEnum.FINISHED.getName().equals(taskStatusEnum.getName())) {
              if ("0".equals(tdpTask.getExitCode())) {
                tdpComponentTypeInstance.setComponentTypeVersion(upgradeVersion);
                log.info("更新instance：{}", tdpComponentTypeInstance.toString());
                this.componentTypeInstanceDao.update(tdpComponentTypeInstance);
              } 
              break;
            } 
            try {
              Thread.sleep(3000L);
            } catch (InterruptedException e) {
              e.printStackTrace();
            } 
          } 
        })).start();
    return TaskPIDDTO.assemble(taskPIDVO);
  }
  
  public void updateVars(Integer clusterInstanceId, String upgradeVersion) {
    TdpComponentTypeInstance tdpComponentTypeInstance = this.componentTypeInstanceDao.getByClusterInstanceId(clusterInstanceId);
    ValidationException.validate((tdpComponentTypeInstance != null), "升级组件实例是null");
    Integer componentTypeId = tdpComponentTypeInstance.getComponentTypeId();
    TdpComponentType tdpComponentType = this.componentTypeDao.getById(componentTypeId);
    log.info("升级更新vars模板，获取vars模板");
    String vars = tdpComponentTypeInstance.getVars();
    if (StringUtils.isBlank(vars))
      vars = tdpComponentType.getVarsTemplate(); 
    log.info("vars模板增加或修改UPDATE_VERSION:{}", vars);
    vars = updateVarsVersion(vars, upgradeVersion);
    tdpComponentTypeInstance.setVars(vars);
    tdpComponentTypeInstance.setUpdateTime(new Date());
    this.componentTypeInstanceDao.update(tdpComponentTypeInstance);
  }
  
  public UpgradeComponentTypeReq upgrade(Integer clusterInstanceId) {
    checkInstanceEnvReadAuth(clusterInstanceId);
    UpgradeComponentTypeReq upgradeComponentTypeReq = new UpgradeComponentTypeReq();
    TdpComponentTypeInstance tdpComponentTypeInstance = this.clusterInstanceDao.getVersionByInstanceId(clusterInstanceId);
    Integer componentTypeId = tdpComponentTypeInstance.getComponentTypeId();
    List<String> upGradeVersions = this.componentTypeVersionDao.getVersions(componentTypeId);
    String currentVersion = tdpComponentTypeInstance.getComponentTypeVersion();
    upGradeVersions.removeIf(str -> str.equals(currentVersion));
    Collections.sort(upGradeVersions, Collections.reverseOrder());
    upgradeComponentTypeReq.setCurrentVersion(currentVersion);
    upgradeComponentTypeReq.setUpgradeVersions(upGradeVersions);
    return upgradeComponentTypeReq;
  }
  
  public void check(UpgradeComponentTypeCheckReq upgradeComponentTypeCheckReq) {
    Integer instanceId = upgradeComponentTypeCheckReq.getClusterInstanceId();
    checkInstanceEnvReadAuth(instanceId);
    checkUpgrade(instanceId);
    List<TdpClusterConfigVersion> tdpClusterConfigVersions = this.clusterConfigVersionDao.selectByConfigVersion(upgradeComponentTypeCheckReq.getCurrentVersion(), instanceId);
    if (CollectionUtils.isEmpty(tdpClusterConfigVersions)) {
      String message = "数据库不存在相应配置的版本信息！";
      throw new ClusterInstanceException(message);
    } 
    for (TdpClusterConfigVersion tdpClusterConfigVersion : tdpClusterConfigVersions) {
      String configVersion = tdpClusterConfigVersion.getConfigVersion();
      String version = "v-t";
      if (version.equals(configVersion)) {
        String message = "未同步临时配置版本！";
        throw new ClusterInstanceException(message);
      } 
    } 
  }
  
  private void checkUpgrade(Integer instanceId) {
    TdpComponentTypeInstance ClusterInstance = this.componentTypeInstanceDao.getByClusterInstanceId(instanceId);
    Integer componentTypeId = ClusterInstance.getComponentTypeId();
    TdpComponentType componentType = this.componentTypeDao.getById(componentTypeId);
    if (!Boolean.TRUE.equals(componentType.getUpgrade())) {
      String message = "该组件不支持升级";
      throw new ClusterInstanceException(message);
    } 
  }
  
  @LogDisplay
  public void operateClusterInstance(ClusterInstanceOperateCommand clusterInstanceOperateReq) throws RemoteException {
    Integer clusterEnvId = clusterInstanceOperateReq.getClusterEnvId();
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE);
    auditLogOperateVo.setOperateClusterEnvId(clusterEnvId);
    auditLogOperateVo.setOperateClusterInstanceId(clusterInstanceOperateReq.getClusterInstanceId());
    LogDisplayContentEnum title = LogDisplayContentEnum.getOperateType(clusterInstanceOperateReq.getOperateType());
    auditLogOperateVo.setOperateContent(title);
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    checkPrincipal(clusterInstanceOperateReq);
    Integer clusterInstanceId = clusterInstanceOperateReq.getClusterInstanceId();
    TdpComponentType tdpComponentType = selectComponentTypeByClusterInstance(clusterInstanceOperateReq.getClusterInstanceId());
    TdpClusterEnv tdpClusterEnv = this.clusterEnvDao.getByClusterInstanceId(clusterInstanceId);
    Map<String, String> runtimeStatus = this.hostRuntimeStatusHandler.getRuntimeStatus(clusterEnvId);
    checkRunStatusClusterInstance(clusterInstanceId);
    refreshInventoryAndVars(clusterInstanceId);
    TdpClusterConfigVersion tdpClusterConfigVersion = this.clusterConfigService.getOnlineConfigVersion(clusterInstanceId);
    if (Objects.nonNull(tdpClusterConfigVersion))
      updateAgentConfig(clusterInstanceId, tdpClusterConfigVersion.getId(), null); 
    ClusterInstanceOperateConfig clusterInstanceOperateConfig = ClusterInstanceOperateConfig.builder().build();
    Map<String, List<String>> componentRoleAndIpMap = Maps.newHashMap();
    List<ClusterInstanceOperateCommand.ComponentRoleNameAndIp> componentRoleAndIpList = clusterInstanceOperateReq.getIpList();
    if (CollectionUtils.isNotEmpty(componentRoleAndIpList)) {
      List<ClusterInstanceOperateCommand.ComponentRoleNameAndIp> componentRoleAndIpListFilter = (List<ClusterInstanceOperateCommand.ComponentRoleNameAndIp>)componentRoleAndIpList.stream().map(roleNameAndIp -> new ClusterInstanceOperateCommand.ComponentRoleNameAndIp(roleNameAndIp.getComponentRoleName(), (List)roleNameAndIp.getIp().stream().filter(()).collect(Collectors.toList()))).collect(Collectors.toList());
      componentRoleAndIpMap = (Map<String, List<String>>)componentRoleAndIpListFilter.stream().collect(Collectors.toMap(ClusterInstanceOperateCommand.ComponentRoleNameAndIp::getComponentRoleName, ClusterInstanceOperateCommand.ComponentRoleNameAndIp::getIp));
    } 
    BeanUtils.copyProperties(clusterInstanceOperateReq, clusterInstanceOperateConfig);
    String operateType = clusterInstanceOperateReq.getOperateType();
    if (StringUtils.equals(operateType, ClusterOperateTypeEnum.EXPANSION.getName())) {
      log.info("create new inventory {}", JsonUtil.objectToJson(componentRoleAndIpMap));
      List<ComponentRoleInstanceAndHost> componentRoleInstanceAndHostList = Lists.newArrayList();
      for (Map.Entry<String, List<String>> entry : componentRoleAndIpMap.entrySet()) {
        String roleName = entry.getKey();
        List<String> ipList = entry.getValue();
        List<TdpHost> tdpHostList = this.hostService.selectHostByEnvIdAndIps(tdpClusterEnv.getId(), ipList);
        List<ComponentRoleInstanceAndHost> oneRoleHost = (List<ComponentRoleInstanceAndHost>)tdpHostList.stream().map(oneTdpHost -> {
              ComponentRoleInstanceAndHost componentRoleInstanceAndHost = new ComponentRoleInstanceAndHost();
              componentRoleInstanceAndHost.setComponentRoleName(roleName);
              componentRoleInstanceAndHost.setHostId(oneTdpHost.getId());
              componentRoleInstanceAndHost.setHostIp(oneTdpHost.getInnerIp());
              componentRoleInstanceAndHost.setHostName(oneTdpHost.getHostName());
              return componentRoleInstanceAndHost;
            }).collect(Collectors.toList());
        componentRoleInstanceAndHostList.addAll(oneRoleHost);
      } 
      log.info("create inventory data {}", JsonUtil.objectToJson(componentRoleInstanceAndHostList));
      Inventory inventoryData = getInventoryData(clusterInstanceId, componentRoleInstanceAndHostList);
      String inventorString = IniUtil.generateInventory(inventoryData);
      log.info("inventorString {}", inventorString);
      clusterInstanceOperateConfig.setExtraParam(ImmutableMap.of("inventory", inventorString));
    } 
    clusterInstanceOperateConfig.setComponentType(tdpComponentType.getName());
    clusterInstanceOperateConfig.setComponentRoleAndIpMap(componentRoleAndIpMap);
    log.info("clusterInstanceOperateConfig {}", JsonUtil.objectToJson(clusterInstanceOperateConfig));
    ClusterInstanceRmi clusterInstanceRmi = this.rmiService.getClusterInstanceRmi(clusterInstanceId);
    this.taskService.doClusterInstanceTask(clusterInstanceRmi::clusterInstanceOperate, clusterInstanceOperateConfig, this::operateCallbackClusterInstance, clusterInstanceOperateConfig);
    operatePostProcess(clusterInstanceOperateReq);
    List<TdpHost> hosts = this.hostDao.searchClusterInstanceHost(clusterInstanceOperateReq.getClusterInstanceId());
    Set<String> hostList = (Set<String>)hosts.stream().map(TdpHost::getNodePort).collect(Collectors.toSet());
    try {
      if (clusterInstanceOperateReq.getOperateType().equals(ClusterInstanceOperateEnum.start.getOperateType()) || clusterInstanceOperateReq
        .getOperateType().equals(ClusterInstanceOperateEnum.expansion.getOperateType())) {
        TdpClusterInstance clusterInstance = this.clusterInstanceDao.getById(clusterInstanceOperateReq.getClusterInstanceId());
        this.clusterInstanceDao.updateStartTimeById(clusterInstance.getId());
        this.monitorService.addInstance2Monitor(clusterEnvId, clusterInstanceOperateReq.getClusterInstanceId(), hostList);
      } 
      if (clusterInstanceOperateReq.getOperateType().equals(ClusterInstanceOperateEnum.stop.getOperateType()) || clusterInstanceOperateReq
        .getOperateType().equals(ClusterInstanceOperateEnum.uninstall.getOperateType()) || clusterInstanceOperateReq
        .getOperateType().equals(ClusterInstanceOperateEnum.shrink.getOperateType()))
        this.monitorService.removeInstance2Monitor(clusterEnvId, clusterInstanceOperateReq.getClusterInstanceId(), hostList); 
    } catch (Exception e) {
      log.error("添加或移除纳管异常", e);
    } 
  }
  
  public void operateClusterInstanceJava(ClusterInstanceOperateCommand clusterInstanceOperateCommand) throws RemoteException {
    Integer clusterEnvId = clusterInstanceOperateCommand.getClusterEnvId();
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE_JAVA);
    auditLogOperateVo.setOperateClusterEnvId(clusterEnvId);
    auditLogOperateVo.setOperateClusterInstanceId(clusterInstanceOperateCommand.getClusterInstanceId());
    LogDisplayContentEnum title = LogDisplayContentEnum.getOperateType(clusterInstanceOperateCommand.getOperateType());
    System.out.println(title.getTitle());
    auditLogOperateVo.setOperateContent(title);
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    this.operateClusterInstanceJavaService.operate(clusterInstanceOperateCommand);
    List<TdpHost> hosts = this.hostDao.searchClusterInstanceHost(clusterInstanceOperateCommand.getClusterInstanceId());
    Set<String> hostList = (Set<String>)hosts.stream().map(TdpHost::getNodePort).collect(Collectors.toSet());
    try {
      if (clusterInstanceOperateCommand.getOperateType().equals(ClusterInstanceOperateEnum.start.getOperateType()))
        this.monitorService.addInstance2Monitor(clusterEnvId, clusterInstanceOperateCommand.getClusterInstanceId(), hostList); 
      if (clusterInstanceOperateCommand.getOperateType().equals(ClusterInstanceOperateEnum.stop.getOperateType()) || clusterInstanceOperateCommand
        .getOperateType().equals(ClusterInstanceOperateEnum.uninstall.getOperateType()))
        this.monitorService.removeInstance2Monitor(clusterEnvId, clusterInstanceOperateCommand.getClusterInstanceId(), hostList); 
    } catch (Exception e) {
      log.error("添加或移除纳管异常", e);
    } 
  }
  
  public TaskPIDDTO asyncOperateClusterInstanceJava(AsyncClusterInstanceOperateReq asyncClusterInstanceOperatereq) throws RemoteException {
    Integer clusterEnvId = asyncClusterInstanceOperatereq.getClusterEnvId();
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE_JAVA);
    auditLogOperateVo.setOperateClusterEnvId(asyncClusterInstanceOperatereq.getClusterEnvId());
    auditLogOperateVo.setOperateClusterInstanceId(asyncClusterInstanceOperatereq.getClusterInstanceId());
    LogDisplayContentEnum title = LogDisplayContentEnum.getOperateType(asyncClusterInstanceOperatereq.getOperateType());
    auditLogOperateVo.setOperateContent(title);
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    List<TdpHost> hosts = this.hostDao.searchClusterInstanceHost(asyncClusterInstanceOperatereq.getClusterInstanceId());
    Set<String> hostList = (Set<String>)hosts.stream().map(TdpHost::getHttpPort).collect(Collectors.toSet());
    try {
      if (asyncClusterInstanceOperatereq.getOperateType().equals(ClusterInstanceOperateEnum.start.getOperateType()))
        this.monitorService.addInstance2Monitor(clusterEnvId, asyncClusterInstanceOperatereq.getClusterInstanceId(), hostList); 
      if (asyncClusterInstanceOperatereq.getOperateType().equals(ClusterInstanceOperateEnum.stop.getOperateType()) || asyncClusterInstanceOperatereq
        .getOperateType().equals(ClusterInstanceOperateEnum.uninstall.getOperateType()))
        this.monitorService.removeInstance2Monitor(clusterEnvId, asyncClusterInstanceOperatereq.getClusterInstanceId(), hostList); 
    } catch (Exception e) {
      log.error("添加或移除纳管异常", e);
    } 
    return this.operateClusterInstanceJavaService.asyncOperate(asyncClusterInstanceOperatereq);
  }
  
  public String customScriptShow(Integer clusterInstanceId) throws RemoteException {
    AuthUtil.checkInstanceAuth(clusterInstanceId);
    TdpComponentTypeInstance componentTypeInstance = this.componentTypeInstanceDao.getByClusterInstanceId(clusterInstanceId);
    TdpComponentType componentType = this.componentTypeDao.getById(componentTypeInstance.getComponentTypeId());
    TdpClusterInstance instance = this.clusterInstanceDao.getById(clusterInstanceId);
    ClusterEnvRmi clusterEnvRmi = this.rmiService.getClusterEnvRmi(instance.getClusterEnvId());
    Map<String, String> agentPath = clusterEnvRmi.getAgentPath();
    StringBuilder stringBuilder = new StringBuilder();
    stringBuilder.append("ansible-playbook -i \"");
    stringBuilder.append(agentPath.get("inventoryPath")).append(clusterInstanceId).append("_host\" ");
    stringBuilder.append("-e  'ips=all user=test' -e \"agent_dir=/test\" -e ");
    stringBuilder.append(" \"var_file=").append(agentPath.get("varPath")).append(componentType.getName()).append("/").append(clusterInstanceId).append("_main.yml\" ");
    stringBuilder.append("--vault-id /opt/ansible/seed  /opt/ansible/kerberos.yml  --tags deploy_keytab_in_allclient");
    return stringBuilder.toString();
  }
  
  private void operatePostProcess(ClusterInstanceOperateCommand clusterInstanceOperateReq) {
    if (StringUtils.equals(clusterInstanceOperateReq.getOperateType(), ClusterOperateTypeEnum.START.getName()))
      this.metaManagerService.registerInstance(clusterInstanceOperateReq.getClusterInstanceId()); 
    if (StringUtils.equals(clusterInstanceOperateReq.getOperateType(), ClusterOperateTypeEnum.UNINSTALL.getName()))
      this.metaManagerService.removeInstance(clusterInstanceOperateReq.getClusterInstanceId()); 
  }
  
  private void checkPrincipal(ClusterInstanceOperateCommand clusterInstanceOperateReq) {
    UserDetailsVo principal = UserUtil.getUserInfo();
    String resourceCode = ClusterInstanceOperateEnum.getResourceCode(clusterInstanceOperateReq.getOperateType());
    boolean b = principal.getResourceCodes().stream().anyMatch(s -> s.equals(resourceCode));
    ValidationException.validate(b, "没有权限操作");
  }
  
  @Transactional(isolation = Isolation.READ_COMMITTED, rollbackFor = {Exception.class})
  public String operateCallbackClusterInstance(ClusterInstanceOperateConfig clusterInstanceOperateConfig) {
    log.info("start exec cluster call back {}", JsonUtil.objectToJson(clusterInstanceOperateConfig));
    Integer clusterInstanceId = clusterInstanceOperateConfig.getClusterInstanceId();
    checkInstanceAuth(clusterInstanceId);
    String configGroupName = clusterInstanceOperateConfig.getConfigGroupName();
    TdpComponentType tdpComponentType = selectComponentTypeByClusterInstance(clusterInstanceId);
    TdpClusterEnv tdpClusterEnv = this.clusterEnvDao.getByClusterInstanceId(clusterInstanceId);
    String operateType = clusterInstanceOperateConfig.getOperateType();
    Map<String, List<String>> roleAndIps = clusterInstanceOperateConfig.getComponentRoleAndIpMap();
    CacheUtil.BaseCache baseCache = CacheUtil.getCache(CacheTypeEnum.GUAVA);
    log.info("role and ips {}", JsonUtil.objectToJson(roleAndIps));
    TdpClusterConfigVersion onlineConfigVersion = this.clusterConfigService.getOnlineConfigVersion(clusterInstanceId);
    if (StringUtils.equalsIgnoreCase(operateType, ClusterOperateTypeEnum.EXPANSION.getName())) {
      roleAndIps.forEach((componentRoleName, ips) -> {
            log.info("clusterInstanceId {} componentTypeName {} componentRoleName {}", new Object[] { clusterInstanceId, tdpComponentType.getName(), componentRoleName });
            TdpComponentRoleInstance tdpComponentRoleInstance = this.componentRoleService.getComponentRoleInstance(clusterInstanceId, tdpComponentType.getName(), componentRoleName);
            log.info("tdpComponentRoleInstance {}", JsonUtil.objectToJson(tdpComponentRoleInstance));
            if (Objects.isNull(tdpComponentRoleInstance))
              tdpComponentRoleInstance = this.componentRoleService.createComponentRoleInstance(clusterInstanceId, tdpComponentType.getName(), componentRoleName); 
            log.info("tdpComponentRoleInstance {}", JsonUtil.objectToJson(tdpComponentRoleInstance));
            Integer componentRoleInstanceId = tdpComponentRoleInstance.getId();
            ips.forEach(());
          });
      baseCache.removeCache(clusterInstanceId, ClusterOperateTypeEnum.EXPANSION);
    } 
    if (StringUtils.equalsIgnoreCase(operateType, ClusterOperateTypeEnum.SHRINK.getName())) {
      roleAndIps.forEach((componentRoleName, ips) -> {
            log.info("component role and ip {} {}", componentRoleName, ips);
            TdpComponentRoleInstance tdpComponentRoleInstance = this.componentRoleService.getComponentRoleInstance(clusterInstanceId, tdpComponentType.getName(), componentRoleName);
            log.info("tdpComponentRoleInstance {} ", JsonUtil.objectToJson(tdpComponentRoleInstance));
            ips.forEach(());
            log.info("delete config group");
            ips.forEach(());
          });
      baseCache.removeCache(clusterInstanceId, ClusterOperateTypeEnum.SHRINK);
    } 
    List<String> allIps = (List<String>)roleAndIps.values().stream().flatMap(Collection::stream).collect(Collectors.toList());
    allIps.forEach(oneIp -> {
          TdpHost tdpHost = this.hostService.selectHostByEnvIdAndIp(tdpClusterEnv.getId(), oneIp);
          List<TdpComponentRoleInstanceHost> tdpComponentRoleInstanceHostList = this.componentRoleInstanceHostService.selectComponentRoleInstanceHostByHostId(tdpHost.getId());
          HostStatusEnum hostStatusEnum = CollectionUtils.isEmpty(tdpComponentRoleInstanceHostList) ? HostStatusEnum.UNUSED : HostStatusEnum.USED;
          log.info("update host status {} {}", JsonUtil.objectToJson(tdpHost), hostStatusEnum.getIndex());
          tdpHost.setStatus(hostStatusEnum.getIndex());
          this.hostDao.updateByPrimaryKey(tdpHost);
        });
    return "";
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public Map<String, String> initConfigClusterInstance(InitConfigClusterInstanceQuery initConfigClusterInstanceQuery) {
    Integer clusterInstanceId = initConfigClusterInstanceQuery.getClusterInstanceId();
    checkInstanceAuth(clusterInstanceId);
    checkStep(initConfigClusterInstanceQuery, clusterInstanceId);
    Date date = new Date();
    TdpComponentType tdpComponentType = selectComponentTypeByClusterInstance(clusterInstanceId);
    ClusterInstanceRmi clusterInstanceRmi = this.rmiService.getClusterInstanceRmi(clusterInstanceId);
    Map<String, String> configFileContentMap = clusterInstanceRmi.getClusterInstanceAllConfig(clusterInstanceId, tdpComponentType.getName());
    log.info("config file and content {}", JsonUtil.objectToJson(configFileContentMap));
    if (Objects.isNull(configFileContentMap) || configFileContentMap.isEmpty()) {
      log.error("init config fail");
      throw new ClusterInstanceException("初始化配置失败");
    } 
    log.info("delete cluster config {}", clusterInstanceId);
    this.clusterConfigService.deleteInstanceConfig(clusterInstanceId);
    log.info("create init config version {}", clusterInstanceId);
    TdpClusterConfigVersion tdpClusterConfigVersion = new TdpClusterConfigVersion();
    tdpClusterConfigVersion.setClusterInstanceId(clusterInstanceId);
    tdpClusterConfigVersion.setConfigVersion("v-1.0");
    tdpClusterConfigVersion.setIsOnline(ConfigVersionOnlineEnum.ONLINE.getOnlineStatus());
    tdpClusterConfigVersion.setCreateTime(date);
    tdpClusterConfigVersion.setUpdateTime(date);
    this.clusterConfigVersionMapper.save(tdpClusterConfigVersion);
    TdpClusterConfigGroup tdpClusterConfigGroup = new TdpClusterConfigGroup();
    tdpClusterConfigGroup.setConfigVersionId(tdpClusterConfigVersion.getId());
    tdpClusterConfigGroup.setConfigGroupName("group1");
    tdpClusterConfigGroup.setCreateTime(date);
    tdpClusterConfigGroup.setUpdateTime(date);
    this.clusterConfigGroupMapper.save(tdpClusterConfigGroup);
    Map<String, String> map = new HashMap<>();
    configFileContentMap.forEach((key, value) -> {
          TdpClusterConfig tdpClusterConfig = new TdpClusterConfig();
          tdpClusterConfig.setConfigGroupId(tdpClusterConfigGroup.getId());
          tdpClusterConfig.setFileName(key);
          tdpClusterConfig.setFileContent(value);
          tdpClusterConfig.setCreateTime(date);
          tdpClusterConfig.setUpdateTime(date);
          this.clusterConfigMapper.save(tdpClusterConfig);
        });
    List<TdpHost> tdpHostList = this.tdpClusterInstanceMapper.searchClusterInstanceHosts(clusterInstanceId);
    tdpHostList.forEach(tdpHost -> {
          TdpClusterConfigGroupHost tdpClusterConfigGroupHost = new TdpClusterConfigGroupHost();
          tdpClusterConfigGroupHost.setConfigGroupId(tdpClusterConfigGroup.getId());
          tdpClusterConfigGroupHost.setHostId(tdpHost.getId());
          tdpClusterConfigGroupHost.setCreateTime(date);
          tdpClusterConfigGroupHost.setUpdateTime(date);
          this.clusterConfigGroupHostMapper.save(tdpClusterConfigGroupHost);
        });
    this.clusterConfigService.createClusterConfigStatus(clusterInstanceId, tdpClusterConfigVersion.getId(), Integer.valueOf(ConfigTakeAffectStateEnum.TAKE_AFFECT.getCode()));
    TdpClusterInstance tdpClusterInstance = new TdpClusterInstance();
    tdpClusterInstance.setId(clusterInstanceId);
    tdpClusterInstance.setOnlineStatus(ClusterOperateButtonOnlineEnum.ONLINE.getStatus());
    this.clusterInstanceDao.update(tdpClusterInstance);
    return map;
  }
  
  private void checkStep(InitConfigClusterInstanceQuery initConfigClusterInstanceQuery, Integer clusterInstanceId) {
    String componentType = initConfigClusterInstanceQuery.getComponentType();
    if (ComponentTypeEnum.BIGDATA.getCode().equals(componentType)) {
      List<TdpClusterOperateStep> tdpClusterOperateSteps = this.clusterOperateStepDao.listObjects(clusterInstanceId);
      if (CollectionUtils.isEmpty(tdpClusterOperateSteps))
        return; 
      TdpClusterOperateStep tdpClusterOperateStep = tdpClusterOperateSteps.get(0);
      ValidationException.validate(Objects.nonNull(tdpClusterOperateStep), "集群必要操作未执行");
      boolean flag = (ClusterOperateStepStatusEnum.DONE.getStatus().equals(tdpClusterOperateStep.getStatus()) && ClusterOperateStepEnum.CHOOSE_HOST.getStep().equals(tdpClusterOperateStep.getStep()));
      ValidationException.validate(flag, "集群操作请执行选择主机");
    } else {
      List<TdpClusterOperateStep> tdpClusterOperateSteps = this.clusterOperateStepDao.listObjects(clusterInstanceId);
      ValidationException.validate((CollectionUtils.size(tdpClusterOperateSteps) == 2), "集群操作步骤请全部执行");
      TdpClusterOperateStep operateStepChooseHost = tdpClusterOperateSteps.stream().filter(operateStep -> (ClusterOperateStepEnum.CHOOSE_HOST.getStep().equals(operateStep.getStep()) && ClusterOperateStepStatusEnum.DONE.getStatus().equals(operateStep.getStatus()))).findFirst().orElse(null);
      TdpClusterOperateStep operateStepUploadJar = tdpClusterOperateSteps.stream().filter(operateStep -> (ClusterOperateStepEnum.UPLOAD_JAR.getStep().equals(operateStep.getStep()) && ClusterOperateStepStatusEnum.DONE.getStatus().equals(operateStep.getStatus()))).findFirst().orElse(null);
      ValidationException.validate(Objects.nonNull(operateStepChooseHost), "请进行绑定主机操作");
      ValidationException.validate(Objects.nonNull(operateStepUploadJar), "请进行上传JAR包操作");
    } 
  }
  
  private void hiddenButton(Integer clusterInstanceId) {
    List<String> buttons = Lists.newArrayList(new String[] { ClusterOperateTypeEnum.INSTALL
          .getName(), ClusterOperateTypeEnum.RE_CONFIG
          .getName(), ClusterOperateTypeEnum.UNINSTALL
          .getName() });
    this.clusterOperateButtonDao.hiddenButtons(clusterInstanceId, buttons);
  }
  
  private void showButton(Integer clusterInstanceId) {
    List<String> buttons = Lists.newArrayList(new String[] { ClusterOperateTypeEnum.INSTALL
          .getName(), ClusterOperateTypeEnum.RE_CONFIG
          .getName(), ClusterOperateTypeEnum.UNINSTALL
          .getName() });
    this.clusterOperateButtonDao.showButtons(clusterInstanceId, buttons);
  }
  
  public Boolean isHiddenButton(Integer clusterInstanceId) {
    List<String> buttons = Lists.newArrayList(new String[] { ClusterOperateTypeEnum.INSTALL
          .getName(), ClusterOperateTypeEnum.RE_CONFIG
          .getName(), ClusterOperateTypeEnum.UNINSTALL
          .getName() });
    return this.clusterOperateButtonDao.isHiddenButton(clusterInstanceId, buttons);
  }
  
  @LogDisplay
  public Integer isInitConfigClusterInstance(Integer clusterInstanceId) {
    checkInstanceEnvReadAuth(clusterInstanceId);
    TdpClusterConfigVersion initConfigVersion = this.clusterConfigService.getConfigVersionByVersionName(clusterInstanceId, "v-1.0");
    if (Objects.nonNull(initConfigVersion)) {
      List<TdpClusterConfigGroup> tdpClusterConfigGroupList = this.clusterConfigService.getAllConfigGroupInVersion(initConfigVersion.getId());
      for (TdpClusterConfigGroup tdpClusterConfigGroup : tdpClusterConfigGroupList) {
        List<TdpClusterConfig> tdpClusterConfigList = this.clusterConfigService.getConfigByGroupId(tdpClusterConfigGroup.getId());
        if (CollectionUtils.isNotEmpty(tdpClusterConfigList))
          return Integer.valueOf(1); 
      } 
    } 
    return Integer.valueOf(0);
  }
  
  @LogDisplay
  public void checkConfigGroup(Integer clusterConfigGroupId) {
    List<TdpClusterConfig> tdpClusterConfigList = this.clusterConfigService.getAllConfigByConfigGroupId(clusterConfigGroupId, "");
    if (CollectionUtils.isEmpty(tdpClusterConfigList)) {
      String message = "no config in config group";
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    List<TdpClusterConfigGroupHost> tdpClusterConfigGroupHostList = this.clusterConfigService.getAllConfigGroupAndHostByGroupId(clusterConfigGroupId);
    if (CollectionUtils.isEmpty(tdpClusterConfigGroupHostList)) {
      String message = "no host in config group";
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
  }
  
  @LogDisplay
  public void temporaryConfigClusterInstance(Integer clusterInstanceId) {
    checkInstanceEnvOperateAuth(clusterInstanceId);
    checkInstanceAuth(clusterInstanceId);
    createTemporaryVersion(clusterInstanceId);
  }
  
  @LogDisplay
  public LogData getLogClusterInstance(Integer clusterInstanceId, int currentLineNumber) {
    checkInstanceEnvReadAuth(clusterInstanceId);
    ClusterInstanceRmi clusterInstanceRmi = this.rmiService.getClusterInstanceRmi(clusterInstanceId);
    return clusterInstanceRmi.getClusterInstanceLog(clusterInstanceId, Integer.valueOf(currentLineNumber));
  }
  
  @LogDisplay
  public ClusterTaskStatusEnum getRunStatusClusterInstance(Integer clusterInstanceId) {
    checkInstanceEnvReadAuth(clusterInstanceId);
    TaskStatusEnum taskStatusEnum = this.taskService.getTaskStatus(ProjectModuleEnum.CLUSTER, clusterInstanceId);
    if (Objects.isNull(taskStatusEnum) || TaskStatusEnum.FINISHED.equals(taskStatusEnum) || TaskStatusEnum.FAILED
      .equals(taskStatusEnum))
      return ClusterTaskStatusEnum.DONE; 
    return ClusterTaskStatusEnum.DOING;
  }
  
  public ClusterTaskStatusEnum getStatusClusterInstance(Integer clusterInstanceId, Boolean isTerminate) {
    checkInstanceEnvReadAuth(clusterInstanceId);
    TdpTask tdpTask = this.taskService.queryTaskStatus(ProjectModuleEnum.CLUSTER, clusterInstanceId);
    String status = tdpTask.getStatus();
    if (isTerminate.booleanValue() && TaskStatusEnum.RUNNING.getName().equals(status)) {
      tdpTask.setStatus("failed");
      tdpTask.setUpdateTime(new Date());
      this.taskService.updateTask(tdpTask);
      return ClusterTaskStatusEnum.DONE;
    } 
    TaskStatusEnum taskStatusEnum = this.taskService.getTaskStatus(ProjectModuleEnum.CLUSTER, clusterInstanceId);
    if (Objects.isNull(taskStatusEnum) || TaskStatusEnum.FINISHED.equals(taskStatusEnum) || TaskStatusEnum.FAILED
      .equals(taskStatusEnum))
      return ClusterTaskStatusEnum.DONE; 
    return ClusterTaskStatusEnum.DOING;
  }
  
  @LogDisplay
  public String checkRunStatusClusterInstance(Integer clusterInstanceId) {
    ClusterTaskStatusEnum clusterTaskStatusEnum = getRunStatusClusterInstance(clusterInstanceId);
    log.info("cluster task status {}", clusterTaskStatusEnum);
    if (Objects.equals(clusterTaskStatusEnum, ClusterTaskStatusEnum.DOING)) {
      TdpClusterInstance clusterInstance = this.clusterInstanceDao.getById(clusterInstanceId);
      String message = String.format("集群 %s 有任务正在运行中", new Object[] { clusterInstance.getNameZh() });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    return "";
  }
  
  public String checkClusterStatus(Integer clusterInstanceId, Boolean isTerminate) {
    ClusterTaskStatusEnum clusterTaskStatusEnum = getStatusClusterInstance(clusterInstanceId, isTerminate);
    log.info("cluster task status {}", clusterTaskStatusEnum);
    if (Objects.equals(clusterTaskStatusEnum, ClusterTaskStatusEnum.DOING)) {
      TdpClusterInstance clusterInstance = this.clusterInstanceDao.getById(clusterInstanceId);
      String message = String.format("集群 %s 有任务正在运行中", new Object[] { clusterInstance.getNameZh() });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    return "";
  }
  
  @LogDisplay
  public RoleAndHostVo roleAndHostClusterInstance(Integer clusterEnvId, Integer clusterInstanceId, String componentRoleName, String ip, Integer current, Integer size) {
    AuthUtil.checkEnvReadAuth(clusterEnvId);
    checkDeploymentMethod(clusterInstanceId);
    List<TdpClusterConfigVersion> clusterConfigVersionList = this.clusterConfigService.getAllConfigVersion(clusterInstanceId);
    if (CollectionUtils.isEmpty(clusterConfigVersionList))
      return RoleAndHostVo.builder().build(); 
    TdpClusterConfigVersion oneLineConfigVersion = this.clusterConfigService.getOnlineConfigVersion(clusterInstanceId);
    ValidationException.validate((oneLineConfigVersion != null), "no online config version");
    TdpClusterInstance clusterInstance = this.clusterInstanceDao.getById(clusterInstanceId);
    ValidationException.validate((clusterInstance != null), "cluster instance must be null");
    TdpComponentType tdpComponentType = this.componentTypeService.getComponentTypeByClusterInstanceId(clusterInstanceId);
    List<TdpComponentRole> tdpComponentRoleList = this.tdpClusterInstanceMapper.searchClusterInstanceRoleNames(clusterInstanceId);
    PageVo<RoleAndHostVo.RoleAndHost> pageVo = new PageVo();
    if (StringUtils.isNotEmpty(componentRoleName)) {
      List<InstanceMonitorVO> monitorList = this.clusterInstanceMonitorCache.getMonitor(clusterInstance.getClusterEnvId(), clusterInstance.getId());
      PageHelper.startPage(current.intValue(), size.intValue());
      List<ClusterInstanceServiceVo> clusterInstanceServiceVoList = this.tdpClusterInstanceMapper.searchClusterInstanceService(clusterInstanceId, ip, clusterInstance.getClusterEnvId(), componentRoleName);
      log.info("clusterInstanceServiceVoList {}", JsonUtil.objectToJson(clusterInstanceServiceVoList));
      List<Integer> componentRoleInstanceHostIds = (List<Integer>)clusterInstanceServiceVoList.stream().map(clusterInstanceServiceVo -> clusterInstanceServiceVo.getComponentRoleInstanceHostId()).collect(Collectors.toList());
      log.info("componentRoleInstanceHostIds {}", JsonUtil.objectToJson(componentRoleInstanceHostIds));
      List<TdpComponentRoleInstanceHostStatus> tdpComponentRoleInstanceHostStatus = this.componentRoleInstanceHostStatusDao.listBycomponentRoleInstanceHostId(componentRoleInstanceHostIds);
      if (CollectionUtils.isNotEmpty(tdpComponentRoleInstanceHostStatus)) {
        Map<Integer, TdpComponentRoleInstanceHostStatus> componentRoleInstanceHostStatusMap = (Map<Integer, TdpComponentRoleInstanceHostStatus>)tdpComponentRoleInstanceHostStatus.stream().collect(Collectors.toMap(TdpComponentRoleInstanceHostStatus::getComponentRoleInstanceHostId, Function.identity()));
        log.info("componentRoleInstanceHostStatusMap {}", JsonUtil.objectToJson(componentRoleInstanceHostStatusMap));
        fillRebalanceStatus(componentRoleInstanceHostStatusMap, clusterInstanceServiceVoList);
      } 
      PageInfo<ClusterInstanceServiceVo> firstPageInfo = new PageInfo(clusterInstanceServiceVoList);
      log.info("clusterInstanceServiceVoList {}", JsonUtil.objectToJson(clusterInstanceServiceVoList));
      List<Integer> hostIds = (List<Integer>)clusterInstanceServiceVoList.stream().map(ClusterInstanceServiceVo::getId).distinct().collect(Collectors.toList());
      List<ClusterConfigVersionAndGroupVo> clusterConfigVersionAndGroupVoList = this.clusterConfigService.getConfigGroupAndHostDetail(oneLineConfigVersion.getId(), hostIds);
      log.info("clusterConfigVersionAndGroupVoList {}", JsonUtil.objectToJson(clusterConfigVersionAndGroupVoList));
      Map<Integer, ClusterConfigVersionAndGroupVo> configVersionAndGroupVoMap = (Map<Integer, ClusterConfigVersionAndGroupVo>)clusterConfigVersionAndGroupVoList.stream().collect(Collectors.toMap(ClusterConfigVersionAndGroupVo::getHostId, Function.identity(), (e1, e2) -> e1));
      log.info("configVersionAndGroupVoMap {}", JsonUtil.objectToJson(configVersionAndGroupVoMap));
      List<RoleAndHostVo.RoleAndHost> roleAndHostList = (List<RoleAndHostVo.RoleAndHost>)clusterInstanceServiceVoList.stream().map(item -> convertRoleAndHostVo(item, configVersionAndGroupVoMap, oneLineConfigVersion)).collect(Collectors.toList());
      log.info("roleAndHostList {}", JsonUtil.objectToJson(roleAndHostList));
      PageInfo<RoleAndHostVo.RoleAndHost> pageInfo = new PageInfo(roleAndHostList);
      BeanUtils.copyProperties(pageInfo, pageVo);
      pageVo.setTotal(firstPageInfo.getTotal());
      pageVo.setData(pageInfo.getList());
      fillServiceMonitorStatus(pageVo.getData(), clusterInstanceId, componentRoleName, monitorList);
      fillConfigTakeStatus(pageVo.getData(), oneLineConfigVersion);
    } 
    TdpClusterInstance instance = this.clusterInstanceDao.getById(clusterInstanceId);
    TdpClusterEnv clusterEnv = this.clusterEnvDao.getById(instance.getClusterEnvId());
    List<InstanceMonitorVO> monitor = this.clusterInstanceMonitorCache.getMonitor(clusterEnv.getId(), clusterInstanceId);
    Map<String, List<InstanceMonitorVO>> monitorMap = (Map<String, List<InstanceMonitorVO>>)monitor.stream().collect(Collectors.groupingBy(InstanceMonitorVO::getRoleName));
    List<RoleAndHostVo.Role> roles = (List<RoleAndHostVo.Role>)tdpComponentRoleList.stream().map(tdpComponentRole -> {
          RoleAndHostVo.Role role = new RoleAndHostVo.Role();
          role.setRoleId(tdpComponentRole.getId());
          role.setRoleName(tdpComponentRole.getName());
          String roleName = RoleNameConvert.getRoleName(tdpComponentRole.getName());
          role.setRoleStatus(findRoleStatus((List<InstanceMonitorVO>)monitorMap.get(roleName)));
          return role;
        }).collect(Collectors.toList());
    return RoleAndHostVo.builder()
      .componentType(tdpComponentType.getName())
      .currentRoleName(componentRoleName)
      .roleList(roles)
      .roleAndHostList(pageVo)
      .build();
  }
  
  private String findRoleStatus(List<InstanceMonitorVO> monitorInfoVOS) {
    if (CollectionUtils.isEmpty(monitorInfoVOS))
      return null; 
    Set<String> statusSet = (Set<String>)monitorInfoVOS.stream().map(InstanceMonitorVO::getStatus).collect(Collectors.toSet());
    return statusSet.contains("abnormal") ? "abnormal" : "normal";
  }
  
  private void fillRebalanceStatus(Map<Integer, TdpComponentRoleInstanceHostStatus> componentRoleInstanceHostStatusMap, List<ClusterInstanceServiceVo> clusterInstanceServiceVoList) {
    clusterInstanceServiceVoList.stream().forEach(clusterInstanceService -> {
          TdpComponentRoleInstanceHostStatus tdpComponentRoleInstanceHostStatus = (TdpComponentRoleInstanceHostStatus)componentRoleInstanceHostStatusMap.get(clusterInstanceService.getComponentRoleInstanceHostId());
          clusterInstanceService.setRebalanceStatus(Objects.nonNull(tdpComponentRoleInstanceHostStatus) ? tdpComponentRoleInstanceHostStatus.getRebalanceStatus() : null);
        });
  }
  
  private void checkDeploymentMethod(Integer clusterInstanceId) {
    Integer deployType = this.clusterInstanceDao.getDeployType(clusterInstanceId);
    if (deployType.equals(TypeEnum.COMPONENT_CONTAINER.getCode())) {
      String message = String.format("集群部署方式为容器不支持此操作", new Object[0]);
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
  }
  
  private void fillConfigTakeStatus(List<RoleAndHostVo.RoleAndHost> data, TdpClusterConfigVersion oneLineConfigVersion) {
    if (oneLineConfigVersion == null)
      return; 
    if (CollectionUtils.isEmpty(data))
      return; 
    Set<Integer> componentRoleInstanceIds = (Set<Integer>)data.stream().map(RoleAndHostVo.RoleAndHost::getComponentRoleInstanceId).collect(Collectors.toSet());
    Map<Integer, RoleAndHostVo.RoleAndHost> map = (Map<Integer, RoleAndHostVo.RoleAndHost>)data.stream().collect(Collectors.toMap(RoleAndHostVo.RoleAndHost::getHostId, Function.identity(), (e1, e2) -> e1));
    List<TdpClusterConfigStatus> takeStatus = this.clusterConfigStatusDao.getClusterConfigStatus(componentRoleInstanceIds, oneLineConfigVersion.getId(), map.keySet());
    Map<String, TdpClusterConfigStatus> statusMap = (Map<String, TdpClusterConfigStatus>)takeStatus.stream().collect(Collectors.toMap(TdpClusterConfigStatus::buildKey, Function.identity(), (e1, e2) -> e1));
    data.forEach(item -> {
          TdpClusterConfigStatus status = (TdpClusterConfigStatus)statusMap.get(item.buildKey());
          if (status != null)
            item.setTakeAffectStatus(status.getTakeAffectStatus()); 
        });
  }
  
  private RoleAndHostVo.RoleAndHost convertRoleAndHostVo(ClusterInstanceServiceVo oneClusterInstanceServiceVo, Map<Integer, ClusterConfigVersionAndGroupVo> configVersionAndGroupVoMap, TdpClusterConfigVersion oneLineConfigVersion) {
    String configStatus;
    ClusterConfigVersionAndGroupVo clusterConfigVersionAndGroupVo = configVersionAndGroupVoMap.get(oneClusterInstanceServiceVo.getId());
    log.info("clusterConfigVersionAndGroupVo {}", JsonUtil.objectToJson(clusterConfigVersionAndGroupVo));
    if (Objects.isNull(clusterConfigVersionAndGroupVo)) {
      configStatus = "";
    } else {
      configStatus = String.format("%s-%s", new Object[] { oneLineConfigVersion.getConfigVersion(), clusterConfigVersionAndGroupVo.getConfigGroupName() });
    } 
    return RoleAndHostVo.RoleAndHost.builder()
      .hostId(oneClusterInstanceServiceVo.getId())
      .componentRoleInstanceId(oneClusterInstanceServiceVo.getComponentRoleInstanceId())
      .componentRoleInstanceHostId(oneClusterInstanceServiceVo.getComponentRoleInstanceHostId())
      .ip(oneClusterInstanceServiceVo.getIp())
      .serviceStatus("")
      .configStatus(configStatus)
      .takeAffectStatus(null)
      .rebalanceStatus(oneClusterInstanceServiceVo.getRebalanceStatus())
      .migrate(oneClusterInstanceServiceVo.getMigrate())
      .build();
  }
  
  private void fillServiceMonitorStatus(List<RoleAndHostVo.RoleAndHost> list, Integer clusterInstanceId, String roleName, List<InstanceMonitorVO> monitorList) {
    Map<String, InstanceMonitorVO> infoVOMap = (Map<String, InstanceMonitorVO>)monitorList.stream().filter(item -> Objects.nonNull(item.getIpAddr())).collect(Collectors.toMap(InstanceMonitorVO::getIpAddr, Function.identity(), (e1, e2) -> e1));
    list.forEach(item -> {
          InstanceMonitorVO infoVO = (InstanceMonitorVO)infoVOMap.get(item.getIp());
          if (infoVO == null)
            return; 
          item.setServiceStatus(infoVO.getStatus());
        });
  }
  
  @LogDisplay
  public PageVo<HostExpansionVo> hostExpansionClusterInstance(HostExpansionShrinkQuery hostExpansionQuery) {
    TdpClusterEnv tdpClusterEnv = this.clusterEnvDao.getByClusterInstanceId(hostExpansionQuery.getClusterInstanceId());
    if (Objects.isNull(tdpClusterEnv)) {
      String message = String.format("cluster %s no env", new Object[] { hostExpansionQuery.getClusterInstanceId() });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    AuthUtil.checkEnvReadAuth(tdpClusterEnv.getId());
    Integer size = hostExpansionQuery.getSize();
    Integer current = hostExpansionQuery.getCurrent();
    Integer clusterInstanceId = hostExpansionQuery.getClusterInstanceId();
    Integer componentRoleId = hostExpansionQuery.getComponentRoleId();
    PageVo<HostExpansionVo> pageVo = new PageVo();
    List<TdpHostConfig> configLists = this.hostConfigDao.getHostConfigList(hostExpansionQuery.getSearchHostQueryExternal());
    List<Integer> hostConfigIds = new ArrayList<>();
    if (!hostExpansionQuery.getSearchHostQueryExternal().isEmpty()) {
      if (CollectionUtils.isEmpty(configLists))
        return pageVo; 
      hostConfigIds = (List<Integer>)configLists.stream().map(TdpHostConfig::getId).collect(Collectors.toList());
    } 
    HostExpansionVO hostExpansionVO = new HostExpansionVO();
    hostExpansionVO.setClusterEnvId(tdpClusterEnv.getId());
    hostExpansionVO.setInnerIpKeyWords(hostExpansionQuery.getInnerIpKeyWords());
    hostExpansionVO.setConfigIds(hostConfigIds);
    List<TdpHost> roleBindHosts = roleBindHostId(clusterInstanceId, componentRoleId);
    if (!CollectionUtils.isEmpty(roleBindHosts))
      hostExpansionVO.setHostIds((List)roleBindHosts.stream().map(TdpHost::getId).collect(Collectors.toList())); 
    PageHelper.startPage(current.intValue(), size.intValue());
    List<TdpHost> tdpHosts = this.hostDao.ListByHostExpansionVO(hostExpansionVO);
    PageInfo<TdpHost> pageInfo = new PageInfo(tdpHosts);
    Map<Integer, TdpHostConfig> tdpHostConfigMap = (Map<Integer, TdpHostConfig>)configLists.stream().collect(Collectors.toMap(TdpHostConfig::getId, config -> config));
    List<String> innerIps = (List<String>)tdpHosts.stream().map(TdpHost::getInnerIp).collect(Collectors.toList());
    Map<String, String> runtimeStatus = this.hostRuntimeStatusHandler.getRuntimeStatus(hostExpansionQuery.getClusterEnvId(), innerIps);
    tdpHosts = HostUtil.setRackDefault(tdpHosts);
    List<HostExpansionVo> hostExpansionVoList = HostExpansionVo.assemble(tdpHosts, tdpHostConfigMap, runtimeStatus, tdpClusterEnv.getName());
    CacheUtil.BaseCache baseCache = CacheUtil.getCache(CacheTypeEnum.GUAVA);
    List<CacheUtil.SelectedHostVO> selectedHostVOList = baseCache.getCache(hostExpansionQuery.getClusterInstanceId(), hostExpansionQuery.getComponentRoleName(), ClusterOperateTypeEnum.EXPANSION);
    List<Integer> selectedHostIdList = (List<Integer>)selectedHostVOList.stream().map(CacheUtil.SelectedHostVO::getHostId).collect(Collectors.toList());
    hostExpansionVoList.forEach(oneHostExpansionVo -> {
          if (selectedHostIdList.contains(oneHostExpansionVo.getId()))
            oneHostExpansionVo.setHostSelectedStatus(HostSelectedStatusEnum.SELECTED.getChecked()); 
          oneHostExpansionVo.setHostRuntimeStatus((String)runtimeStatus.get(oneHostExpansionVo.getInnerIp()));
        });
    pageVo.setPageNum(current.intValue());
    pageVo.setPageSize(size.intValue());
    pageVo.setTotal(pageInfo.getTotal());
    pageVo.setSize(pageInfo.getSize());
    pageVo.setData(hostExpansionVoList);
    return pageVo;
  }
  
  private List<TdpHost> getNotBindHosts(HostExpansionShrinkQuery hostExpansionQuery) {
    HostSearchVO hostSearchVO = new HostSearchVO();
    hostSearchVO.setInnerIpKeyWords(hostExpansionQuery.getInnerIpKeyWords());
    hostSearchVO.setClusterInstanceId(hostExpansionQuery.getClusterInstanceId());
    hostSearchVO.setClusterEnvId(hostExpansionQuery.getClusterEnvId());
    List<TdpHost> hosts = this.hostDao.searchHostsBySearchVO(hostSearchVO, hostSearchVO.getClusterEnvId());
    if (CollectionUtils.isEmpty(hosts))
      return new ArrayList<>(); 
    Integer clusterInstanceId = hostExpansionQuery.getClusterInstanceId();
    Integer componentRoleId = hostExpansionQuery.getComponentRoleId();
    List<TdpHost> roleBindHosts = roleBindHostId(clusterInstanceId, componentRoleId);
    if (CollectionUtils.isEmpty(roleBindHosts))
      return hosts; 
    List<Integer> roleBindHostIds = (List<Integer>)roleBindHosts.stream().map(TdpHost::getId).collect(Collectors.toList());
    return (List<TdpHost>)hosts.stream().filter(host -> !roleBindHostIds.contains(host.getId())).collect(Collectors.toList());
  }
  
  private List<TdpHost> roleBindHostId(Integer clusterInstanceId, Integer componentRoleId) {
    TdpComponentTypeInstance componentTypeInstance = this.componentTypeInstanceDao.getByClusterInstanceId(clusterInstanceId);
    TdpComponentRoleInstance roleInstance = this.componentRoleInstanceDao.getObjectByRoleId(componentRoleId, componentTypeInstance.getId());
    if (Objects.isNull(roleInstance))
      return Lists.newArrayList(); 
    List<TdpComponentRoleInstanceHost> roleInstanceHosts = this.componentRoleInstanceHostDao.getByRoleInstanceId(roleInstance.getId());
    return this.hostDao.listByIds((Set)roleInstanceHosts.stream().map(TdpComponentRoleInstanceHost::getHostId).collect(Collectors.toSet()));
  }
  
  @LogDisplay
  public String hostExpansionSaveClusterInstance(HostExpansionSaveReq hostExpansionSaveReq) {
    checkInstanceAuth(hostExpansionSaveReq.getClusterInstanceId());
    hostExpansionSaveReq.validate();
    CacheUtil.BaseCache baseCache = CacheUtil.getCache(CacheTypeEnum.GUAVA);
    Integer hostId = hostExpansionSaveReq.getHostId();
    List<CacheUtil.SelectedHostVO> cacheList = baseCache.getCache(hostExpansionSaveReq.getClusterInstanceId(), hostExpansionSaveReq
        .getComponentRoleName(), ClusterOperateTypeEnum.EXPANSION);
    List<Integer> hostIdList = new ArrayList<>();
    Boolean promoteFlag = getListAndPromoteFlag(hostId, cacheList, hostIdList);
    List<CacheUtil.SelectedHostVO> selectedHostVOList = (List<CacheUtil.SelectedHostVO>)hostIdList.stream().map(oneHostId -> CacheUtil.SelectedHostVO.builder().hostId(oneHostId).clusterInstanceId(hostExpansionSaveReq.getClusterInstanceId()).componentRoleName(hostExpansionSaveReq.getComponentRoleName()).build()).collect(Collectors.toList());
    baseCache.writeCache(hostExpansionSaveReq.getClusterInstanceId(), hostExpansionSaveReq
        .getComponentRoleName(), ClusterOperateTypeEnum.EXPANSION, selectedHostVOList);
    if (Boolean.TRUE.equals(promoteFlag))
      return "绑定成功"; 
    return "取消成功";
  }
  
  private Boolean getListAndPromoteFlag(Integer hostId, List<CacheUtil.SelectedHostVO> cacheList, List<Integer> hostIdList) {
    boolean promoteFlag;
    log.info("原缓存中数据：{}", JSONObject.toJSONString(cacheList, new com.alibaba.fastjson2.JSONWriter.Feature[0]));
    List<Integer> collect = (List<Integer>)cacheList.stream().map(CacheUtil.SelectedHostVO::getHostId).collect(Collectors.toList());
    if (CollectionUtils.isEmpty(cacheList)) {
      promoteFlag = true;
      hostIdList.add(hostId);
    } else if (collect.contains(hostId)) {
      promoteFlag = false;
      List<Integer> collect1 = (List<Integer>)collect.stream().filter(s -> !s.equals(hostId)).collect(Collectors.toList());
      hostIdList.addAll(collect1);
    } else {
      hostIdList.addAll(collect);
      hostIdList.add(hostId);
      promoteFlag = true;
    } 
    log.info("即将保存到缓存中数据：{}", JSONObject.toJSONString(hostIdList, new com.alibaba.fastjson2.JSONWriter.Feature[0]));
    return Boolean.valueOf(promoteFlag);
  }
  
  @LogDisplay
  public List<HostExpansionVo> hostExpansionGetClusterInstance(Integer clusterEnvId, Integer clusterInstanceId) {
    AuthUtil.checkEnvReadAuth(clusterEnvId);
    TdpComponentType tdpComponentType = this.componentTypeService.getComponentTypeByClusterInstanceId(clusterInstanceId);
    List<TdpComponentRole> tdpComponentRoleList = this.componentRoleService.selectComponentRole(tdpComponentType.getId());
    CacheUtil.BaseCache baseCache = CacheUtil.getCache(CacheTypeEnum.GUAVA);
    Map<String, String> runtimeStatus = this.hostRuntimeStatusHandler.getRuntimeStatus(clusterEnvId);
    ImmutableList.Builder<HostExpansionVo> builder = ImmutableList.builder();
    tdpComponentRoleList.forEach(oneTdpComponentRole -> {
          List<CacheUtil.SelectedHostVO> selectedHostVOList = baseCache.getCache(clusterInstanceId, oneTdpComponentRole.getName(), ClusterOperateTypeEnum.EXPANSION);
          List<Integer> hostIds = (List<Integer>)selectedHostVOList.stream().map(CacheUtil.SelectedHostVO::getHostId).collect(Collectors.toList());
          List<TdpHost> hostList = this.hostService.selectHostByIds(hostIds);
          hostList = HostUtil.setRackDefault(hostList);
          List<HostExpansionVo> hostExpansionVoList = (List<HostExpansionVo>)hostList.stream().map(()).collect(Collectors.toList());
          builder.addAll(hostExpansionVoList);
        });
    return builder.build();
  }
  
  @LogDisplay
  public PageVo<HostShrinkVo> hostShrinkClusterInstance(HostExpansionShrinkQuery hostExpansionShrinkQuery) {
    String componentRoleName = hostExpansionShrinkQuery.getComponentRoleName();
    Integer clusterInstanceId = hostExpansionShrinkQuery.getClusterInstanceId();
    Integer current = hostExpansionShrinkQuery.getCurrent();
    Integer size = hostExpansionShrinkQuery.getSize();
    checkInstanceEnvReadAuth(clusterInstanceId);
    TdpClusterEnv tdpClusterEnv = this.clusterEnvDao.getByClusterInstanceId(clusterInstanceId);
    if (Objects.isNull(tdpClusterEnv)) {
      String message = String.format("cluster %s no env", new Object[] { clusterInstanceId });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    PageVo<HostShrinkVo> pageVo = new PageVo();
    List<Integer> hostConfigIds = new ArrayList<>();
    List<TdpHostConfig> configList = this.hostConfigDao.getHostConfigList(hostExpansionShrinkQuery.getSearchHostQueryExternal());
    log.info("高级查询主机配置信息:{}", JSONObject.toJSONString(configList, new com.alibaba.fastjson2.JSONWriter.Feature[0]));
    if (!hostExpansionShrinkQuery.getSearchHostQueryExternal().isEmpty()) {
      if (CollectionUtils.isEmpty(configList))
        return pageVo; 
      hostConfigIds = (List<Integer>)configList.stream().map(TdpHostConfig::getId).collect(Collectors.toList());
    } 
    List<TdpHost> roleBindHosts = roleBindHostId(clusterInstanceId, hostExpansionShrinkQuery.getComponentRoleId());
    if (CollectionUtils.isEmpty(roleBindHosts))
      return new PageVo(); 
    log.info("角色已经绑定的主机所有主机:{}", JSONObject.toJSONString(roleBindHosts, new com.alibaba.fastjson2.JSONWriter.Feature[0]));
    HostShrinkClusterVO hostShrinkClusterVO = new HostShrinkClusterVO();
    hostShrinkClusterVO.setClusterEnvId(tdpClusterEnv.getId());
    hostShrinkClusterVO.setInnerIpKeyWords(hostExpansionShrinkQuery.getInnerIpKeyWords());
    hostShrinkClusterVO.setConfigIds(hostConfigIds);
    log.info("角色已经绑定的主机所有主机:{}", JSONObject.toJSONString(roleBindHosts, new com.alibaba.fastjson2.JSONWriter.Feature[0]));
    hostShrinkClusterVO.setHostIds((List)roleBindHosts.stream().map(TdpHost::getId).collect(Collectors.toList()));
    PageHelper.startPage(current.intValue(), size.intValue());
    List<TdpHost> hosts = this.hostDao.ListByHostShrinkClusterVO(hostShrinkClusterVO);
    hosts = HostUtil.setRackDefault(hosts);
    PageInfo<TdpHost> pageInfo = new PageInfo(hosts);
    if (CollectionUtils.isEmpty(hosts))
      return new PageVo(); 
    log.info("在页面展示的主机信息:{}", JSONObject.toJSONString(hosts, new com.alibaba.fastjson2.JSONWriter.Feature[0]));
    Map<Integer, TdpHostConfig> tdpHostConfigMap = (Map<Integer, TdpHostConfig>)configList.stream().collect(Collectors.toMap(TdpHostConfig::getId, Function.identity()));
    List<String> innerIps = (List<String>)hosts.stream().map(TdpHost::getInnerIp).collect(Collectors.toList());
    Map<String, String> runtimeStatus = this.hostRuntimeStatusHandler.getRuntimeStatus(hostExpansionShrinkQuery.getClusterEnvId(), innerIps);
    List<HostShrinkVo> hostShrinkVoList = HostShrinkVo.assemble(hosts, tdpHostConfigMap, runtimeStatus, tdpClusterEnv.getName());
    CacheUtil.BaseCache baseCache = CacheUtil.getCache(CacheTypeEnum.GUAVA);
    List<CacheUtil.SelectedHostVO> selectedHostVOList = baseCache.getCache(clusterInstanceId, componentRoleName, ClusterOperateTypeEnum.SHRINK);
    List<Integer> selectedHostIdList = (List<Integer>)selectedHostVOList.stream().map(CacheUtil.SelectedHostVO::getHostId).collect(Collectors.toList());
    hostShrinkVoList.forEach(oneHostShrinkVo -> {
          if (selectedHostIdList.contains(oneHostShrinkVo.getId()))
            oneHostShrinkVo.setHostSelectedStatus(HostSelectedStatusEnum.SELECTED.getChecked()); 
          oneHostShrinkVo.setHostRuntimeStatus((String)runtimeStatus.get(oneHostShrinkVo.getInnerIp()));
        });
    pageVo.setPageNum(current.intValue());
    pageVo.setPageSize(size.intValue());
    pageVo.setTotal(pageInfo.getTotal());
    pageVo.setSize(pageInfo.getSize());
    pageVo.setData(hostShrinkVoList);
    return pageVo;
  }
  
  @LogDisplay
  public String hostShrinkSaveClusterInstance(HostShrinkSaveReq hostShrinkSaveReq) {
    checkInstanceAuth(hostShrinkSaveReq.getClusterInstanceId());
    hostShrinkSaveReq.validate();
    Integer hostId = hostShrinkSaveReq.getHostId();
    CacheUtil.BaseCache baseCache = CacheUtil.getCache(CacheTypeEnum.GUAVA);
    List<CacheUtil.SelectedHostVO> cacheList = baseCache.getCache(hostShrinkSaveReq.getClusterInstanceId(), hostShrinkSaveReq
        .getComponentRoleName(), ClusterOperateTypeEnum.SHRINK);
    List<Integer> hostIdList = new ArrayList<>();
    Boolean promoteFlag = getListAndPromoteFlag(hostId, cacheList, hostIdList);
    List<CacheUtil.SelectedHostVO> selectedHostVOList = (List<CacheUtil.SelectedHostVO>)hostIdList.stream().map(oneHostId -> CacheUtil.SelectedHostVO.builder().hostId(oneHostId).clusterInstanceId(hostShrinkSaveReq.getClusterInstanceId()).componentRoleName(hostShrinkSaveReq.getComponentRoleName()).build()).collect(Collectors.toList());
    baseCache.writeCache(hostShrinkSaveReq.getClusterInstanceId(), hostShrinkSaveReq
        .getComponentRoleName(), ClusterOperateTypeEnum.SHRINK, selectedHostVOList);
    if (Boolean.TRUE.equals(promoteFlag))
      return "绑定成功"; 
    return "取消成功";
  }
  
  @LogDisplay
  public List<HostShrinkVo> hostShrinkGetClusterInstance(Integer clusterEnvId, Integer clusterInstanceId) {
    AuthUtil.checkEnvReadAuth(clusterEnvId);
    TdpComponentType tdpComponentType = this.componentTypeService.getComponentTypeByClusterInstanceId(clusterInstanceId);
    List<TdpComponentRole> tdpComponentRoleList = this.componentRoleService.selectComponentRole(tdpComponentType.getId());
    log.info("tdpComponentRoleList {}", tdpComponentRoleList.toString());
    CacheUtil.BaseCache baseCache = CacheUtil.getCache(CacheTypeEnum.GUAVA);
    Map<String, String> runtimeStatus = this.hostRuntimeStatusHandler.getRuntimeStatus(clusterEnvId);
    ImmutableList.Builder<HostShrinkVo> builder = ImmutableList.builder();
    tdpComponentRoleList.forEach(oneTdpComponentRole -> {
          List<CacheUtil.SelectedHostVO> selectedHostVOList = baseCache.getCache(clusterInstanceId, oneTdpComponentRole.getName(), ClusterOperateTypeEnum.SHRINK);
          log.info("oneTdpComponentRole {} selectedHostVOList {}", oneTdpComponentRole.toString(), selectedHostVOList.toString());
          List<Integer> hostIds = (List<Integer>)selectedHostVOList.stream().map(CacheUtil.SelectedHostVO::getHostId).collect(Collectors.toList());
          log.info("hostIds {}", hostIds);
          List<TdpHost> hostList = this.hostService.selectHostByIds(hostIds);
          hostList = HostUtil.setRackDefault(hostList);
          log.info("hostList {}", hostList);
          List<HostShrinkVo> hostShrinkVoList = (List<HostShrinkVo>)hostList.stream().map(()).collect(Collectors.toList());
          log.info("hostExpansionVoList {}", hostShrinkVoList);
          builder.addAll(hostShrinkVoList);
        });
    return builder.build();
  }
  
  @LogDisplay
  public ClusterInstanceConfigKeyValueVo getConfigClusterInstance(Integer clusterEnvId, Integer clusterInstanceId, String configVersion, String configGroup, String configFileName, String configFileKeyWord) {
    TdpClusterConfigVersion currentConfigVersion;
    TdpClusterConfigGroup currentConfigGroup;
    checkDeploymentMethod(clusterInstanceId);
    AuthUtil.checkEnvReadAuth(clusterEnvId);
    List<TdpClusterConfigVersion> allTdpClusterConfigVersionList = this.clusterConfigService.getAllConfigVersion(clusterInstanceId);
    log.info("allTdpClusterConfigVersionList {}", allTdpClusterConfigVersionList);
    if (CollectionUtils.isEmpty(allTdpClusterConfigVersionList))
      return ClusterInstanceConfigKeyValueVo.builder().build(); 
    List<ClusterInstanceConfigKeyValueVo.ConfigVersionAndGroup> versionAndGroupList = (List<ClusterInstanceConfigKeyValueVo.ConfigVersionAndGroup>)allTdpClusterConfigVersionList.stream().map(oneClusterConfigVersion -> {
          String currentConfigVersion = oneClusterConfigVersion.getConfigVersion();
          List<TdpClusterConfigGroup> tdpClusterConfigGroupList = this.clusterConfigService.getAllConfigGroupInVersion(oneClusterConfigVersion.getId());
          List<String> configGroupNames = (List<String>)tdpClusterConfigGroupList.stream().map(TdpClusterConfigGroup::getConfigGroupName).collect(Collectors.toList());
          List<Integer> configGroupIds = (List<Integer>)tdpClusterConfigGroupList.stream().map(TdpClusterConfigGroup::getId).collect(Collectors.toList());
          return ClusterInstanceConfigKeyValueVo.ConfigVersionAndGroup.builder().configVersion(currentConfigVersion).isOnLine(oneClusterConfigVersion.getIsOnline()).configGroupIds(configGroupIds).configGroups(configGroupNames).build();
        }).collect(Collectors.toList());
    log.info("versionAndGroupList {}", versionAndGroupList);
    Collections.reverse(versionAndGroupList);
    if (StringUtils.isEmpty(configVersion)) {
      currentConfigVersion = this.clusterConfigService.getOnlineConfigVersion(clusterInstanceId);
    } else {
      currentConfigVersion = this.clusterConfigService.getConfigVersionByVersionName(clusterInstanceId, configVersion);
    } 
    if (Objects.isNull(currentConfigVersion))
      throw new ClusterConfigException("invalid config version"); 
    if (StringUtils.isEmpty(configGroup)) {
      List<TdpClusterConfigGroup> tdpClusterConfigGroupList = this.clusterConfigService.getAllConfigGroupInVersion(currentConfigVersion.getId());
      currentConfigGroup = tdpClusterConfigGroupList.get(0);
    } else {
      currentConfigGroup = this.clusterConfigService.getConfigGroupByGroupName(currentConfigVersion.getId(), configGroup);
    } 
    List<TdpClusterConfig> tdpClusterConfigList = this.clusterConfigService.getAllConfigByConfigGroupId(currentConfigGroup.getId(), configFileKeyWord);
    log.info("tdp cluster config list {}", JsonUtil.objectToJson(tdpClusterConfigList));
    Map<String, String> fileNameAndContentMap = (Map<String, String>)tdpClusterConfigList.stream().filter(oneConfig -> Objects.nonNull(oneConfig.getFileContent())).collect(Collectors.toMap(TdpClusterConfig::getFileName, TdpClusterConfig::getFileContent));
    List<String> allConfigFileName = Lists.newArrayList(fileNameAndContentMap.keySet());
    log.info("all config file name {}", allConfigFileName);
    String configContent = "";
    TdpComponentType tdpComponentType = this.componentTypeService.getComponentTypeByClusterInstanceId(clusterInstanceId);
    if (CollectionUtils.isEmpty(allConfigFileName))
      return ClusterInstanceConfigKeyValueVo.builder()
        .clusterInstanceId(clusterInstanceId)
        .clusterType(tdpComponentType.getName())
        .configVersionAndGroups(versionAndGroupList)
        .configVersion(currentConfigVersion.getConfigVersion())
        .configGroupId(currentConfigGroup.getId())
        .configGroup(currentConfigGroup.getConfigGroupName())
        .allConfigFileName(allConfigFileName)
        .configFileName("")
        .config("")
        .build(); 
    if (StringUtils.isEmpty(configFileName)) {
      Optional<Map.Entry<String, String>> firstNameAndContentOptional = fileNameAndContentMap.entrySet().stream().findFirst();
      log.info("firstNameAndContentOptional is present {}", Boolean.valueOf(firstNameAndContentOptional.isPresent()));
      if (firstNameAndContentOptional.isPresent()) {
        configFileName = (String)((Map.Entry)firstNameAndContentOptional.get()).getKey();
        log.info("config file name {}", configFileName);
        log.info("config value {}", ((Map.Entry)firstNameAndContentOptional.get()).getValue());
        configContent = (String)((Map.Entry)firstNameAndContentOptional.get()).getValue();
      } 
    } else {
      TdpClusterConfig tdpClusterConfig = this.clusterConfigService.getConfigByConfigGroupIdAndFileName(currentConfigGroup.getId(), configFileName);
      log.info("tdpClusterConfig.getFileContent() {}", tdpClusterConfig.getFileContent());
      configContent = tdpClusterConfig.getFileContent();
    } 
    log.info("config content {}", configContent);
    return ClusterInstanceConfigKeyValueVo.builder()
      .clusterInstanceId(clusterInstanceId)
      .clusterType(tdpComponentType.getName())
      .configVersionAndGroups(versionAndGroupList)
      .configVersion(currentConfigVersion.getConfigVersion())
      .configGroupId(currentConfigGroup.getId())
      .configGroup(currentConfigGroup.getConfigGroupName())
      .allConfigFileName(allConfigFileName)
      .configFileName(configFileName)
      .config(configContent)
      .build();
  }
  
  public Boolean getVersionAndGroup(Integer clusterEnvId, Integer clusterInstanceId) {
    AuthUtil.checkEnvReadAuth(clusterEnvId);
    List<TdpClusterConfigVersion> allTdpClusterConfigVersionList = this.clusterConfigService.getAllConfigVersion(clusterInstanceId);
    log.info("allTdpClusterConfigVersionList {}", allTdpClusterConfigVersionList);
    if (CollectionUtils.isEmpty(allTdpClusterConfigVersionList))
      return Boolean.valueOf(false); 
    List<TdpClusterConfigVersion> collect = (List<TdpClusterConfigVersion>)allTdpClusterConfigVersionList.stream().filter(oneClusterConfigVersion -> "v-t".equals(oneClusterConfigVersion.getConfigVersion())).collect(Collectors.toList());
    if (CollectionUtils.isNotEmpty(collect))
      return Boolean.valueOf(true); 
    return Boolean.valueOf(false);
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public void saveConfigClusterInstance(SaveClusterInstanceConfigReq saveClusterInstanceConfigReq) {
    Integer clusterEnvId = saveClusterInstanceConfigReq.getClusterEnvId();
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE_CONFIG);
    auditLogOperateVo.setOperateContent(LogDisplayContentEnum.CONFIGUPDATE);
    auditLogOperateVo.setOperateClusterEnvId(clusterEnvId);
    auditLogOperateVo.setOperateClusterInstanceId(saveClusterInstanceConfigReq.getClusterInstanceId());
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    Integer clusterInstanceId = saveClusterInstanceConfigReq.getClusterInstanceId();
    createTemporaryVersion(clusterInstanceId);
    TdpClusterConfigVersion temporaryConfigVersion = this.clusterConfigService.getConfigVersionByVersionName(clusterInstanceId, "v-t");
    log.info("temporaryConfigVersion {}", temporaryConfigVersion);
    TdpClusterConfigGroup tdpClusterConfigGroup = this.clusterConfigService.getConfigGroupByGroupName(temporaryConfigVersion.getId(), saveClusterInstanceConfigReq
        .getConfigGroup());
    if (Objects.isNull(tdpClusterConfigGroup)) {
      String message = String.format("no config group %s", new Object[] { saveClusterInstanceConfigReq.getConfigGroup() });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    TdpClusterConfig tdpClusterConfig = this.clusterConfigService.getConfigByConfigGroupIdAndFileName(tdpClusterConfigGroup.getId(), saveClusterInstanceConfigReq
        .getConfigFileName());
    if (Objects.isNull(tdpClusterConfig)) {
      String message = String.format("no config file %s in config group %s", new Object[] { saveClusterInstanceConfigReq.getConfigFileName(), saveClusterInstanceConfigReq
            .getConfigGroup() });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    tdpClusterConfig.setFileContent(saveClusterInstanceConfigReq.getConfig());
    this.clusterConfigMapper.updateById(tdpClusterConfig);
  }
  
  private ClusterInstanceRmi updateAgentConfig(Integer clusterInstanceId, Integer configVersionId, Integer configGroupId) {
    List<TdpClusterConfigGroup> tdpClusterConfigGroupList = this.clusterConfigService.getAllConfigGroupInVersion(configVersionId);
    if (configGroupId != null)
      tdpClusterConfigGroupList = (List<TdpClusterConfigGroup>)tdpClusterConfigGroupList.stream().filter(item -> Objects.equals(configGroupId, item.getId())).collect(Collectors.toList()); 
    List<ClusterConfigFile.ConfigGroupAndHost> configDetail = (List<ClusterConfigFile.ConfigGroupAndHost>)tdpClusterConfigGroupList.stream().map(oneConfigGroup -> {
          List<TdpClusterConfig> tdpClusterConfigList = this.clusterConfigService.getConfigByGroupId(oneConfigGroup.getId());
          Map<String, Object> configFileNameAndContent = (Map<String, Object>)tdpClusterConfigList.stream().filter(()).filter(()).collect(Collectors.toMap(TdpClusterConfig::getFileName, TdpClusterConfig::getFileContent));
          List<TdpHost> tdpHostList = this.clusterConfigService.getAllConfigGroupHostByGroupId(oneConfigGroup.getId(), "");
          List<String> ipList = (List<String>)tdpHostList.stream().map(TdpHost::getInnerIp).collect(Collectors.toList());
          return ClusterConfigFile.ConfigGroupAndHost.builder().configGroup(oneConfigGroup.getConfigGroupName()).ipList(ipList).configFileNameAndContent(configFileNameAndContent).build();
        }).collect(Collectors.toList());
    ClusterConfigFile clusterConfigFile = ClusterConfigFile.builder().clusterInstanceId(clusterInstanceId).configDetail(configDetail).build();
    log.info("start update config, param is {}", JsonUtil.objectToJson(clusterConfigFile));
    ClusterInstanceRmi clusterInstanceRmi = this.rmiService.getClusterInstanceRmi(clusterInstanceId);
    log.info("get rmi client {}", clusterInstanceRmi);
    try {
      clusterInstanceRmi.updateConfig(clusterConfigFile);
    } catch (Exception exception) {
      log.error("rmi error", exception);
    } 
    return clusterInstanceRmi;
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public void publishConfigClusterInstance(PublishClusterInstanceConfigReq publishClusterInstanceConfigReq) {
    Integer clusterEnvId = publishClusterInstanceConfigReq.getClusterEnvId();
    Integer clusterInstanceId = publishClusterInstanceConfigReq.getClusterInstanceId();
    Integer configGroupId = publishClusterInstanceConfigReq.getConfigGroupId();
    checkRunStatusClusterInstance(clusterInstanceId);
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    publishConfigInstance(clusterEnvId, clusterInstanceId, configGroupId);
  }
  
  public void publishTmpConfig(ConfigPublishReq param) {
    log.info("=================================");
    log.info("===========开始发布配置====ClusterEnvDataAuthService=======");
    log.info("=================================");
    log.info("发布配置参数是：{}", param.toString());
    Integer oldHostId = param.getOldHostId();
    Integer newHostId = param.getNewHostId();
    Integer clusterInstanceId = param.getClusterInstanceId();
    ValidationException.validate(Objects.nonNull(clusterInstanceId), "clusterInstanceId 不能为空");
    TdpClusterInstance tdpClusterInstance = this.clusterInstanceDao.getById(clusterInstanceId);
    ValidationException.validate(Objects.nonNull(tdpClusterInstance), "tdpClusterInstance 查找为空");
    String configStatus = param.getConfigStatus();
    int index = configStatus.lastIndexOf("-");
    String configGroupName = configStatus.substring(index + 1);
    Integer clusterEnvId = tdpClusterInstance.getClusterEnvId();
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    checkRunStatusClusterInstance(clusterInstanceId);
    Authentication authentication = SecurityContextHolder.getContext().getAuthentication();
    String traceId = MDC.get("traceId");
    (new Thread(() -> {
          SecurityContextHolder.getContext().setAuthentication(authentication);
          MDC.put("traceId", traceId);
          try {
            this.clusterInstanceService.asyncPublish(param, oldHostId, newHostId, clusterInstanceId, configGroupName, clusterEnvId);
          } catch (Exception e) {
            log.error("异步分发配置文件报错", e);
          } 
          MDC.remove("traceId");
        })).start();
  }
  
  @Transactional
  public void asyncPublish(ConfigPublishReq param, Integer oldHostId, Integer newHostId, Integer clusterInstanceId, String configGroupName, Integer clusterEnvId) {
    log.info("开始异步发布配置");
    TdpComponentRoleInstance componentRoleInstance = this.componentRoleInstanceDao.getComponentRoleInstanceById(param.getComponentRoleInstanceId());
    List<TdpHost> hosts = this.hostDao.listByIds(Sets.newHashSet(new Integer[] { oldHostId, newHostId }));
    Map<Integer, TdpHost> hostMap = (Map<Integer, TdpHost>)hosts.stream().collect(Collectors.toMap(TdpHost::getId, Function.identity(), (e1, e2) -> e1));
    TdpHost oldHost = hostMap.get(oldHostId);
    TdpHost newHost = hostMap.get(newHostId);
    log.info("处理临时版本配置");
    this.roleMigratesService.roleMigrateHandler(newHost, oldHost, param.getRoleName(), clusterInstanceId, componentRoleInstance, "v-t", configGroupName);
    log.info("调用脚本发布配置");
    publishConfigInstance(clusterEnvId, clusterInstanceId, null);
  }
  
  private void publishConfigInstance(Integer clusterEnvId, Integer clusterInstanceId, Integer configGroupId) {
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE_CONFIG);
    auditLogOperateVo.setOperateContent(LogDisplayContentEnum.CONFIGDEPLOY);
    auditLogOperateVo.setOperateClusterEnvId(clusterEnvId);
    auditLogOperateVo.setOperateClusterInstanceId(clusterInstanceId);
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    TdpClusterConfigVersion temporaryConfigVersion = this.clusterConfigService.getTemporaryConfigVersion(clusterInstanceId);
    if (Objects.isNull(temporaryConfigVersion)) {
      String message = "not version v-t";
      log.error(message);
      throw new RuntimeException(message);
    } 
    refreshInventoryAndVars(clusterInstanceId);
    ClusterInstanceRmi clusterInstanceRmi = updateAgentConfig(clusterInstanceId, temporaryConfigVersion.getId(), configGroupId);
    TdpComponentType tdpComponentType = selectComponentTypeByClusterInstance(clusterInstanceId);
    log.info("tdpComponentType {}", tdpComponentType);
    ClusterInstanceOperateConfig clusterInstanceOperateConfig = ClusterInstanceOperateConfig.builder().clusterInstanceId(clusterInstanceId).operateType(ClusterOperateTypeEnum.UPDATE_CONFIG.getName()).componentType(tdpComponentType.getName()).ansibleCommand("").build();
    log.info("start publish task");
    TdpTask tdpTask = this.taskService.doClusterInstanceTask(config -> clusterInstanceRmi.clusterInstanceOperate(clusterInstanceOperateConfig), clusterInstanceOperateConfig);
    log.info("发布配置之后的结果是：{}", tdpTask.toString());
    if ("0".equals(tdpTask.getExitCode())) {
      publishConfigCallBackClusterInstance(clusterInstanceId);
    } else {
      log.info("发布配置失败，返回的结果是：{}", tdpTask.getExitCode());
      throw new RuntimeException("发布失败");
    } 
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public String publishConfigCallBackClusterInstance(Integer clusterInstanceId) {
    TdpClusterConfigVersion onLineConfigVersion = this.clusterConfigService.getOnlineConfigVersion(clusterInstanceId);
    log.info("onLineConfigVersion {}", onLineConfigVersion);
    onLineConfigVersion.setIsOnline(ConfigVersionOnlineEnum.OFFLINE.getOnlineStatus());
    this.clusterConfigVersionMapper.updateById(onLineConfigVersion);
    log.info("onLineConfigVersion {}", onLineConfigVersion);
    TdpClusterConfigVersion temporaryConfigVersion = this.clusterConfigService.getConfigVersionByVersionName(clusterInstanceId, "v-t");
    if (Objects.isNull(temporaryConfigVersion)) {
      String message = String.format("no version %s", new Object[] { "v-t" });
      log.info(message);
      throw new ClusterInstanceException(message);
    } 
    temporaryConfigVersion.setIsOnline(ConfigVersionOnlineEnum.ONLINE.getOnlineStatus());
    String maxVersion = this.clusterConfigService.getMaxVersion(clusterInstanceId);
    String increasedVersion = ConfigVersionUtil.increaseVersion(maxVersion);
    log.info("current max version {} increasedVersion {}", maxVersion, increasedVersion);
    temporaryConfigVersion.setConfigVersion(increasedVersion);
    this.clusterConfigVersionMapper.updateById(temporaryConfigVersion);
    log.info("temporaryConfigVersion {}", temporaryConfigVersion);
    this.clusterConfigService.createClusterConfigStatus(clusterInstanceId, temporaryConfigVersion.getId(), 
        Integer.valueOf(ConfigTakeAffectStateEnum.NOT_TAKE_AFFECT.getCode()));
    String traceId = MDC.get("traceId");
    sendConfig2Elastic(clusterInstanceId, traceId);
    return "";
  }
  
  public PageVo<TdpOperateLogDTO> getOperationHistory(Integer clusterInstanceId, Integer current, Integer size) {
    checkInstanceEnvReadAuth(clusterInstanceId);
    PageVo<TdpOperateLogDTO> pageVo = new PageVo();
    PageHelper.startPage(current.intValue(), size.intValue());
    List<TdpTask> tdpTasks = this.taskDao.listClusterById(clusterInstanceId);
    PageInfo<TdpTask> pageInfo = new PageInfo(tdpTasks);
    if (CollectionUtils.isEmpty(tdpTasks))
      return pageVo; 
    List<TdpOperateLogDTO> tdpOperateLogDTOs = new ArrayList<>();
    for (TdpTask task : tdpTasks) {
      TdpOperateLogDTO dto = new TdpOperateLogDTO();
      dto.setId(task.getId());
      if (null != task.getOperateType()) {
        String displayName = ClusterOperateTypeEnum.getByName(task.getOperateType()).getDisplayName();
        dto.setClusterOperateType(displayName);
      } else {
        dto.setClusterOperateType("未知");
      } 
      dto.setUserName(task.getUser());
      String index = TaskStatusEnum.getByName(task.getStatus()).getIndex();
      dto.setOperateStatus(index);
      dto.setCreateTime(task.getCreateTime());
      dto.setUpdateTime(task.getUpdateTime());
      tdpOperateLogDTOs.add(dto);
    } 
    pageVo.setTotal(pageInfo.getTotal());
    pageVo.setData(tdpOperateLogDTOs);
    pageVo.setPageNum(pageInfo.getPageNum());
    pageVo.setPageSize(pageInfo.getPageSize());
    pageVo.setSize(tdpOperateLogDTOs.size());
    return pageVo;
  }
  
  public List<TdpClusterInstance> queryAll() {
    List<TdpClusterInstance> tdpClusterInstances = this.clusterInstanceDao.queryAll();
    return tdpClusterInstances;
  }
  
  public BasicInformationReq basicInformation(Integer clusterInstanceId) {
    String componentType;
    TdpClusterInstance tdpClusterInstance = this.clusterInstanceDao.getById(clusterInstanceId);
    TdpComponentType tdpComponentType = this.componentTypeService.getComponentTypeByClusterInstanceId(clusterInstanceId);
    TdpComponentTypeInstance byClusterInstanceId = this.componentTypeInstanceDao.getByClusterInstanceId(clusterInstanceId);
    TdpClusterEnv tdpClusterEnv = this.clusterEnvDao.getById(tdpClusterInstance.getClusterEnvId());
    AuthUtil.checkEnvReadAuth(tdpClusterEnv.getId());
    BasicInformationReq basicInformationReq = new BasicInformationReq();
    basicInformationReq.setId(clusterInstanceId);
    basicInformationReq.setComponentTypeId(tdpComponentType.getId());
    basicInformationReq.setClusterEnvId(tdpClusterInstance.getClusterEnvId());
    basicInformationReq.setClusterEnvName(tdpClusterEnv.getName());
    basicInformationReq.setVersion(byClusterInstanceId.getComponentTypeVersion());
    basicInformationReq.setNameEn(tdpClusterInstance.getNameEn());
    basicInformationReq.setRemark(tdpClusterInstance.getRemark());
    basicInformationReq.setDeployType(tdpClusterInstance.getDeployType());
    basicInformationReq.setCreateTime(tdpClusterInstance.getCreateTime());
    basicInformationReq.setUpdateTime(tdpClusterInstance.getUpdateTime());
    String name = tdpComponentType.getName();
    basicInformationReq.setName(name);
    if (ComponentTypeEnum.JAVA.getCode().equalsIgnoreCase(name)) {
      componentType = ComponentTypeEnum.JAVA.getCode();
    } else {
      componentType = ComponentTypeEnum.BIGDATA.getCode();
    } 
    basicInformationReq.setComponentTypeCategorization(componentType);
    basicInformationReq.setShowOnline(tdpClusterInstance.getOnlineStatus());
    basicInformationReq.setUpgrade(tdpComponentType.getUpgrade());
    basicInformationReq.setMonitor(tdpClusterInstance.getMonitor());
    ClusterInstanceAndComponentTypeDTO clusterInstanceDTO = new ClusterInstanceAndComponentTypeDTO();
    clusterInstanceDTO.setInstanceStatus(tdpClusterInstance.getInstanceStatus());
    getMonitorStatus(clusterInstanceDTO, tdpClusterInstance);
    basicInformationReq.setRunningStatus(clusterInstanceDTO.getRunningStatus());
    basicInformationReq.setInstanceStatus(clusterInstanceDTO.getInstanceStatus());
    basicInformationReq.setStartTime(tdpClusterInstance.getStartTime());
    return basicInformationReq;
  }
  
  public OperationInformation operationInformation(Integer clusterInstanceId) {
    checkInstanceEnvReadAuth(clusterInstanceId);
    int dependencyCount = 0;
    TdpComponentType tdpComponentType = this.componentTypeService.getComponentTypeByClusterInstanceId(clusterInstanceId);
    Integer componentTypeId = tdpComponentType.getId();
    Set<String> dependencyNames = this.componentTypeDependenciesDao.selectByComponentTypeId(componentTypeId);
    if (CollectionUtils.isNotEmpty(dependencyNames))
      dependencyCount = dependencyNames.size(); 
    List<TdpComponentTypeInstance> componentTypeInstancesByInstance = this.componentTypeInstanceDao.getComponentTypeInstancesByInstanceId(clusterInstanceId);
    Integer componentRoleInstanceId = Integer.valueOf(0);
    if (CollectionUtils.isNotEmpty(componentTypeInstancesByInstance))
      componentRoleInstanceId = ((TdpComponentTypeInstance)componentTypeInstancesByInstance.get(0)).getId(); 
    List<TdpComponentRoleInstance> typeInstanceId = this.componentRoleInstanceDao.getByTypeInstanceId(componentRoleInstanceId);
    Set<Integer> componentRoleInstanceIds = new HashSet<>();
    List<Integer> componentRoleIds = new ArrayList<>();
    if (CollectionUtils.isNotEmpty(typeInstanceId))
      for (TdpComponentRoleInstance tdpComponentRoleInstance : typeInstanceId) {
        Integer id = tdpComponentRoleInstance.getId();
        Integer componentRoleId = tdpComponentRoleInstance.getComponentRoleId();
        componentRoleIds.add(componentRoleId);
        componentRoleInstanceIds.add(id);
      }  
    Integer clusterEnvId = this.clusterInstanceDao.getById(clusterInstanceId).getClusterEnvId();
    Set<Integer> hostIds = this.hostDetailService.getHostListByInstanceId(clusterInstanceId);
    List<TdpHost> hosts = this.hostDao.listByIdAndInnerIp(clusterEnvId, hostIds, "");
    Integer hostCount = Integer.valueOf(hosts.size());
    TdpClusterConfigVersion onlineConfigVersion = this.clusterConfigVersionDao.getOnlineConfigVersion(clusterInstanceId);
    String configVersion = "";
    if (Objects.nonNull(onlineConfigVersion))
      configVersion = onlineConfigVersion.getConfigVersion(); 
    OperationInformation operationInformation = new OperationInformation();
    operationInformation.setComponentTypeDependenciesName(dependencyNames);
    operationInformation.setComponentTypeDependenciesCount(Integer.valueOf(dependencyCount));
    operationInformation.setHostCount(hostCount);
    if (CollectionUtils.isEmpty(componentRoleIds)) {
      operationInformation.setRoleCount(Integer.valueOf(0));
    } else {
      operationInformation.setRoleCount(Integer.valueOf(componentRoleIds.size()));
    } 
    operationInformation.setConfigurationVersion(configVersion);
    return operationInformation;
  }
  
  public void clusterMonitor(MonitorClusterCommand monitorClusterCommand) throws RemoteException {
    Integer clusterEnvId = monitorClusterCommand.getClusterEnvId();
    AuthUtil.checkEnvReadAuth(clusterEnvId);
    List<TdpHost> hosts = this.hostDao.searchClusterInstanceHost(monitorClusterCommand.getClusterInstanceId());
    Set<String> hostList = (Set<String>)hosts.stream().map(TdpHost::getNodePort).collect(Collectors.toSet());
    if (monitorClusterCommand.getMonitor().booleanValue()) {
      this.monitorService.addInstance2Monitor(monitorClusterCommand.getClusterEnvId(), monitorClusterCommand.getClusterInstanceId(), hostList);
    } else {
      this.monitorService.removeInstance2Monitor(monitorClusterCommand.getClusterEnvId(), monitorClusterCommand.getClusterInstanceId(), hostList);
    } 
  }
  
  public String getOnlineConfig(Integer clusterEnvId, String innerIp, Integer clusterInstanceId, String configName) throws RemoteException {
    checkDeploymentMethod(clusterInstanceId);
    AuthUtil.checkEnvReadAuth(clusterEnvId);
    return this.clusterConfigService.getRemoteConfigContent(clusterEnvId, innerIp, configName);
  }
  
  public List<TdpHost> getHost(Integer clusterInstanceId) {
    List<TdpHost> tdpHosts = this.hostDao.searchClusterInstanceHost(clusterInstanceId);
    return tdpHosts;
  }
  
  public void fillHostNumAndRoleNum(List<ClusterInstanceAndComponentTypeDTO> result) {
    List<Integer> instanceIds = (List<Integer>)result.stream().map(ClusterInstanceAndComponentTypeDTO::getId).collect(Collectors.toList());
    List<TdpComponentTypeInstance> instanceList = this.componentTypeInstanceDao.listByClusterInstanceId(instanceIds);
    if (CollectionUtils.isEmpty(instanceList))
      return; 
    Map<Integer, TdpComponentTypeInstance> instanceMap = (Map<Integer, TdpComponentTypeInstance>)instanceList.stream().collect(Collectors.toMap(TdpComponentTypeInstance::getClusterInstanceId, Function.identity(), (e1, e2) -> e1));
    List<Integer> typeInstanceIds = (List<Integer>)instanceList.stream().map(TdpComponentTypeInstance::getId).collect(Collectors.toList());
    List<TdpComponentRoleInstance> roleInstances = this.componentRoleInstanceDao.listByTypeInstanceIds(typeInstanceIds);
    if (CollectionUtils.isEmpty(roleInstances))
      return; 
    Map<Integer, List<TdpComponentRoleInstance>> roleInstanceMap = (Map<Integer, List<TdpComponentRoleInstance>>)roleInstances.stream().collect(Collectors.groupingBy(TdpComponentRoleInstance::getComponentTypeInstanceId));
    List<Integer> roleInstanceIds = (List<Integer>)roleInstances.stream().map(TdpComponentRoleInstance::getId).collect(Collectors.toList());
    List<TdpComponentRoleInstanceHostCount> res = this.componentRoleInstanceHostDao.countByRoleInstanceId(roleInstanceIds);
    if (CollectionUtils.isEmpty(res))
      return; 
    Map<Integer, TdpComponentRoleInstanceHostCount> hostNumMap = (Map<Integer, TdpComponentRoleInstanceHostCount>)res.stream().collect(Collectors.toMap(TdpComponentRoleInstanceHostCount::getComponentRoleInstanceId, Function.identity(), (e1, e2) -> e1));
    for (ClusterInstanceAndComponentTypeDTO dto : result) {
      TdpComponentTypeInstance componentTypeInstance = instanceMap.get(dto.getId());
      if (componentTypeInstance == null)
        continue; 
      List<TdpComponentRoleInstance> roleInstanceList = roleInstanceMap.get(componentTypeInstance.getId());
      if (CollectionUtils.isEmpty(roleInstanceList)) {
        dto.setRoleNum(Integer.valueOf(0));
      } else {
        dto.setRoleNum(Integer.valueOf(roleInstanceList.size()));
      } 
      int hostNum = 0;
      if (CollectionUtils.isNotEmpty(roleInstanceList))
        for (TdpComponentRoleInstance tdpComponentRoleInstance : roleInstanceList) {
          TdpComponentRoleInstanceHostCount instanceHost = hostNumMap.get(tdpComponentRoleInstance.getId());
          if (Objects.nonNull(instanceHost))
            hostNum += instanceHost.getCount().intValue(); 
        }  
      dto.setHostNum(Integer.valueOf(hostNum));
    } 
  }
  
  private void sendConfig2Elastic(Integer clusterInstanceId, String traceId) {
    (new Thread(() -> {
          MDC.put("traceId", traceId);
          log.info("开始将 {} 集群的配置信息同步到弹性计算服务", clusterInstanceId);
          String url = getEcUrl(clusterInstanceId) + "/api/v1/cluster/service";
          try {
            List<TdpClusterConfig> configList = this.clusterConfigService.getConfigList(clusterInstanceId);
            if (CollectionUtils.isEmpty(configList)) {
              log.error("同步配置到弹性计算服务失败：获取的配置列表为空");
              return;
            } 
            Map<String, String> configMap = new HashMap<>();
            for (TdpClusterConfig tdpClusterConfig : configList)
              configMap.put(tdpClusterConfig.getFileName(), tdpClusterConfig.getFileContent()); 
            Map<String, Object> param = new HashMap<>();
            param.put("cluster_id", clusterInstanceId + "");
            param.put("file", configMap);
            this.httpClient.doPost(url, param);
          } catch (Exception e) {
            log.error("同步配置到弹性计算服务失败:", e);
          } 
          MDC.remove("traceId");
        })).start();
  }
  
  private String getEcUrl(Integer ecInstanceId) {
    TdpComponentTypeInstance byClusterInstanceId = this.componentTypeInstanceDao.getByClusterInstanceId(ecInstanceId);
    String ecUrl = VarsUtil.getVarsValue(byClusterInstanceId.getVars(), "ec_url");
    ValidationException.validate(StringUtils.isBlank(ecUrl), "vars模板未指定ec_url");
    return ecUrl;
  }
  
  public boolean rollBackConfigClusterCheckInstance(RollBackClusterInstanceConfigCheckReq rollBackClusterInstanceConfigCheckReq) {
    Integer clusterEnvId = rollBackClusterInstanceConfigCheckReq.getClusterEnvId();
    Integer clusterInstanceId = rollBackClusterInstanceConfigCheckReq.getClusterInstanceId();
    AuthUtil.checkEnvOperateAuth(clusterEnvId);
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE_CONFIG);
    auditLogOperateVo.setOperateContent(LogDisplayContentEnum.CONFIGROLL);
    auditLogOperateVo.setOperateClusterEnvId(clusterEnvId);
    auditLogOperateVo.setOperateClusterInstanceId(clusterInstanceId);
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    String targetVersionName = rollBackClusterInstanceConfigCheckReq.getConfigVersion();
    if (targetVersionName.isEmpty()) {
      log.error("未获取到版本信息");
      throw new ClusterInstanceException("未获取到版本信息");
    } 
    TdpClusterConfigVersion onlineConfigVersion = this.clusterConfigService.getOnlineConfigVersion(clusterInstanceId);
    log.info("onlineConfigVersion {}", JsonUtil.objectToJson(onlineConfigVersion));
    List<TdpClusterConfigGroupHost> onlineVersionHostList = this.clusterConfigService.getClusterConfigVersionAllHost(onlineConfigVersion.getId());
    log.info("onlineVersionHostList {}", JsonUtil.objectToJson(onlineVersionHostList));
    TdpClusterConfigVersion targetConfigVersion = this.clusterConfigService.getConfigVersionByVersionName(clusterInstanceId, targetVersionName);
    log.info("targetConfigVersion {}", JsonUtil.objectToJson(targetConfigVersion));
    List<TdpClusterConfigGroupHost> targetVersionHostList = this.clusterConfigService.getClusterConfigVersionAllHost(targetConfigVersion.getId());
    log.info("targetVersionHostList {}", JsonUtil.objectToJson(targetVersionHostList));
    Set<Integer> temporaryVersionHostSet = (Set<Integer>)onlineVersionHostList.stream().map(TdpClusterConfigGroupHost::getHostId).collect(Collectors.toSet());
    Set<Integer> targetVersionHostSet = (Set<Integer>)targetVersionHostList.stream().map(TdpClusterConfigGroupHost::getHostId).collect(Collectors.toSet());
    Set<Integer> setView1 = Sets.difference(temporaryVersionHostSet, targetVersionHostSet);
    Set<Integer> setView2 = Sets.difference(targetVersionHostSet, temporaryVersionHostSet);
    Set<Integer> interSectionSet = Sets.intersection(temporaryVersionHostSet, targetVersionHostSet);
    return (Objects.equals(Integer.valueOf(interSectionSet.size()), Integer.valueOf(temporaryVersionHostSet.size())) && 
      Objects.equals(Integer.valueOf(interSectionSet.size()), Integer.valueOf(targetVersionHostSet.size())) && 
      CollectionUtils.isEmpty(setView1) && CollectionUtils.isEmpty(setView2));
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public void rollBackConfigClusterInstance(RollBackClusterInstanceConfigReq rollBackClusterInstanceConfigReq) {
    Integer clusterEvnId = rollBackClusterInstanceConfigReq.getClusterEnvId();
    Integer clusterInstanceId = rollBackClusterInstanceConfigReq.getClusterInstanceId();
    AuthUtil.checkEnvOperateAuth(clusterEvnId);
    AuditLogOperateVo auditLogOperateVo = new AuditLogOperateVo();
    auditLogOperateVo.setOperateType(LogDisplayEnum.CLUSTER_MANAGE_CONFIG);
    auditLogOperateVo.setOperateContent(LogDisplayContentEnum.CONFIGROLL);
    auditLogOperateVo.setOperateClusterEnvId(clusterEvnId);
    auditLogOperateVo.setOperateClusterInstanceId(clusterInstanceId);
    this.auditLogService.auditLogMethod(System.currentTimeMillis(), auditLogOperateVo);
    String configVersion = rollBackClusterInstanceConfigReq.getConfigVersion();
    TdpClusterConfigVersion tdpClusterConfigVersion = this.clusterConfigService.getConfigVersionByVersionName(clusterInstanceId, configVersion);
    ClusterInstanceRmi clusterInstanceRmi = updateAgentConfig(clusterInstanceId, tdpClusterConfigVersion.getId(), rollBackClusterInstanceConfigReq.getConfigGroupId());
    TdpComponentType tdpComponentType = selectComponentTypeByClusterInstance(clusterInstanceId);
    ClusterInstanceOperateConfig clusterInstanceOperateConfig = ClusterInstanceOperateConfig.builder().clusterInstanceId(clusterInstanceId).operateType(ClusterOperateTypeEnum.UPDATE_CONFIG.getName()).componentType(tdpComponentType.getName()).ansibleCommand("").build();
    log.info("start roll back task");
    this.taskService.doClusterInstanceTask(config -> clusterInstanceRmi.clusterInstanceOperate(clusterInstanceOperateConfig), clusterInstanceOperateConfig, this::rollBackConfigCallBackClusterInstance, 
        ImmutablePair.of(clusterInstanceId, configVersion));
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public String rollBackConfigCallBackClusterInstance(ImmutablePair<Integer, String> clusterInstanceIdAndVersion) {
    Integer clusterInstanceId = (Integer)clusterInstanceIdAndVersion.left;
    checkInstanceAuth(clusterInstanceId);
    String configVersion = (String)clusterInstanceIdAndVersion.right;
    TdpClusterConfigVersion tdpClusterConfigVersion = this.clusterConfigService.getConfigVersionByVersionName(clusterInstanceId, configVersion);
    if (Objects.isNull(tdpClusterConfigVersion)) {
      String message = String.format("no config version %s", new Object[] { configVersion });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    if (Objects.equals(tdpClusterConfigVersion.getIsOnline(), ConfigVersionOnlineEnum.ONLINE.getOnlineStatus())) {
      String message = String.format("config version %s is on line, can not rollback", new Object[] { configVersion });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    TdpClusterConfigVersion onLineConfigVersion = this.clusterConfigService.getOnlineConfigVersion(clusterInstanceId);
    onLineConfigVersion.setIsOnline(ConfigVersionOnlineEnum.OFFLINE.getOnlineStatus());
    this.clusterConfigVersionMapper.updateById(onLineConfigVersion);
    tdpClusterConfigVersion.setIsOnline(ConfigVersionOnlineEnum.OFFLINE.getOnlineStatus());
    tdpClusterConfigVersion.setUpdateTime(new Date());
    this.clusterConfigVersionMapper.updateById(tdpClusterConfigVersion);
    TdpClusterConfigVersion newTdpClusterConfigVersion = new TdpClusterConfigVersion();
    String maxConfigVersion = this.clusterConfigService.getMaxVersion(clusterInstanceId);
    log.info("get max config version {}", maxConfigVersion);
    newTdpClusterConfigVersion.setConfigVersion(ConfigVersionUtil.increaseVersion(maxConfigVersion));
    newTdpClusterConfigVersion.setIsOnline(ConfigVersionOnlineEnum.ONLINE.getOnlineStatus());
    newTdpClusterConfigVersion.setCreateTime(new Date());
    newTdpClusterConfigVersion.setUpdateTime(new Date());
    newTdpClusterConfigVersion.setClusterInstanceId(clusterInstanceId);
    this.clusterConfigVersionMapper.save(newTdpClusterConfigVersion);
    List<TdpClusterConfigGroup> tdpClusterConfigGroupList = this.clusterConfigService.getAllConfigGroupInVersion(tdpClusterConfigVersion.getId());
    tdpClusterConfigGroupList.forEach(oneClusterConfigGroup -> {
          TdpClusterConfigGroup newTdpClusterConfigGroup = new TdpClusterConfigGroup();
          BeanUtils.copyProperties(oneClusterConfigGroup, newTdpClusterConfigGroup);
          newTdpClusterConfigGroup.setId(null);
          newTdpClusterConfigGroup.setConfigVersionId(newTdpClusterConfigVersion.getId());
          newTdpClusterConfigGroup.setCreateTime(new Date());
          newTdpClusterConfigGroup.setUpdateTime(new Date());
          this.clusterConfigGroupMapper.save(newTdpClusterConfigGroup);
          List<TdpClusterConfig> tdpClusterConfigList = this.clusterConfigService.getAllConfigByConfigGroupId(oneClusterConfigGroup.getId(), "");
          tdpClusterConfigList.forEach(());
          List<TdpClusterConfigGroupHost> tdpClusterConfigGroupHostList = this.clusterConfigService.getAllConfigGroupAndHostByGroupId(oneClusterConfigGroup.getId());
          tdpClusterConfigGroupHostList.forEach(());
        });
    deleteTemporaryVersion(clusterInstanceId);
    this.clusterConfigService.createClusterConfigStatus(clusterInstanceId, newTdpClusterConfigVersion.getId(), 
        Integer.valueOf(ConfigTakeAffectStateEnum.NOT_TAKE_AFFECT.getCode()));
    return "";
  }
  
  @LogDisplay
  public List<ClusterInstanceConfigGroupVo> listConfigGroupClusterInstance(Integer clusterInstanceId, String configGroupName) {
    checkInstanceEnvReadAuth(clusterInstanceId);
    TdpClusterConfigVersion temporaryVersion = this.clusterConfigService.getTemporaryConfigVersion(clusterInstanceId);
    if (Objects.nonNull(temporaryVersion))
      return getClusterInstanceConfigGroupVos(configGroupName, temporaryVersion); 
    TdpClusterConfigVersion onLineConfigVersion = this.clusterConfigService.getOnlineConfigVersion(clusterInstanceId);
    if (Objects.isNull(onLineConfigVersion)) {
      log.error("no online config version");
      throw new ClusterInstanceException("no online config version");
    } 
    return getClusterInstanceConfigGroupVos(configGroupName, onLineConfigVersion);
  }
  
  private List<ClusterInstanceConfigGroupVo> getClusterInstanceConfigGroupVos(String configGroupName, TdpClusterConfigVersion configVersion) {
    log.info("Method getClusterInstanceConfigGroupVos paramater:{},{}", configGroupName, configVersion);
    if (Objects.isNull(configVersion))
      return new ArrayList<>(); 
    List<TdpClusterConfigGroup> clusterConfigGroups = getTdpClusterConfigGroups(configGroupName, configVersion);
    if (CollectionUtils.isEmpty(clusterConfigGroups))
      return new ArrayList<>(); 
    List<Integer> clusterConfigGroupIds = (List<Integer>)clusterConfigGroups.stream().map(TdpClusterConfigGroup::getId).collect(Collectors.toList());
    List<TdpClusterConfigGroupHost> configGroupHosts = this.clusterConfigGroupHostDao.selectByConfigGroupIds(clusterConfigGroupIds);
    log.info("clusterConfigGroupHost type :{}", JSONObject.toJSONString(configGroupHosts, new com.alibaba.fastjson2.JSONWriter.Feature[0]));
    Map<Integer, List<TdpClusterConfigGroupHost>> collect = (Map<Integer, List<TdpClusterConfigGroupHost>>)configGroupHosts.stream().collect(Collectors.groupingBy(TdpClusterConfigGroupHost::getConfigGroupId));
    Map<Integer, List<TdpHost>> hostFilterByRunnTimeStatusMap = new HashMap<>();
    collect.forEach((key, tdpClusterConfigGroupHosts) -> {
          Set<Integer> hostIdSets = (Set<Integer>)tdpClusterConfigGroupHosts.stream().map(TdpClusterConfigGroupHost::getHostId).collect(Collectors.toSet());
          List<TdpHost> tdpHosts = this.hostDao.listByIds(hostIdSets);
          hostFilterByRunnTimeStatusMap.put(key, tdpHosts);
        });
    return ClusterInstanceConfigGroupVo.assamble(clusterConfigGroups, hostFilterByRunnTimeStatusMap);
  }
  
  private List<TdpClusterConfigGroup> getTdpClusterConfigGroups(String configGroupName, TdpClusterConfigVersion configVersion) {
    LambdaQueryWrapper<TdpClusterConfigGroup> wrapper = new LambdaQueryWrapper();
    if (StringUtils.isNotBlank(configGroupName))
      wrapper.eq(TdpClusterConfigGroup::getConfigGroupName, configGroupName); 
    wrapper.eq(TdpClusterConfigGroup::getConfigVersionId, configVersion.getId());
    List<TdpClusterConfigGroup> clusterConfigGroups = this.clusterConfigGroupDao.query(wrapper);
    return clusterConfigGroups;
  }
  
  @LogDisplay
  public List<ClusterInstanceConfigGroupHostVo> listConfigGroupHostsClusterInstance(Integer configGroupId, String ip) {
    TdpClusterConfigGroup tdpClusterConfigGroup = this.clusterConfigService.getConfigGroupByConfigGroupId(configGroupId);
    if (Objects.isNull(tdpClusterConfigGroup)) {
      String message = String.format("no config group %s", new Object[] { configGroupId });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    List<TdpHost> tdpHostList = this.clusterConfigService.getAllConfigGroupHostByGroupId(configGroupId, ip);
    if (CollectionUtils.isNotEmpty(tdpHostList)) {
      TdpHost tdpHost = tdpHostList.get(0);
      AuthUtil.checkEnvOperateAuth(tdpHost.getClusterEnvId());
    } 
    return (List<ClusterInstanceConfigGroupHostVo>)tdpHostList.stream().map(oneHost -> ClusterInstanceConfigGroupHostVo.builder().id(oneHost.getId()).hostName(oneHost.getHostName()).ip(oneHost.getInnerIp()).configGroup(tdpClusterConfigGroup.getConfigGroupName()).build())




      
      .collect(Collectors.toList());
  }
  
  private List<TdpHost> getTdpHostsFilterByRunnTimeStatus(List<TdpHost> tdpHostList) {
    Map<Integer, List<TdpHost>> collect = (Map<Integer, List<TdpHost>>)tdpHostList.stream().collect(Collectors.groupingBy(TdpHost::getClusterEnvId));
    List<TdpHost> tdpHostList1 = Lists.newArrayList();
    collect.forEach((envId, tdpHosts) -> {
          Map<String, String> runtimeStatus = this.hostRuntimeStatusHandler.getRuntimeStatus(envId);
          if (!runtimeStatus.isEmpty()) {
            List<TdpHost> hosts = (List<TdpHost>)tdpHosts.stream().filter(()).collect(Collectors.toList());
            tdpHostList1.addAll(hosts);
          } 
        });
    return tdpHostList1;
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public void addConfigGroupClusterInstance(AddConfigGroupClusterInstanceReq addConfigGroupClusterInstanceReq) {
    Integer clusterInstanceId = addConfigGroupClusterInstanceReq.getClusterInstanceId();
    checkInstanceAuth(clusterInstanceId);
    TdpClusterConfigVersion temporaryConfigVersion = createTemporaryVersion(clusterInstanceId);
    String baseConfigGroup = addConfigGroupClusterInstanceReq.getBaseConfigGroup();
    TdpClusterConfigGroup baseClusterConfigGroup = this.clusterConfigService.getConfigGroupByGroupName(temporaryConfigVersion.getId(), baseConfigGroup);
    if (Objects.isNull(baseClusterConfigGroup)) {
      String message = String.format("config group %s not exist", new Object[] { baseConfigGroup });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    List<TdpClusterConfigGroup> tdpClusterConfigGroupList = this.clusterConfigService.getAllConfigGroupInVersion(temporaryConfigVersion.getId());
    List<String> configGroupNameList = (List<String>)tdpClusterConfigGroupList.stream().map(TdpClusterConfigGroup::getConfigGroupName).collect(Collectors.toList());
    String configGroupName = addConfigGroupClusterInstanceReq.getConfigGroupName();
    if (configGroupNameList.contains(configGroupName)) {
      String message = String.format("config group %s exist", new Object[] { configGroupName });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    TdpClusterConfigGroup newClusterConfigGroup = new TdpClusterConfigGroup();
    newClusterConfigGroup.setConfigVersionId(temporaryConfigVersion.getId());
    newClusterConfigGroup.setConfigGroupName(addConfigGroupClusterInstanceReq.getConfigGroupName());
    newClusterConfigGroup.setCreateTime(new Date());
    newClusterConfigGroup.setUpdateTime(new Date());
    this.clusterConfigGroupMapper.save(newClusterConfigGroup);
    List<TdpClusterConfig> baseConfigList = this.clusterConfigService.getAllConfigByConfigGroupId(baseClusterConfigGroup.getId(), "");
    baseConfigList.forEach(oneBaseConfig -> {
          TdpClusterConfig newClusterConfig = new TdpClusterConfig();
          BeanUtils.copyProperties(oneBaseConfig, newClusterConfig);
          newClusterConfig.setId(null);
          newClusterConfig.setConfigGroupId(newClusterConfigGroup.getId());
          newClusterConfig.setCreateTime(new Date());
          newClusterConfig.setUpdateTime(new Date());
          this.clusterConfigMapper.save(newClusterConfig);
        });
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public void renameConfigGroupClusterInstance(RenameConfigGroupClusterInstanceReq renameConfigGroupClusterInstanceReq) {
    Integer clusterInstanceId = renameConfigGroupClusterInstanceReq.getClusterInstanceId();
    checkInstanceAuth(clusterInstanceId);
    TdpClusterConfigVersion temporaryConfigVersion = createTemporaryVersion(clusterInstanceId);
    TdpClusterConfigGroup tdpClusterConfigGroup = this.clusterConfigService.getConfigGroupByGroupName(temporaryConfigVersion.getId(), renameConfigGroupClusterInstanceReq
        .getSourceConfigGroupName());
    if (Objects.isNull(tdpClusterConfigGroup)) {
      String message = String.format("config group %s not exists", new Object[] { renameConfigGroupClusterInstanceReq.getSourceConfigGroupName() });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    tdpClusterConfigGroup.setConfigGroupName(renameConfigGroupClusterInstanceReq.getTargetConfigGroupName());
    this.clusterConfigGroupMapper.updateById(tdpClusterConfigGroup);
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public void deleteConfigGroupClusterInstance(DeleteConfigGroupClusterInstanceReq deleteConfigGroupClusterInstanceReq) {
    Integer clusterInstanceId = deleteConfigGroupClusterInstanceReq.getClusterInstanceId();
    TdpClusterConfigVersion temporaryConfigVersion = createTemporaryVersion(clusterInstanceId);
    checkInstanceAuth(clusterInstanceId);
    TdpClusterConfigGroup tdpClusterConfigGroup = this.clusterConfigService.getConfigGroupByGroupName(temporaryConfigVersion.getId(), deleteConfigGroupClusterInstanceReq
        .getGroupName());
    if (Objects.isNull(tdpClusterConfigGroup)) {
      String message = String.format("config group %s not exists", new Object[] { deleteConfigGroupClusterInstanceReq.getGroupName() });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    List<TdpClusterConfig> tdpClusterConfigList = this.clusterConfigService.getAllConfigByConfigGroupId(tdpClusterConfigGroup.getId(), "");
    tdpClusterConfigList.forEach(oneConfig -> this.clusterConfigMapper.removeById(oneConfig));
    List<TdpClusterConfigGroupHost> tdpClusterConfigGroupHosts = this.clusterConfigService.getAllConfigGroupAndHostByGroupId(tdpClusterConfigGroup.getId());
    tdpClusterConfigGroupHosts.forEach(oneConfigGroupHost -> this.clusterConfigGroupHostMapper.removeById(oneConfigGroupHost.getId()));
    this.clusterConfigGroupMapper.removeById(tdpClusterConfigGroup);
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public void transformConfigGroupClusterInstance(TransformConfigGroupClusterInstanceReq transformConfigGroupClusterInstanceReq) {
    Integer clusterInstanceId = transformConfigGroupClusterInstanceReq.getClusterInstanceId();
    checkInstanceAuth(clusterInstanceId);
    String sourceConfigGroupName = transformConfigGroupClusterInstanceReq.getSourceConfigGroupName();
    String targetConfigGroupName = transformConfigGroupClusterInstanceReq.getTargetConfigGroupName();
    List<Integer> hostIds = transformConfigGroupClusterInstanceReq.getHostIds();
    TdpClusterConfigVersion temporaryConfigVersion = createTemporaryVersion(clusterInstanceId);
    TdpClusterConfigGroup sourceConfigGroup = this.clusterConfigService.getConfigGroupByGroupName(temporaryConfigVersion.getId(), sourceConfigGroupName);
    if (Objects.isNull(sourceConfigGroup)) {
      String message = String.format("no config version %s", new Object[] { sourceConfigGroupName });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    List<TdpClusterConfigGroupHost> tdpClusterConfigGroupHostList = this.clusterConfigService.getConfigGroupAndHostByGroupId(sourceConfigGroup.getId(), hostIds);
    tdpClusterConfigGroupHostList.forEach(oneConfigGroupAndHost -> this.clusterConfigGroupHostMapper.removeById(oneConfigGroupAndHost));
    TdpClusterConfigGroup targetConfigGroup = this.clusterConfigService.getConfigGroupByGroupName(temporaryConfigVersion.getId(), targetConfigGroupName);
    if (Objects.isNull(targetConfigGroup)) {
      String message = String.format("no config version %s", new Object[] { targetConfigGroupName });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    hostIds.forEach(oneHostId -> {
          LambdaQueryWrapper<TdpClusterConfigGroupHost> wrapper = new LambdaQueryWrapper();
          wrapper.eq(TdpClusterConfigGroupHost::getConfigGroupId, targetConfigGroup.getId());
          wrapper.eq(TdpClusterConfigGroupHost::getHostId, oneHostId);
          List<TdpClusterConfigGroupHost> tdpClusterConfigGroupHosts = this.clusterConfigGroupHostMapper.list((Wrapper)wrapper);
          if (CollectionUtils.isNotEmpty(tdpClusterConfigGroupHosts))
            return; 
          TdpClusterConfigGroupHost tdpClusterConfigGroupHost = new TdpClusterConfigGroupHost();
          tdpClusterConfigGroupHost.setConfigGroupId(targetConfigGroup.getId());
          tdpClusterConfigGroupHost.setHostId(oneHostId);
          tdpClusterConfigGroupHost.setCreateTime(new Date());
          tdpClusterConfigGroupHost.setUpdateTime(new Date());
          this.clusterConfigGroupHostMapper.save(tdpClusterConfigGroupHost);
        });
  }
  
  @Transactional(isolation = Isolation.REPEATABLE_READ, rollbackFor = {Exception.class})
  @LogDisplay
  public void deleteConfigClusterInstance(DeleteClusterInstanceConfigReq deleteClusterInstanceConfigReq) {
    checkInstanceAuth(deleteClusterInstanceConfigReq.getClusterInstanceId());
    this.clusterConfigService.deleteInstanceConfig(deleteClusterInstanceConfigReq.getClusterInstanceId());
  }
  
  private void checkHostListExist(List<Integer> hostIdList) {
    hostIdList.forEach(hostId -> {
          boolean isExists = this.hostService.checkExistById(hostId);
          if (!isExists) {
            String message = String.format("主机id %s 不存在", new Object[] { hostId });
            log.error(message);
            throw new HostException(message);
          } 
        });
  }
  
  private void checkClusterInstanceIdExist(Integer clusterInstanceId) {
    boolean isExists = this.hostService.checkExistById(clusterInstanceId);
    if (!isExists) {
      String message = String.format("主机id %s 不存在", new Object[] { clusterInstanceId });
      log.error(message);
      throw new HostException(message);
    } 
  }
  
  private void checkHostExist(Integer hostId) {
    boolean isExists = this.hostService.checkExistById(hostId);
    if (!isExists) {
      String message = String.format("主机id %s 不存在", new Object[] { hostId });
      log.error(message);
      throw new HostException(message);
    } 
  }
  
  private void checkRoleIdExist(Set<Integer> componentRoleIds) {
    componentRoleIds.forEach(componentRoleId -> {
          boolean isExists = this.componentRoleService.isExists(componentRoleId);
          if (!isExists) {
            String message = String.format("组件角色id %s 不存在", new Object[] { componentRoleId });
            log.error(message);
            throw new HostException(message);
          } 
        });
  }
  
  private void checkComponentRoleIdExist(Integer componentRoleId) {
    boolean isExist = this.componentRoleService.isExists(componentRoleId);
    if (!isExist) {
      String message = String.format("组件角色 %s 不存在", new Object[] { componentRoleId });
      log.error(message);
      throw new ComponentRoleException(message);
    } 
  }
  
  private void checkComponentRoleIdListExist(List<Integer> componentRoleIdList) {
    componentRoleIdList.forEach(componentRoleId -> {
          boolean isExist = this.componentRoleService.isExists(componentRoleId);
          if (!isExist) {
            String message = String.format("组件角色 %s 不存在", new Object[] { componentRoleId });
            log.error(message);
            throw new ComponentRoleException(message);
          } 
        });
  }
  
  public TdpClusterConfigVersion createTemporaryVersion(Integer clusterInstanceId) {
    TdpClusterConfigVersion tdpClusterConfigVersion;
    List<TdpClusterConfigVersion> allConfigVersion = this.clusterConfigService.getAllConfigVersion(clusterInstanceId);
    log.info("获取所有的配置文件");
    if (CollectionUtils.isEmpty(allConfigVersion)) {
      String message = String.format("no config version in instance %s", new Object[] { clusterInstanceId });
      log.error(message);
      throw new ClusterInstanceException(message);
    } 
    List<String> allConfigVersionName = (List<String>)allConfigVersion.stream().map(TdpClusterConfigVersion::getConfigVersion).collect(Collectors.toList());
    if (!allConfigVersionName.contains("v-t")) {
      log.info("不存在临时配置，开始创建");
      TdpClusterConfigVersion onLineVersion = this.clusterConfigService.getOnlineConfigVersion(clusterInstanceId);
      tdpClusterConfigVersion = configVersionCopy(clusterInstanceId, onLineVersion.getConfigVersion(), "v-t");
    } else {
      log.info("存在临时版本，开始过滤");
      tdpClusterConfigVersion = (TdpClusterConfigVersion)allConfigVersion.stream().filter(configVersion -> StringUtils.equalsAnyIgnoreCase("v-t", new CharSequence[] { configVersion.getConfigVersion() })).findAny().orElseThrow(() -> new ClusterInstanceException("no online config version"));
    } 
    log.info("创建临时版本配置结束");
    return tdpClusterConfigVersion;
  }
  
  public void deleteTemporaryVersion(Integer clusterInstanceId) {
    checkInstanceAuth(clusterInstanceId);
    TdpClusterConfigVersion temporaryConfigVersion = this.clusterConfigService.getTemporaryConfigVersion(clusterInstanceId);
    if (Objects.nonNull(temporaryConfigVersion))
      this.clusterConfigService.deleteConfigVersion(temporaryConfigVersion.getId()); 
  }
  
  private TdpClusterConfigVersion configVersionCopy(Integer clusterInstanceId, String sourceVersionName, String targetVersionName) {
    checkInstanceAuth(clusterInstanceId);
    log.info("1、拷贝版本数据");
    TdpClusterConfigVersion sourceConfigVersion = this.clusterConfigService.getConfigVersionByVersionName(clusterInstanceId, sourceVersionName);
    TdpClusterConfigVersion targetConfigVersion = new TdpClusterConfigVersion();
    BeanUtils.copyProperties(sourceConfigVersion, targetConfigVersion);
    targetConfigVersion.setId(null);
    targetConfigVersion.setIsOnline(ConfigVersionOnlineEnum.OFFLINE.getOnlineStatus());
    targetConfigVersion.setCreateTime(new Date());
    targetConfigVersion.setUpdateTime(new Date());
    targetConfigVersion.setConfigVersion(targetVersionName);
    this.clusterConfigVersionMapper.save(targetConfigVersion);
    log.info("2、拷贝配置组数据");
    List<TdpClusterConfigGroup> sourceConfigGroupList = this.clusterConfigService.getAllConfigGroupInVersion(sourceConfigVersion.getId());
    sourceConfigGroupList.forEach(sourceConfigGroup -> {
          TdpClusterConfigGroup targetConfigGroup = new TdpClusterConfigGroup();
          BeanUtils.copyProperties(sourceConfigGroup, targetConfigGroup);
          targetConfigGroup.setId(null);
          targetConfigGroup.setCreateTime(new Date());
          targetConfigGroup.setUpdateTime(new Date());
          targetConfigGroup.setConfigVersionId(targetConfigVersion.getId());
          this.clusterConfigGroupMapper.save(targetConfigGroup);
          log.info("2.1、拷贝配置文件数据");
          List<TdpClusterConfig> sourceConfigList = this.clusterConfigService.getAllConfigByConfigGroupId(sourceConfigGroup.getId(), "");
          sourceConfigList.forEach(());
          log.info("2.2、拷贝配置组与机器映射数据");
          List<TdpClusterConfigGroupHost> sourceConfigGroupHostList = this.clusterConfigService.getAllConfigGroupAndHostByGroupId(sourceConfigGroup.getId());
          sourceConfigGroupHostList.forEach(());
        });
    return targetConfigVersion;
  }
}
